
var curation = {
	file: null,
	group: null,
	pages: [],
	step: 1
};

var curationWizardEnabled = false;

function initCurationWizard()
{
	curationWizardEnabled = true;
	curation.file = tree.createCurationFile({}, true);
	curation.group = tree.createCurationGroup({ parent: curation.file.guid }, true);
	curationStep1();
}

function curationNext()
{
	for (var i in props)
		if (props.hasOwnProperty(i))
		{
			if (props[i].editable && currentNode.hasOwnProperty(i))
			{
				currentNode[i] = props[i].getValue();
			}
		}
	if(curation.step == 1)
	{
		curationStep2();
	} else if(curation.step == 2)
	{
		curationStep3();
	}
}

function curationPrev()
{
	for (var i in props)
		if (props.hasOwnProperty(i))
		{
			if (props[i].editable && currentNode.hasOwnProperty(i))
			{
				currentNode[i] = props[i].getValue();
			}
		}
	if(curation.step == 2)
	{
		curationStep1();
	}
}

function curationAddPage()
{
	for (var i in props)
		if (props.hasOwnProperty(i))
		{
			if (props[i].editable && currentNode.hasOwnProperty(i))
			{
				currentNode[i] = props[i].getValue();
			}
		}
	var page = tree.createCurationPage({
		parent: curation.group.guid
	}, true);
	currentNode = page;
	curation.pages.push(page);
	populateFields(page);
	document.getElementById('comm-saveUnder').removeAttribute('checked');
	document.getElementById('row-page_url').hidden = true;
	document.getElementById('comm-saveUnder').hidden = true;
}

function curationStep1()
{
	curation.step = 1;
	currentNode = curation.file;
	populateFields(curation.file);
	document.getElementById('prev-button').hidden = true;
	document.getElementById('next-button').hidden = false;
	document.getElementById('addpage-button').hidden = true;
	document.getElementById('save-button').hidden = true;
	document.getElementById('row-exportfile').hidden = true;
}

function curationStep2()
{
	curation.step = 2;
	currentNode = curation.group;
	populateFields(curation.group);
	document.getElementById('prev-button').hidden = false;
	document.getElementById('next-button').hidden = false;
	document.getElementById('addpage-button').hidden = true;
	document.getElementById('save-button').hidden = true;
}

function curationStep3()
{
	curation.step = 3;
	currentNode = tree.createCurationPage({
		parent: curation.group.guid
	}, true);
	curation.pages.push(currentNode);
	populateFields(currentNode);
	document.getElementById('comm-saveUnder').removeAttribute('checked');
	document.getElementById('row-page_url').hidden = true;
	document.getElementById('comm-saveUnder').hidden = true;
	document.getElementById('prev-button').hidden = true;
	document.getElementById('next-button').hidden = true;
	document.getElementById('save-button').hidden = false;
	document.getElementById('addpage-button').hidden = false;
}

function curationSave()
{
	console.log(curation);
	tree.addNode(curation.file);
	tree.addNode(curation.group);
	var includeLastPage = !document.getElementById('addpage-button').disabled;
	if(includeLastPage)
	{
		for (var i in props)
			if (props.hasOwnProperty(i))
			{
				if (props[i].editable && currentNode.hasOwnProperty(i))
				{
					currentNode[i] = props[i].getValue();
				}
			}
	}
	var l = includeLastPage ? curation.pages.length : curation.pages.length - 1;
	for(var i=0; i<l; i++)
	{
		console.log("Adding page!");
		tree.addNode(curation.pages[i]);
	}
}