var utils,
	app,
	strings;

var backups;
var chosenFile = null;
var createdFile = null;
var closeAll = true;
var action = 'default';
const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";

Components.utils.import("resource://gre/modules/FileUtils.jsm");

function loadAnother()
{
	app.loadFile();
	window.close();
}

function showBackup()
{
	function compareBackups(a, b)
	{
		return b.lastModifiedTime - a.lastModifiedTime;
	}
	backups.sort(compareBackups);
	var list = document.getElementById('backup-list');
	for (var i = 0; i < backups.length; i++)
	{
		var item = document.createElementNS(XUL_NS, "listitem");
		var cell = document.createElementNS(XUL_NS, "listcell");
		cell.setAttribute('label', backups[i].leafName);
		item.appendChild(cell);

		cell = document.createElementNS(XUL_NS, "listcell");
		var time = new Date(backups[i].lastModifiedTime);
		cell.setAttribute('label', time.toLocaleString());
		item.appendChild(cell);

		item.addEventListener('dblclick', loadBackup);

		list.appendChild(item);
	}
	list.selectedIndex = 0;
	document.getElementById('main-deck').selectedIndex = 1;
}

function loadBackup()
{
	var idx = document.getElementById('backup-list').selectedIndex;
	app.loadFile(backups[idx]);
	window.close();
}

function loadDefault()
{
	window.close();
}

function onclose()
{
	console.log("[LF] CLOSING");
	if (closeAll)
	{
		console.log("[LF] CLOSING");
		app.tryClose();
	}
}

function next()
{
	document.getElementById('main-deck').selectedIndex = 1;
	changeMode();
}

function changeMode()
{
	var mode = document.getElementById('file-mode').selectedIndex;
	var textbox = document.getElementById('file-path');
	textbox.readonly = mode == 1;
	textbox.disabled = mode == 0;
	if (mode == 0)
		document.getElementById('file-path').value = createdFile ? createdFile.path : "";
	else
		document.getElementById('file-path').value = chosenFile ? chosenFile.path : "";
	checkFile();
}

function chooseFile()
{
	var mode = document.getElementById('file-mode').selectedIndex;
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	if (mode == 0)
	{
		fp.init(window, strings.getString('oaff.createFile'), nsIFilePicker.modeSave);
	}
	else
	{
		fp.init(window, strings.getString('oaff.loadFile'), nsIFilePicker.modeOpen);
	}
	fp.appendFilter("JSON files", "*.json");
	var lastFile = utils.getSetting("defaultFile", "string");
	/*if(lastFile) {
		lastFile = new FileUtils.File(lastFile);
	} else {*/
	lastFile = utils.getLocalDir();
	lastFile.append('default_desktop.json');
	lastFile = utils.postfixFile(lastFile);
	console.log("[LF] File: " + lastFile.leafName);
	/*}*/
	fp.displayDirectory = lastFile.parent;
	fp.defaultString = lastFile.leafName;
	var result = fp.show();
	if (result != nsIFilePicker.returnCancel)
	{
		var thefile = fp.file;
		if (mode == 0)
			createdFile = thefile;
		else
			chosenFile = thefile;
		document.getElementById('file-path').value = thefile.path;
		checkFile();
	}
}

function validFile(path)
{

	try
	{
		var thefile = new FileUtils.File(path);
		if (thefile.exists())
			return thefile;
		return null;
	}
	catch (e)
	{
		return null;
	}
}

function checkFile()
{
	console.log("[LF] Checking file...");
	if (document.getElementById('file-mode').selectedIndex == 1)
	{
		document.getElementById('please-select').hidden = true;
		var path = document.getElementById('file-path').value;
		var thefile = validFile(path);
		if (!thefile)
		{
			document.getElementById('not-exists').hidden = false;
			document.getElementById('finish').disabled = true;
		}
		else
		{
			document.getElementById('not-exists').hidden = true;
			document.getElementById('finish').disabled = false;
		}
	}
	else
	{
		document.getElementById('not-exists').hidden = true;
		if (!createdFile)
		{
			document.getElementById('please-select').hidden = false;
			document.getElementById('finish').disabled = true;
		}
		else
		{
			document.getElementById('please-select').hidden = true;
			document.getElementById('finish').disabled = false;
		}
	}
}

function finish()
{
	if (document.getElementById('file-mode').selectedIndex == 0)
	{
		app.loadDefault();
		utils.saveSetting("defaultFile", "string", createdFile.path);
		app.saveFile();
	}
	else
	{
		console.log('[LF] ' + document.getElementById('file-path').value);
		app.loadFile(document.getElementById('file-path').value);
	}
	closeAll = false;
	document.getElementById('oaff-loadfile').acceptDialog();
}

function init()
{
	var args = window.arguments[0];
	utils = args.utils;
	app = args.app;

	strings = document.getElementById('loadfile-string-bundle');

	createdFile = utils.getLocalDir();
	createdFile.append('default_desktop.json');
	createdFile = utils.postfixFile(createdFile);

	/*chosenFile = utils.getLocalDir();
	createdFile.append('default_desktop.json');*/

	window.addEventListener('close', onclose);
}