
var tree,
	app,
	favicons,
	utils,
	additionalInfo,
	strings;

var currentFile = null;

var currentAction = "";

var currentData = null;

var selection = {};

function selectNode(guid, value)
{
	if(selection[guid] === undefined)
	{
		selection[guid] = value === undefined ? true : value;
	} else {
		selection[guid] = value === undefined ? !selection[guid] : value;
	}
	var node = o(guid);
	// select/unselect children
	if(node.type !== 'page')
	{
		for(var i=0; i<node.children.length; i++)
		{
			selectNode(node.children[i], selection[guid]);
		}
	}
}

function selectParent(guid)
{
	var node = o(guid);
	if(node.type !== 'panelroot')
	{
		var parent = o(node.parent);
		var off = true;
		for(var i=0; i<parent.children.length; i++)
		{
			if( selection[parent.children[i]] )
				off = false;
		}
		//console.log("[W] off ", off, parent.name ,selection[parent.guid], '(', node.name, ')', selection[node.guid]);
		if(off)
		{
			selection[parent.guid] = false;
			selectParent(parent.guid);
		}
		if( !selection[parent.guid] && !off )
		{
			selection[parent.guid] = true;
			selectParent(parent.guid);
		}
	}
}

function treeSelect()
{
	var tree = document.getElementById('exportTree');
	var idx = tree.currentIndex;
	if(idx < 0 || idx >= treeView.visibleData.length )
	{
		return;
	}

	setTimeout(function() {
		if(!treeView.nodeToggle)
			{
			selectNode(treeView.visibleData[idx].guid);

			selectParent(treeView.visibleData[idx].guid);

			treeView.treeBox.invalidate();

			$('next-button').disabled = true;
			$('save-button').disabled = true;
			for(var i in selection)
			{
				if(selection[i])
				{
					$('next-button').disabled = false;
					$('save-button').disabled = false;
					break;
				}
			}
		}

		treeView.nodeToggle = false;
	}, 100);
}

function next()
{
	switch(currentAction)
	{
		case "panelexport":
			export2();
		break;

		case "panelimport":
			import2();
		break;
	}
}

function prev()
{};

function save()
{
	switch(currentAction)
	{
		case "panelexport":
			var FileUtils = Components.utils.import("resource://gre/modules/FileUtils.jsm").FileUtils;
			var file = new FileUtils.File($('export-filename').value);
			var newData = tree.exportSubtree(tree.getPanelRoot(), selection).data;
			utils.asyncWriteLocal(file, tree.serializeJSON(newData), function() {
				window.close();
			});
		break;

		case "panelimport":
			//app.importAndReset(currentData, selection);
			tree.importSubtree(currentData, selection);
			window.close();
		break;
	}
}

function $(id)
{
	return document.getElementById(id);
}

function buildVirtualTree(data)
{
	currentData = data;
	o = function o2(guid)
		{
			return data[guid] || null;
		}

	var root = null;
	for(var i in data)
	{
		if(data[i].type == 'panelroot')
		{
			root = data[i];
			break;
		}
	}

	$('exportTree').view = treeView;
	treeView.prepareTree(root);
}

function browseSaveFile()
{
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Save file", nsIFilePicker.modeSave);
	fp.appendFilter("OAP files", "*.oap");
	fp.defaultExtension = "*.oap";
	var lastDir = utils.getSetting("lastExportFile", "string", null);
	var lastFile = utils.getLocalDir();
	if(lastDir)
		lastFile = new FileUtils.File(lastDir);
	fp.displayDirectory = lastFile.parent;
	var filename = "export"; //$('export-filename').value || "user.oap";
	if (!filename.match(/\.oap$/i))
			filename += '.oap';
	fp.defaultString = filename;
	var result = fp.show();
	if (result != nsIFilePicker.returnCancel)
	{
		var thefile = fp.file;
		console.log(thefile.path);
		if (!thefile.path.match(/\.oap$/i)) {
			thefile.leafName += '.oap';
			console.log("Adding", thefile.path);
		}
		currentFile = thefile;
		$('export-filename').value = thefile.path;
		$('save-button').disabled = false;
		utils.saveSetting("lastExportFile", "string", thefile.path);
		console.log(utils.getSetting("lastExportFile", "string", null));
	}
}

function browseLoadFile()
{
	Components.utils.import("resource://gre/modules/FileUtils.jsm");
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Load file", nsIFilePicker.modeOpen);
	fp.appendFilter("OAP files", "*.oap");
	var lastDir = utils.getSetting("lastExportFile", "string", null);
	var lastFile = utils.getLocalDir();
	if(lastDir)
		lastFile = new FileUtils.File(lastDir);
	var filename = "import"; //$('export-filename').value || "";
	if (!filename.match(/\.oap$/i))
			filename += '.oap';
	lastFile.append(filename);
	fp.displayDirectory = lastFile.parent;
	fp.defaultString = lastFile.leafName;
	var result = fp.show();
	if (result != nsIFilePicker.returnCancel)
	{
		var thefile = fp.file;
		currentFile = thefile;
		$('export-filename').value = thefile.path;
		$('next-button').disabled = false;
		utils.saveSetting("lastExportFile", "string", thefile.path);
	}
}

function export1()
{
	document.title = strings.getString('wizard.export');
	currentAction = "panelexport";
	$('wizard-deck').selectedIndex = 0;
	$('save-button').hidden = true;
	$('next-button').hidden = false;
	$('next-button').disabled = true;
	$('exportTree').view = treeView;
	treeView.prepareTree(tree.getPanelRoot());
}

function export2()
{
	$('browse-button').addEventListener("command", browseSaveFile);
	$('wizard-deck').selectedIndex = 1;
	$('save-button').hidden = false;
	$('next-button').hidden = true;
	$('save-button').disabled = true;
	$('prop-type').value = strings.getString('panelroot');
	$('prop-created').value = (new Date()).toLocaleString();

	var FileUtils = Components.utils.import("resource://gre/modules/FileUtils.jsm").FileUtils;
	var lastDir = utils.getSetting("lastExportFile", "string", null);
	if(!lastDir)
	{
		lastDir = utils.getLocalDir();
		lastDir.append('export.oap');
	}
	else
		lastDir = new FileUtils.File(lastDir);
	lastDir = utils.postfixFile(lastDir);
	$('export-filename').value = lastDir.path;
	$('save-button').disabled = false;
}

function import1()
{
	document.title = strings.getString('wizard.import');
	currentAction = "panelimport";
	$('browse-button').addEventListener("command", browseLoadFile);
	$('wizard-deck').selectedIndex = 1;
	$('save-button').hidden = true;
	$('next-button').hidden = false;
	$('next-button').disabled = true;
	$('prop-type').value = strings.getString('panelroot');
	$('prop-created').value = (new Date()).toLocaleString();

	/*var FileUtils = Components.utils.import("resource://gre/modules/FileUtils.jsm").FileUtils;
	var lastDir = utils.getSetting("lastExportFile", "string", null);
	if(!lastDir)
		lastDir = utils.getLocalDir();
	else
		lastDir = new FileUtils.File(lastDir);
	lastDir.append('export.oap');
	$('export-filename').value = lastDir.path;*/
}

function import2()
{
	utils.asyncRead(currentFile, function(data)
	{
		try {
			data = tree.loadJSON(data, true, true);
			buildVirtualTree(data);
		} catch(e) {
			alert("Invalid data file!");
		}
	});
	$('save-button').disabled = true;
	$('wizard-deck').selectedIndex = 0;
	$('save-button').hidden = false;
	$('next-button').hidden = true;
}

function cancel()
{
	window.close();	
}

function init() 
{
	var args = window.arguments[0];
	tree = args.tree;
	app = args.app;
	favicons = args.favicons;
	utils = args.utils;
	additionalInfo = args.info || {};
	strings = document.getElementById('panelexport-string-bundle');

	if(additionalInfo.action == 'panelexport')
	{
		export1();
	}
	if(additionalInfo.action == 'panelimport')
	{
		import1();
	}
}