(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
/**
 * Main module, which contains an entry point for application
 * @module app
 * @requires module:utils
 */

var objects = require('./model/objects.js'),
	tree = require('./model/tree.js'),
	tabs = require('./view/tabs.js'),
	tabs = require('./view/tab-collection.js'),
	xul = require('./view/interface.js'),
	favicons = require('./faviconmanager.js'),
	hotkeys = require('./hotkeys.js'),
	metainfo = require('./metainfo.js'),
	clipboard = require('./model/clipboard.js'),
	curationExporter = require('./curation-exporter.js'),
	rss = require('./rss.js'),
	utils = require('./utils.js');

window.Tabsmoz = window.Tabsmoz ||
{};

var autosaveInterval = null;

var dontSave = false;

var debug = false;

var tabManagerUpdate = false;

/**
 * Shows dialog window when no last file is found, and loads default file in background
 * @static
 */
function showNoFileDialog()
{
	debug && console.log("[A] Showng no file dialog");
	loadDefault();
	var l = (screen.width - 600) / 2;
	var t = (screen.height - 200) / 2;
	debug && console.log("[A] " + l + " " + t);
	window.openDialog("chrome://store.tabsmoz/content/dialogs/loadfile.xul", "File not found", "chrome=1,left=" + l + ",top=" + t + ",height=200,width=600,resizable,modal",
	{
		utils: utils,
		app: Tabsmoz
	});
}

/**
 * Loads data at the beginning and initializes model with data. If no last file is found, shows appropriate dialog.
 * @static
 */
function loadData()
{
	var lastFile = utils.getSetting("defaultFile", "string");
	if(lastFile == null)
	{
		loadDefault();
		createdFile = utils.getLocalDir();
		createdFile.append('default_desktop.json');
		createdFile = utils.postfixFile(createdFile);
		utils.saveSetting('defaultFile', "string", createdFile.path);
		addFileToRecent(createdFile.path);
		saveData();
	}
	else
	if (!lastFile || !lastFile.length)
	{
		// last file has gone
		showNoFileDialog();
		//loadDefault();
	}
	else
	{
		// ok, load last file
		var FileUtils = Cu.import("resource://gre/modules/FileUtils.jsm").FileUtils;
		var file = new FileUtils.File(lastFile);
		if (!file.exists())
		{
			showNoFileDialog();
			return;
		}
		utils.asyncRead(file, function(data)
		{
			tree.loadJSON(data, null, null, xul.getString);
			setTimeout(function() { xul.init(); }, 0);
		});
	}
}

/**
 * Sets autosave interval. Clears it if interval is less or equal to zero
 * @static
 * @param {int} interval interval in minutes
 */
function setSaveInterval(interval)
{
	clearInterval(autosaveInterval);
	if (interval > 0)
	{
		autosaveInterval = setInterval(function() {
			saveData();
		}, interval * 60 * 1000);
	}
}

/**
 * Loads default tree data from built-in file and initializes model with data
 * @static
 * @param {function} [callback] optional callback
 */
function loadDefault(callback)
{
	var prefFile = 'chrome://store.tabsmoz/content/default.json';
	utils.asyncRead(prefFile, function(data)
	{
		tree.loadJSON(data, null, null, xul.getString);
		setTimeout(function() { xul.init() }, 0);
		if(callback)
			callback();
	});
}

var saveFlag = true, // flag that blocks often rewriting the file
	saveInterval = 2000; // minimal delay between writings

/**
 * Saves data to autosave file with minimum delay to prevent often writings to file
 * @static
 */
function saveData()
{
	if (saveFlag)
	{
		saveFlag = false;
		debug && console.log("[A] Saving data");
		setTimeout(function()
		{
			var data = tree.serializeJSON();
			var defFile = utils.getSetting("defaultFile", "string");
			var dir = utils.getBackupDir();
			var backup = "autosave.bak";
			if (defFile)
			{
				var FileUtils = Cu.import("resource://gre/modules/FileUtils.jsm").FileUtils;
				backup = new FileUtils.File(defFile).leafName.replace(/\.json$/i, '.bak');
			}
			dir.append(backup);
			utils.asyncWriteLocal(dir, data, function()
			{
				debug && console.log("[A] Successful saving!");
			});
			saveFile();
			saveFlag = true;
		}, saveInterval);
	}
}

/**
 * Shows settings window
 * @static
 */
function showSettings()
{
	window.openDialog("chrome://store.tabsmoz/content/dialogs/settings.xul", "Settings", "chrome=1,resizable=1,centerscreen,height=400,width=680,alwaysRaised",
	{
		tree: tree,
		xul: xul,
		utils: utils,
		app: Tabsmoz,
		hotkeys: hotkeys
	});
}

/**
 * Shows properties window for a node
 * @static
 * @param  {BaseObject} node
 * @param {bool} [justCreated] flag that shows that node is just created and is not in the tree
 * @param {object} [info] additional info that you may pass to function. Mostly used with <pre>justCreated=true</pre>. For example, there goes url/link for new group.
 */
function showProperties(node, justCreated, info)
{
	var url = "chrome://store.tabsmoz/content/dialogs/properties.xul";
	if (node.type == "curationlink")
	{
		console.log("[A] Curation properties");
		url = "chrome://store.tabsmoz/content/dialogs/curation.xul";
	}
	window.openDialog(url, "Properties", "chrome=1,resizable=1,centerscreen,height=400,width=600,alwaysRaised",
	{
		justCreated: justCreated,
		node: node,
		tree: tree,
		favicons: favicons,
		utils: utils,
		info: info,
		metainfo: metainfo,
		rss: rss,
		app: Tabsmoz
	});
}

/**
 * Shows wizard for new curation file
 * @static
 */
function showCurationWizard()
{
	window.openDialog("chrome://store.tabsmoz/content/dialogs/properties.xul", "Properties", "chrome=1,resizable=1,centerscreen,height=400,width=600",
	{
		justCreated: true,
		node: null,
		tree: tree,
		favicons: favicons,
		utils: utils,
		info: { curationWizard: true },
		metainfo: metainfo,
		rss: rss,
		app: Tabsmoz
	});
}

/**
 * Shows wizard for exporting panel tree
 * @static
 */
function exportPanelTree()
{
	window.openDialog("chrome://store.tabsmoz/content/wizards/import-export.xul", "Properties", "chrome=1,resizable=1,centerscreen,height=400,width=600",
	{
		tree: tree,
		favicons: favicons,
		utils: utils,
		info: {action: 'panelexport'},
		app: Tabsmoz
	});
}

/**
 * Shows wizard for importing panel tree
 * @static
 */
function importPanelTree()
{
	window.openDialog("chrome://store.tabsmoz/content/wizards/import-export.xul", "Properties", "chrome=1,resizable=1,centerscreen,height=400,width=600",
	{
		tree: tree,
		favicons: favicons,
		utils: utils,
		info: {action: 'panelimport'},
		app: Tabsmoz
	});
}

/**
 * Imports panel tree and resets UI
 * @static
 * @param  {object} data      raw node list to import from
 * @param  {object} selection list of nodes to import
 */
function importAndReset(data, selection)
{
	//utils.saveSetting("defaultFile", "string", "");
	console.log("Importing subtree");
	tree.importSubtree(data, selection);
	console.log("Resetting");
	xul.reset();
}

/**
 * Shows tab manager
 * @static
 */
function showTabManager()
{
	window.openDialog("chrome://store.tabsmoz/content/dialogs/tabmanager.xul", "Tab manager", "chrome=1,resizable=1,centerscreen,height=400,width=600,alwaysRaised",
	{
		tree: tree,
		xul: xul,
		utils: utils,
		app: Tabsmoz,
		setUpdater: function(updater)
		{
			tabManagerUpdate = updater;
		}
	});
}

function updateTabManager(event)
{
	if (tabManagerUpdate)
		tabManagerUpdate(event.detail);
}

/**
 * Adds file to "recent files" list
 * @static
 * @param {string} filename
 */
function addFileToRecent(filename)
{
	debug && console.log("[A] Adding to recent " + filename);
	var files = utils.getSetting('recentFiles', 'string');
	if (files)
	{
		files = JSON.parse(files);
		var i = files.indexOf(filename);
		if (i > -1)
		{
			files.splice(i, 1);
		}
	}
	else
	{
		files = [];
	}
	files.unshift(filename);
	if (files.length > 6)
		files.pop();
	utils.saveSetting('recentFiles', 'string', JSON.stringify(files));
}

/**
 * Shows file picker and loads selected file
 * @static
 */
function loadFile(filepath)
{
	Components.utils.import("resource://gre/modules/FileUtils.jsm");
	if (filepath)
	{
		if (typeof(filepath) == 'string')
			var thefile = new FileUtils.File(filepath);
		else
			var thefile = filepath;
		utils.asyncRead(thefile, function(data)
		{
			debug && console.log("[A] Loading from file " + thefile.path);
			if (!thefile.leafName.match(/\.bak$/i))
			{
				utils.saveSetting("defaultFile", "string", thefile.path);
				addFileToRecent(thefile.path);
			}
			try {
				tree.loadJSON(data, null, null, xul.getString);
			} catch(e) {};
			xul.reset();
		});
	}
	else
	{
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
		fp.init(window, "Load file", nsIFilePicker.modeOpen);
		fp.appendFilter("JSON files", "*.json");
		var lastFile = utils.getSetting("defaultFile", "string");
		if (lastFile)
		{
			lastFile = new FileUtils.File(lastFile);
		}
		else
		{
			lastFile = utils.getLocalDir();
			lastFile.append('user.json');
		}
		fp.displayDirectory = lastFile.parent;
		fp.defaultString = lastFile.leafName;
		var result = fp.show();
		if (result != nsIFilePicker.returnCancel)
		{
			var thefile = fp.file;
			utils.asyncRead(thefile, function(data)
			{
				utils.saveSetting("defaultFile", "string", thefile.path);
				addFileToRecent(thefile.path);
				tree.loadJSON(data, null, null, xul.getString);
				xul.reset();
			});
		}
	}
}

/**
 * Saves data to autosave file and current file. If current file not selected, prompts user to select it
 * @static
 * @param  {boolean} force flag to show "Save as" window if current file not selected
 */
function saveFile(force)
{
	var data = tree.serializeJSON();
	/*utils.asyncWriteLocal('user.json', data, function () {
		debug && console.log("[A] Successful saving!");
	});*/
	var file = utils.getSetting("defaultFile", "string");
	if (file && file.length)
	{
		var FileUtils = Components.utils.import("resource://gre/modules/FileUtils.jsm").FileUtils;
		var deffile = new FileUtils.File(file);
		utils.asyncWriteLocal(deffile, data, function() {});
	}
	else if (force)
	{
		saveFileAs();
	}
	saveFlag = true;
}

/**
 * Shows dialog for creating a new file.
 * @static
 */
function createFile()
{
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Load file", nsIFilePicker.modeSave);
	fp.appendFilter("JSON files", "*.json");
	fp.defaultExtension = "*.json";
	var lastFile = utils.getSetting("defaultFile", "string");
	if (lastFile)
	{
		lastFile = new FileUtils.File(lastFile);
	}
	else
	{
		lastFile = utils.getLocalDir();
		lastFile.append('New Desktop.json');
	}
	fp.displayDirectory = lastFile.parent;
	fp.defaultString = "New Desktop.json";
	var result = fp.show();
	if (result != nsIFilePicker.returnCancel)
	{
		var thefile = fp.file;
		if (!thefile.path.match(/\.json$/i))
			thefile.path += '.json';
		utils.saveSetting("defaultFile", "string", thefile.path);
		loadDefault(function() {
			addFileToRecent(thefile.path);
			xul.reset();
			saveFile(true);
		});
		
	}
}

/**
 * Asks user to select file for saving, and saves data. <br>
 * It it exists, chooses the last file as default. Otherwise chooses OptimalAccess/user.json in user's home folder
 * @static
 */
function saveFileAs()
{
	var FileUtils = Cu.import("resource://gre/modules/FileUtils.jsm").FileUtils;
	var file = utils.getSetting("defaultFile", "string");
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Save As...", nsIFilePicker.modeSave);
	fp.appendFilter("JSON files", "*.json");
	fp.defaultExtension = "*.json";
	if (file && file.length)
	{
		file = new FileUtils.File(file);
		fp.displayDirectory = file.parent;
		fp.defaultString = file.leafName;
	}
	else
	{
		var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
		// for Windows and MacOS
		file.append('Optimal Data');
		fp.displayDirectory = file;
		fp.defaultString = 'user.json';
	}
	var result = fp.show();
	if (result != nsIFilePicker.returnCancel)
	{
		var thefile = fp.file;
		var data = tree.serializeJSON();
		utils.saveSetting("defaultFile", "string", thefile.path);
		addFileToRecent(thefile.path);
		utils.asyncWriteLocal(thefile, data, function()
		{
			if (!thefile.path.match(/\.json$/i))
			{
				debug && console.log("[A] Renaming " + thefile.leafName + " to " + thefile.leafName + ".json", thefile.parent);
				thefile.moveTo(null, thefile.leafName + ".json");
			}
		});
		utils.asyncWriteLocal('user.json', data, function() {});
	}
}

function exportCurationFile(file)
{
	curationExporter.exportFile(file);
}

/**
 * Shows dialog window with list of all pages that will be deleted with given link
 * @static
 * @param  {BaseObject} link  - link to be deleted
 * @param  {BaseObject[]} pages - array of all linked pages
 * @return {boolean}       true if user confirms deletion, false otherwise
 */
function promptLinkDelete(link, pages)
{
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var string = "Deletion of this link will remove these pages:";
	for (var i = 0; i < pages.length; i++)
	{
		string += "\n" + pages[i].getFullPath().join(' / ');
	}
	return promptService.confirm(null, "Delete link \"" + link.name + "\"", string);
}

function warnLastPageInGroup()
{
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var strings = document.getElementById('oaff_string_bundle');
	return promptService.confirm(null, strings.getString('oaff.warn.lastPageTitle'), strings.getString('oaff.warn.lastPage'));
}

function warnDeleteGroup()
{
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var strings = document.getElementById('oaff_string_bundle');
	return promptService.confirm(null, strings.getString('oaff.warn.deleteGroupTitle'), strings.getString('oaff.warn.deleteGroup'));
}

function warnDeletePanel()
{
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var strings = document.getElementById('oaff_string_bundle');
	return promptService.confirm(null, strings.getString('oaff.warn.deletePanelTitle'), strings.getString('oaff.warn.deletePanel'));
}

/**
 * Executed when browser window is closing and saves data if necessary
 */
function onClose()
{
	debug && console.log("[A] Closing...");
	var save = utils.getSetting("sa	veOnExit", "bool");
	if (save && !dontSave)
	{
		debug && console.log("[A] Saving...");
		saveFlag = true;
		saveData();
	}
	utils.saveSetting("page", "int", 0, "browser.startup.");
}

/**
 * Closes browser
 * @static
 */
function tryClose()
{
	// ff native function
	debug && console.log("[A] Force Closing...");
	dontSave = true;
	Components
		.classes['@mozilla.org/toolkit/app-startup;1']
		.getService(Components.interfaces.nsIAppStartup)
		.quit(Components.interfaces.nsIAppStartup.eForceQuit);
}

/**
 * Catches modifications of tree and saves data if necessary
 * @param  {Event} event
 */
function onTreeModified(event)
{
	if (utils.getSetting('saveInterval', 'int') == 0)
	{
		saveData();
	}
}

/**
 * Entry point for application
 */
function init()
{
	//menubar toolbar directories extrachrome 

	Components.utils.import("resource://gre/modules/Services.jsm");
	Services.prefs.setBoolPref("browser.tabs.warnOnClose", false);

	window.Tabsmoz.showSettings = showSettings;
	window.Tabsmoz.showProperties = showProperties;
	window.Tabsmoz.showTabManager = showTabManager;
	window.Tabsmoz.loadFile = loadFile;
	window.Tabsmoz.saveFile = saveFile;
	window.Tabsmoz.saveFileAs = saveFileAs;
	window.Tabsmoz.createFile = createFile;
	window.Tabsmoz.promptLinkDelete = promptLinkDelete;
	window.Tabsmoz.clipboard = clipboard;
	window.Tabsmoz.warnings = {
		lastPage: warnLastPageInGroup,
		group: warnDeleteGroup,
		panel: warnDeletePanel
	};
	window.Tabsmoz.loadDefault = loadDefault;
	window.Tabsmoz.setSaveInterval = setSaveInterval;
	window.Tabsmoz.tryClose = tryClose;
	window.Tabsmoz.exportCurationFile = exportCurationFile;
	window.Tabsmoz.showCurationWizard = showCurationWizard;
	window.Tabsmoz.exportPanelTree = exportPanelTree;
	window.Tabsmoz.importPanelTree = importPanelTree;
	window.Tabsmoz.importAndReset = importAndReset;
	window.Tabsmoz.getUtils = function()
	{
		return utils;
	};
	window.Tabsmoz.getRSS = function()
	{
		return rss;
	};

	loadData();
	utils.saveSetting("page", "int", 0, "browser.startup.");
	window.addEventListener('close', onClose);
	utils.addTabsmozListener(utils.treeModifiedEvent, onTreeModified);
	utils.addTabsmozListener(utils.treeModifiedEvent, updateTabManager);
	favicons.init();
	hotkeys.init();

}

window.addEventListener("load", function load(event)
{
	window.removeEventListener("load", load, false); //remove listener, no longer needed
	init();
}, false);
},{"./curation-exporter.js":2,"./faviconmanager.js":3,"./hotkeys.js":4,"./metainfo.js":5,"./model/clipboard.js":6,"./model/objects.js":8,"./model/tree.js":9,"./rss.js":10,"./utils.js":11,"./view/interface.js":14,"./view/tab-collection.js":17,"./view/tabs.js":18}],2:[function(require,module,exports){
/**
 * Module that exports curation file as xml
 * @module curation-exporter
 */

var tree = require('./model/tree.js'),
	utils = require('./utils.js');

/**
 * removes hyphens from guid and makes it uppercase
 * @param  {BaseObject} node 
 * @return {string}      clean guid
 */
function cleanId(node)
{
	return node.guid.replace(/-/g, '').toUpperCase();
}

function clean(str)
{
	str = str || '';
	return str.replace(/\&/g, '&amp;').replace(/\"/g, "&quot;").replace(/\'/g, "&apos;").replace(/\</g, '&lt;').replace(/\>/g, '&gt;');
}

function decodeHTMLEntities(text) {
    var entities = [
        ['apos', '\''],
        ['amp', '&'],
        ['lt', '<'],
        ['gt', '>']
    ];

    for (var i = 0, max = entities.length; i < max; ++i) 
        text = text.replace(new RegExp('&'+entities[i][0]+';', 'g'), entities[i][1]);

    return text;
}

function clearHTML(text)
{
	if(!text)
		return "";
	return clean(text.replace(/<script.*\/script>/gi, '').replace(/\<[^\>]+\>/g, ''));
}

function getCurationXML (file) 
{
	var xml = '<?xml version="1.0" encoding="UTF-8"?>\n';
	xml += '<file>\n<div itemscope="" itemtype="http://schema.org/WebPage">\n'
			+ '\t<span itemprop="about">' + clean(file.name) + '</span>\n'
			+ '\t<span itemprop="comment">' + clean(file.comment) + '</span>\n'
			+ '\t<span itemprop="encoding">' + cleanId(file) + '</span>\n'
			+ '\t<span itemprop="publisher">' + clean(file.publisher) + '</span>\n'
			+ '\t<span itemprop="author">' + clean(file.author) + '</span>\n'
			+ '\t<span itemprop="keywords">' + clean(file.tags.join(',')) + '</span>\n';
	
	for(var i=0; i<file.children.length; i++)
	{
		var group = tree.getObject(file.children[i]);
		//xml += '<BOOK name="' + clean(group.name) + '" object_uid="' + cleanId(group) + '" caption="' + clean(group.name) + '" tooltip="' + clean(group.tags.join(', ')) + '">';
		xml += '\t<group>\n\t<div itemscope="" itemtype="http://schema.org/WebPageElement">\n'
				+ '\t\t<span itemprop="about">' + clean(group.name) + '</span>\n'
				+ '\t\t<span itemprop="comment">' + clean(group.comment) + '</span>\n'
				+ '\t\t<span itemprop="encoding">' + cleanId(group) + '</span>\n'
				+ '\t\t<span itemprop="keywords">' + clean(group.tags.join(',')) + '</span>\n';

		for(var j=0; j<group.children.length; j++)
		{
			var page = tree.getObject(group.children[j]);
			//xml += '<CHAPTER name="' + clean(page.name) + '" object_uid="' + cleanId(page) + '" caption="' + clean(page.name) + '" tooltip="' + clean(page.tags.join(', ')) + '">';
			xml += '\t\t<page>\n\t\t<div itemscope="" itemtype="http://schema.org/WebPageElement">\n'
					+ '\t\t\t<span itemprop="about">' + clean(page.name) + '</span>\n'
					+ '\t\t\t<span itemprop="comment">' + clean(page.name) + '</span>\n'
					+ '\t\t\t<span itemprop="encoding">' + cleanId(page) + '</span>\n'
					+ '\t\t\t<span itemprop="keywords">' + clean(page.tags.join(',')) + '</span>\n';

			var folder = tree.getObject(page.link);

			for(var k=0; k < folder.links.length; k++)
			{
				var link = tree.getObject(folder.links[k]);
				var date = new Date(link.pubDate);
				//xml += '<PAGE name="' + clean(link.headline) + '" object_uid="' + cleanId(link) + '" caption="' + clean(link.headline) + '" tooltip="' + clean(link.tags.join(', ')) + '" author="' + clean(link.author) + '" pubDate="' + date.toUTCString() + '">';
				//xml += '<COMMENT>' + clean(link.description) + '</COMMENT>';
				//xml += '<LINK><PAGEURL>' + clean(link.url) + '</PAGEURL></LINK></PAGE>';
				var type = link.pubType == 'news' ? 'NewsArcticle' : 'Article';
				xml += '\t\t\t<link>\n\t\t\t<div itemscope="" itemtype="http://schema.org/' + type + '">\n'
						  + '\t\t\t\t<meta itemscope="" itemprop="mainEntityOfPage"  itemType="https://schema.org/WebPage" itemid="' + clean(link.url) + '"/>\n'
						  + '\t\t\t\t<h2 itemprop="headline">' + clean(link.headline) + '</h2>\n'
						  + '\t\t\t\t<h3 itemprop="author" itemscope="" itemtype="https://schema.org/Person">\n'
						    + '\t\t\t\t\tBy <span itemprop="name">' + clean(link.author) + '</span>\n'
						  + '\t\t\t\t</h3>'
						  + '\t\t\t\t<span itemprop="description">' + clearHTML(link.description) + '</span>\n';
						  if(link.imageUrl)
						  {
						  	xml += '\t\t\t\t<div itemprop="image" itemscope="" itemtype="https://schema.org/ImageObject">\n'
						  	+ '\t\t\t\t\t<img src="' + clean(link.imageUrl) + '"/>\n'
						  	+ '\t\t\t\t\t<meta itemprop="url" content="' + clean(link.imageUrl) + '"/>\n'
						  	+ '\t\t\t\t</div>\n';
						  }
				xml += '\t\t\t\t<div itemprop="publisher" itemscope="" itemtype="https://schema.org/Organization">\n'
						    + '\t\t\t\t\t<meta itemprop="name" content="' + clean(link.publisher) + '"/>\n'
						  + '\t\t\t\t</div>' // end of publisher
						  + '\t\t\t\t<meta itemprop="datePublished" content="' + clean(date.toUTCString()) + '"/>\n'
						  + '\t\t\t\t<meta itemprop="dateModified" content="' + clean(date.toUTCString()) + '"/>\n';
			    if(link.rating)
			    {
			  		xml += '\t\t\t\t<div itemprop="aggregateRating" itemscope="" itemtype="http://schema.org/AggregateRating">\n'
			  			+ '\t\t\t\t\t<span itemprop="ratingValue">' + (link.rating + 1) + '</span>\n'
			  			+ '\t\t\t\t</div>';
			    }
				xml += '\t\t\t\t<span itemprop="keywords">' + clean(link.tags.join(',')) + '</span>\n'
						+ '\t\t\t</div>\n\t\t\t</link>\n';
			}

			xml += '\t\t</div>\n\t\t</page>\n';
		}

		xml += '\t</div>\n\t</group>\n';
	}

	xml += '</div>\n</file>';

	return xml;
}

/**
 * Exports curation file as xml. Also lets user choose destination file
 * @static
 * @param  {CurationFile} file 
 */
function exportFile(file)
{
	file = tree.getObject(file);
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Export file", nsIFilePicker.modeSave);
	fp.appendFilter("XML files", "*.xml");
	fp.defaultExtension = "*.xml";
	var lastDir = utils.getSetting("lastExportDir", "string", null);
	var lastFile = utils.getLocalDir();
	if(lastDir)
	{
		lastFile = new FileUtils.File(lastDir);
		lastFile.leafName = file.name + '.xml';
	} else {
		lastFile.append(file.name + '.xml');
	}
	fp.displayDirectory = lastFile.parent;
	fp.defaultString = file.name + '.xml';
	var result = fp.show();
	if (result != nsIFilePicker.returnCancel)
	{
		var thefile = fp.file;
		if (!thefile.path.match(/\.xml$/i))
			thefile.path += '.xml';
		var data = getCurationXML(file);
		utils.saveSetting("lastExportDir", "string", thefile.path);
		utils.asyncWriteLocal(thefile, data, function() {
			console.log("[CE] Export successful!");

		});	
	}
}

module.exports = {
	exportFile: exportFile
};
},{"./model/tree.js":9,"./utils.js":11}],3:[function(require,module,exports){
/**
 * Module for managing favicons
 * @module favicons
 */

var utils = require('./utils.js');

var iconMap = {
	"curation": "chrome://store.tabsmoz/content/common/favicons/curation.png",
	"folder": "chrome://store.tabsmoz/content/common/favicons/folder.png",
	"rss": "chrome://store.tabsmoz/content/common/favicons/rss.png",
	"search": "chrome://store.tabsmoz/content/common/favicons/search.png"
};
var iconDir = null;

var defaultIcon = "chrome://store.tabsmoz/content/common/favicon.png";

var debug = false;

/**
 * Scans the cache folder and initializes storage
 */
function scanFolder()
{
	var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);

	console.log(iconDir);
	var entries = iconDir.directoryEntries;
	while (entries.hasMoreElements())
	{
		var file = entries.getNext().QueryInterface(Components.interfaces.nsIFile);
		var domain = file.leafName;
		domain = domain.replace(/\.(png|ico|gif|jpg)$/i, "");
		iconMap[domain] = "file:///" + file.path.replace(/\.(png|ico|gif|jpg)$/i, ".png");; //ioService.newURI(file.path, null, null);
	}
	debug && console.log("[F] Scanned", iconMap);
}

/**
 * Creates local filename to save the favicon
 * @param  {string} domain 
 * @return {nsIFile}        file
 */
function getIconFile(domain)
{
	var dir = iconDir.clone();
	try
	{
		dir.append(domain + '.png');
	}
	catch (e)
	{
		debug && console.log("[F] Error domain: " + domain);
		return null;
	}
	return dir;
}

/**
 * Downloads favicon for given site
 * @param  {string} domain 
 */
function loadFavicon(domain)
{
	Components.utils.import("resource://gre/modules/NetUtil.jsm");
	Components.utils.import("resource://gre/modules/FileUtils.jsm");

	NetUtil.asyncFetch("http://www.google.com/s2/favicons?domain=" + domain, function(aInputStream, aResult)
	{
		// Check that we had success.
		if (!Components.isSuccessCode(aResult))
		{
			iconMap[domain] = defaultIcon;
			return;
		}

		var file = getIconFile(domain);
		if (!file)
		{
			return;
		}
		var ostream = FileUtils.openSafeFileOutputStream(file);

		NetUtil.asyncCopy(aInputStream, ostream, function(status)
		{
			if (!Components.isSuccessCode(status))
			{
				// Handle error!
				debug && console.log("[F] Error while writing favicon");
				return;
			}
			iconMap[domain] = "file:///" + iconDir.path + '/' + domain + ".png";
			console.log(iconMap[domain]);
			debug && console.log("[F] Successfully written favicon");
			// Data has been written to the file.
			utils.emitEvent(utils.faviconLoadEvent,
			{
				domain: domain
			});
		});
	});
}

/**
 * Returns favicon for given url. If no favicon present, downloads it.
 * @static
 * @param  {string} url 
 * @return {string}     local path to favicon in cache
 */
function getFavicon(url)
{
	if (url && iconMap[url])
		return iconMap[url];

	var ioService = Components.classes["@mozilla.org/network/io-service;1"]
		.getService(Components.interfaces.nsIIOService);

	var uri = "";
	try
	{
		uri = ioService.newURI(url, null, null);
	}
	catch (e)
	{
		debug && console.log("[F] Error URL: " + url);
		if (!/^https?:\/\//i.test(url))
		{
			//just a domain, maybe
			uri = {
				host: url
			};
		}
		else
		{
			return defaultIcon;
		}
	}

	try
	{
		var host = uri.host;
	}
	catch (e)
	{
		return defaultIcon;
	}

	if (!iconMap[host])
	{
		console.log("[F] loading icon for host " + host);
		loadFavicon(host);
		iconMap[host] = defaultIcon;
	}

	return iconMap[host];
}

/**
 * Initializes module
 * @static
 */
function init()
{
	iconDir = utils.getLocalDir().parent;
	iconDir.append('oaffdata');
	if (!iconDir.exists() || !iconDir.isDirectory())
	{
		// read and write permissions to owner and group, read-only for others.
		iconDir.create(Ci.nsIFile.DIRECTORY_TYPE, 508);
	}
	iconDir.append('favicons');
	if (!iconDir.exists() || !iconDir.isDirectory())
	{
		// read and write permissions to owner and group, read-only for others.
		iconDir.create(Ci.nsIFile.DIRECTORY_TYPE, 508);
	}

	console.log("EXISTS",iconDir.exists(),iconDir.path);

	scanFolder();

	window.Tabsmoz = window.Tabsmoz ||
	{};
	window.Tabsmoz.getFavicons = function()
	{
		return module.exports;
	}
}

module.exports = {
	init: init,
	getFavicon: getFavicon
};
},{"./utils.js":11}],4:[function(require,module,exports){

/**
 * Processing hotkeys
 * @module hotkeys
 */

var debug = false;

/**
 * Labels for certain actions, which usually don't have textual representation
 * @type {Object}
 */
const HOTKEY_LABELS = {
  "focusURLBar": "Focus URL Bar",
  "focusURLBar2": "Focus URL Bar",
  "key_search": "Web Search",
  "key_search2": "Web Search",
  "key_stop": "Stop",
  "key_stop_mac": "Stop",
  "goHome": "Home",
  "goBackKb": "Back",
  "goBackKb2": "Back 2",
  "goForwardKb": "Forward",
  "goForwardKb2": "Forward",
  "key_close": "Close Tab",
  "key_undoCloseTab": "Undo Close Tab",
  "key_undoCloseWindow": "Undo Close Window",
  "key_toggleAddonBar": "Toggle Add-on Bar",
  "key_findPrevious": "Find Previous",
  "key_findSelection": "Find Selection",
  "key_devToolboxMenuItemF12": "Toggle Tools",
  "key_reload": "Reload",
  "key_reload2": "Reload",
  "key_selectLastTab": "Select Last Tab",
  "key_selectTab1": "Select Tab 1",
  "key_selectTab2": "Select Tab 2",
  "key_selectTab3": "Select Tab 3",
  "key_selectTab4": "Select Tab 4",
  "key_selectTab5": "Select Tab 5",
  "key_selectTab6": "Select Tab 6",
  "key_selectTab7": "Select Tab 7",
  "key_selectTab8": "Select Tab 8",
  "key_tabview": "Tab Groups",
  "key_minimizeWindow": "Minimize Window",
  "key_sanitize_mac": "Clear Recent History…",
  "key_fullScreen_old": "Enter Full Screen",
  "focusChatBar": "Focus Chat Bar"
};

/**
 * Human-readable representation of virtual keycodes
 * @type {Object}
 */
const KEY_CODE_TO_DOM_KEY_NAME = {
  VK_MENU: "Alt",
  VK_LMENU: "Alt",
  VK_RMENU: "Alt",
  VK_CAPITAL: "CapsLock",
  VK_CONTROL: "Control",
  VK_LCONTROL: "Control",
  VK_RCONTROL: "Control",
  VK_NUMLOCK: "NumLock",
  VK_LWIN: "OS",
  VK_RWIN: "OS",
  VK_SCROLL: "ScrollLock",
  VK_SHIFT: "Shift",
  VK_LSHIFT: "Shift",
  VK_RSHIFT: "Shift",
  VK_RETURN: "Enter",
  VK_TAB: "Tab",
  VK_DOWN: "ArrowDown",
  VK_LEFT: "ArrowLeft",
  VK_RIGHT: "ArrowRight",
  VK_UP: "ArrowUp",
  VK_END: "End",
  VK_HOME: "Home",
  VK_NEXT: "PageDown",
  VK_PRIOR: "PageUp",
  VK_BACK: "Backspace",
  VK_CLEAR: "Clear",
  VK_OEM_CLEAR: "Clear",
  VK_CRSEL: "CrSel",
  VK_DELETE: "Delete",
  VK_EREOF: "EraseEof",
  VK_EXSEL: "ExSel",
  VK_INSERT: "Insert",
  VK_ACCEPT: "Accept",
  VK_ATTN: "Attn",
  VK_CANCEL: "Cancel",
  VK_APPS: "ContextMenu",
  VK_ESCAPE: "Escape",
  VK_EXECUTE: "Execute",
  VK_HELP: "Help",
  VK_PAUSE: "Pause",
  VK_PLAY: "Play",
  VK_SELECT: "Select",
  VK_SNAPSHOT: "PrintScreen",
  VK_SLEEP: "Standby",
  VK_OEM_ATTN: "Alphanumeric",
  VK_CONVERT: "Convert",
  VK_FINAL: "FinalMode",
  VK_MODECHANGE: "ModeChange",
  VK_NONCONVERT: "NonConvert",
  VK_HANGUL: "HangulMode",
  VK_HANJA: "HanjaMode",
  VK_JUNJA: "JunjaMode",
  VK_OEM_AUTO: "Hankaku",
  VK_OEM_COPY: "Hiragana",
  VK_KANA: "KanaMode",
  VK_ATTN: "KanaMode",
  VK_KANJI: "KanjiMode",
  VK_OEM_FINISH: "Katakana",
  VK_OEM_BACKTAB: "Romaji",
  VK_OEM_ENLW: "Zenkaku",
  VK_F1: "F1",
  VK_F2: "F2",
  VK_F3: "F3",
  VK_F4: "F4",
  VK_F5: "F5",
  VK_F6: "F6",
  VK_F7: "F7",
  VK_F8: "F8",
  VK_F9: "F9",
  VK_F10: "F10",
  VK_F11: "F11",
  VK_F12: "F12",
  VK_F13: "F13",
  VK_F14: "F14",
  VK_F15: "F15",
  VK_F16: "F16",
  VK_F17: "F17",
  VK_F18: "F18",
  VK_F19: "F19",
  VK_F20: "F20",
  VK_F21: "F21",
  VK_F22: "F22",
  VK_F23: "F23",
  VK_F24: "F24",
  VK_MEDIA_PLAY_PAUSE: "MediaPlayPause",
  VK_LAUNCH_MEDIA_SELECT: "MediaSelect",
  VK_MEDIA_STOP: "MediaStop",
  VK_MEDIA_NEXT_TRACK: "MediaTrackNext",
  VK_MEDIA_PREV_TRACK: "MediaTrackPrevious",
  VK_VOLUME_DOWN: "VolumeDown",
  VK_VOLUME_UP: "VolumeUp",
  VK_VOLUME_MUTE: "VolumeMute",
  VK_LAUNCH_MAIL: "LaunchMail",
  VK_LAUNCH_APP1: "LaunchApplication1",
  VK_LAUNCH_APP2: "LaunchApplication2",
  VK_BROWSER_BACK: "BrowserBack",
  VK_BROWSER_FAVORITES: "BrowserFavorites",
  VK_BROWSER_FORWARD: "BrowserForward",
  VK_BROWSER_HOME: "BrowserHome",
  VK_BROWSER_REFRESH: "BrowserRefresh",
  VK_BROWSER_SEARCH: "BrowserSearch",
  VK_BROWSER_STOP: "BrowserStop",
  VK_ZOOM: "ZoomToggle",
};

/**
 * Object that stores user-defined hotkeys
 * @type {Object}
 */
var gOverlays = (function() {
  var overlays = {};

  return {
    get(id) {
      return overlays[id] || null;
    },

    set(id, modifiers, key) {
      overlays[id] = {modifiers, key};
      debug && console.log("[HK] Set", overlays);
    },

    disable(id) {
      overlays[id] = {disabled: true};
    },

    clear(id) {
      delete overlays[id];
    },

    keys() {
    	return Object.keys(overlays);
    },

    save() {
    	utils.saveSetting("hotkeys", "string", JSON.stringify(overlays));
    },

    load() {
    	var data = utils.getSetting("hotkeys", "string");
    	try {
    		overlays = JSON.parse(data);
    	} catch(e) {
    		overlays = {};
    	}
    }
   };
})();

/**
 * Gets label for shortcut, basing on &lt;key&rt; element
 * @param  {XULElement} element &lt;key&rt; element that holds the hotkey
 * @return {string}
 */
function getLabel(element) {
  var label = element.getAttribute("label");

  if (label) {
    return label;
  }

  var id = element.id;

  if (id in HOTKEY_LABELS) {
    return HOTKEY_LABELS[id];
  }

  // Try to find a menuitem...
  var menuitem = document.querySelector('menuitem[key="' + id + '"][label]');
  return menuitem ? menuitem.getAttribute("label") : id;
}

var gPlatform;

var gModifiers = (function () {
  const MODIFIER_NAMES = new Set(["Control", "Shift", "Meta", "Alt", "OS", "AltGraph"]);
  const MODIFIER_KEYS = {16: "shift", 17: "control", 18: "alt", 91: "meta", 92: "meta", 224: "meta"};

  const MODIFIER_CONTROL = 1;
  const MODIFIER_META    = 2;
  const MODIFIER_SHIFT   = 4;
  const MODIFIER_ALT     = 8;

  gPlatform = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS.toLowerCase();

  function getModifierState(event, modifier) {
    // Pressing Alt/Option on OS X shouldn't yield true for AltGraph.
    if (gPlatform == "darwin" && modifier == "AltGraph") {
      return false;
    }

    if (event.getModifierState(modifier)) {
      return true;
    }

    // getModifierState() seems to always return false on Linux when only a
    // single modifier key is pressed. Work around by checking the keyCode.
    if (gPlatform == "linux") {
      return (MODIFIER_KEYS[event.keyCode] || "") == modifier.toLowerCase();
    }

    return false;
  }

  return {
    isModifier(key) {
      return MODIFIER_NAMES.has(key);
    },

    fromEvent(event) {
      var modifiers = 0;

      if (getModifierState(event, "Control") || getModifierState(event, "AltGraph")) {
        modifiers |= MODIFIER_CONTROL;
      }

      if (getModifierState(event, "Shift")) {
        modifiers |= MODIFIER_SHIFT;
      }

      if (getModifierState(event, "Meta") || getModifierState(event, "OS")) {
        modifiers |= MODIFIER_META;
      }

      if (getModifierState(event, "Alt") || getModifierState(event, "AltGraph")) {
        modifiers |= MODIFIER_ALT;
      }

      return modifiers;
    },

    fromAttribute(attr, accelKey) {
      var parts = new Set(attr.toLowerCase().split(/[,\s]/));

      if (parts.has("accel")) {
        parts.add(MODIFIER_KEYS[accelKey] || "control");
        parts.delete("accel");
      }

      var modifiers = 0;

      if (parts.has("control")) {
        modifiers |= MODIFIER_CONTROL;
      }

      if (parts.has("shift")) {
        modifiers |= MODIFIER_SHIFT;
      }

      if (parts.has("meta")) {
        modifiers |= MODIFIER_META;
      }

      if (parts.has("alt")) {
        modifiers |= MODIFIER_ALT;
      }

      return modifiers;
    },

    toText(modifiers) {
      var parts = [];

      if (modifiers & MODIFIER_CONTROL) {
        parts.push("Ctrl + ");
      }

      if (modifiers & MODIFIER_META) {
        var text = "";
        if (gPlatform == "darwin") {
          text = "Cmd";
        } else if (gPlatform == "linux") {
          text = "Super";
        } else if (gPlatform == "winnt") {
          text = "Win";
        }

        if (text) {
          parts.push(`${text} + `);
        }
      }

      if (modifiers & MODIFIER_SHIFT) {
        parts.push("Shift + ");
      }

      if (modifiers & MODIFIER_ALT) {
        parts.push("Alt + ");
      }

      return parts.join("");
    }
  }
})();


/**
 * Holds information about grouping hotkeys.
 * @name  gKeyGroups
 * @type {Object}
 */
var gKeyGroups = (function () {

  const KEY_GROUPS = {
    "Navigation": [
      "goBackKb", "goBackKb2", "goForwardKb", "goForwardKb2", "goHome",
      "openFileKb", /*"F5",*/ "key_reload", /*"Ctrl+F5", Ctrl+Shift+R,*/
      "key_stop", "key_stop_mac", "focusURLBar", "focusURLBar2"
    ],

    "Current Page": [
      /*"End", "Home", "F6", "Shift+F6",*/ "key_viewInfo", "key_viewSource",
      "printKb", "key_savePage", "key_fullZoomEnlarge", "key_fullZoomReduce",
      "key_fullZoomReset", "key_switchTextDirection"
    ],

    "Editing": [
      "key_copy", "key_cut", "key_delete", "key_paste", "key_redo",
      "key_selectAll", "key_undo"
    ],

    "Search": [
      "key_find", "key_findAgain", "key_findPrevious", "key_search",
      "key_search2", "key_findSelection"
    ],
 
    "Windows & Tabs": [
      "key_close", "key_closeWindow", "key_newNavigatorTab", "key_newNavigator",
      "key_undoCloseTab", "key_undoCloseWindow",
      "key_switchToNextTab", "key_switchToPrevTab",
      "key_selectTab1", "key_selectTab2", "key_selectTab3", "key_selectTab4",
      "key_selectTab5", "key_selectTab6", "key_selectTab7", "key_selectTab8",
      "key_selectLastTab", "key_tabview", "key_nextTabGroup", "key_prevTabGroup",
      "key_minimizeWindow", "key_showAllTabs", "key_privatebrowsing",
    ],

    "Bookmarks & History": [
      "addBookmarkAsKb", "viewBookmarksSidebarKb", "viewBookmarksSidebarWinKb",
      "manBookmarkKb", "bookmarkAllTabsKb", "key_gotoHistory",
      "showAllHistoryKb", "key_sanitize", "key_sanitize_mac"
    ],

    "Tools": [
      "key_openDownloads", "key_openAddons", "key_preferencesCmdMac"
    ],

    "Developer Tools": [
      "key_webdebug && console", "key_errordebug && Console", "key_jsdebugger", "key_inspector",
      "key_styleeditor", "key_jsprofiler", "key_devToolbar", "key_responsiveUI",
      "key_scratchpad", "key_netmonitor", "key_devToolboxMenuItemF12",
      "key_browserdebug && Console", "key_devToolboxMenuItem", "key_webide"
    ]
  };

  /**
   * Returns key-value map of hotkeys, divided by groups
   * @param  {array} keys array of "hotkey" object
   * @return {Map}      map that maps group name to array of hotkeys
   */
  function group(keys) {
    var remaining = new Map(keys);
    var retval = new Map();

    for (var name in KEY_GROUPS) {
      var group = [];

      for (var id of KEY_GROUPS[name]) {
        if (remaining.has(id)) {
          group.push(keys.get(id));
          remaining.delete(id);
        }
      }

      if (group.length) {
        // Sort by label.
        group.sort(function(a, b) { a.label > b.label ? 1 : a.label < b.label ? -1 : 0 });
        retval.set(name, group);
      }
    }

    if (remaining.size) {
      retval.set("Other", [...remaining.values()]);
    }

    return retval;
  }

  return {group: group};
})();

/**
 * Executes command that defined in browser layout
 * @param  {XULElement} elem &lt;command&gt; element
 */
function executeXULCommand(elem) {
  var cmdID = elem.getAttribute("command");
  var command = elem.ownerDocument.getElementById(cmdID);

  if (command) {
    command.doCommand();
  }
}

/**
 * Fires event for executing command
 * @param  {XULElement} elem &lt;command&gt; element
 */
function fireXULCommandEvent(elem) {
  var sourceEvent = elem.ownerDocument.createEvent("Events");
  sourceEvent.initEvent("command", false, false);

  var event = elem.ownerDocument.createEvent("XULCommandEvents");
  event.initCommandEvent("command", true, false, null, null, false, false, false, false, sourceEvent);
  elem.dispatchEvent(event);
}

var execute = function (id) {
  // Handle custom commands. For next releases
  /*if (COMMANDS_CUSTOM.has(id)) {
    COMMANDS_CUSTOM.get(id)();
    return;
  }*/

  var doc = document;
  var key = doc.getElementById(id);
  if (!key) {
    return;
  }

  if (key.hasAttribute("command")) {
    executeXULCommand(key);
    return;
  }

  if (key.hasAttribute("oncommand")) {
    fireXULCommandEvent(key);
    return;
  }

  var menuitem = doc.querySelector("menuitem[key=" + id + "][command]");
  if (menuitem) {
    executeXULCommand(menuitem);
  }
};

/**
 * Checks if there is user-defined hotkey for currently pressed keys
 * @param  {KeyboardEvent} event 
 * @return {boolean}
 */
function findOverlay(event) {
  var evmodifiers = gModifiers.fromEvent(event);

  return gOverlays.keys().find(function(id) {
    var overlay = gOverlays.get(id);
    debug && console.log("[HK] ", id, overlay);
    return evmodifiers == overlay.modifiers &&
           event.key.toLowerCase() == overlay.key.toLowerCase();
  });
}

/**
 * Returns user-defined hotkey for currently pressed keys
 * @param  {KeyboardEvent} event 
 * @return {object} Hotkey object
 */
function findOverridden(event) {
  var modifiers = gModifiers.fromEvent(event);

  return gOverlays.keys().map(function(id) 
  	{ 
  		return gOverlays.get(id); 
  	}).some(function(hotkey) 
  	{
    	return modifiers == hotkey.modifiers &&
           event.key.toLowerCase() == hotkey.key.toLowerCase();
  	});
}

/**
 * Tries to find user hotkey for keyboard event
 * @param  {KeyboardEvent} event 
 */
function handlePossibleShortcut(event) {
  // Ignore synthetic events.
  if (!event.isTrusted) {
    return;
  }

  var overlay = findOverlay(event);

  debug && console.log("[HK] Searching for overlay", gModifiers.fromEvent(event), event.key, overlay);

  if (overlay) {
  	debug && console.log("[HK] overlay");
    execute(overlay);
  } else {
    overlay = findOverridden(event);
  }

  if (overlay) {
    event.preventDefault();
    event.stopPropagation();
  }
}

/**
 * Returns list of all hotkeys
 * @return {object} key-value pairs of data. Key is id of related &lt;key&gt; element, data is { id: string, label: string, modifiers: int }
 */
var getList = function () {
  	function parseModifiers(attr) {
	  return gModifiers.fromAttribute(attr, utils.getSetting("accelKey", "int", "ui.key."));
	}
  var hotkeys = {};

  var keys = document.querySelectorAll("key[id]");
  for (var i=0; i < keys.length; i++) {
  	var hotkey = keys[i];
    var id = hotkey.getAttribute("id");
    var data = {id: id, label: getLabel(hotkey), modifiers: 0};

    if (hotkey.hasAttribute("modifiers")) {
      data.modifiers = parseModifiers(hotkey.getAttribute("modifiers"));
    }

    if (hotkey.hasAttribute("keycode")) {
      var value = hotkey.getAttribute("keycode");
      data.key = KEY_CODE_TO_DOM_KEY_NAME[value] || null;
    } else {
      data.key = hotkey.getAttribute("key").toLowerCase();
    }

    if (data.key) {
      hotkeys[id] = data;
    }
  }

  // Add custom hotkey definitions.
  //addCustomHotKeys(hotkeys);

  return hotkeys;
};

/**
 * Inits module
 * @static
 */
function init() {
	window.addEventListener("keydown", handlePossibleShortcut);
	debug && console.log("[HK]", utils.getSetting("accelKey", "int", "ui.key."));
	gOverlays.load();
	gHotKeys = getList();
}


/**
 * Saves current hotkey configuration
 */
function save()
{
	gOverlays.save();
}

module.exports = {
	init: init,
	overlays: gOverlays,
	getLabel: getLabel,
	modifiers: gModifiers,
	keyGroups: gKeyGroups,
	save: save,
	getOverlays: function() { return gOverlays; },
	getList: function() { return gHotKeys; }
};

var utils = require('./utils.js');
},{"./utils.js":11}],5:[function(require,module,exports){
/**
 * Page info grabber
 * @module metainfo
 */


var utils = require('./utils.js');

/**
 * Downloads page by url
 * @param  {NSIUri}   uri     
 * @param  {Function}   finalize callback to pass into callback
 * @param  {Function} callback 
 */
function downloadPage (uri, finalize, callback) {
	Components.utils.import("resource://gre/modules/NetUtil.jsm");
	NetUtil.asyncFetch(uri, function(inputStream, status)
	{
		if (!Components.isSuccessCode(status))
		{
			// Handle error!
			return;
		}

		// The file data is contained within inputStream.
		// You can read it into a string with
		var data = NetUtil.readInputStreamToString(inputStream, inputStream.available(), { charset: "UTF-8" });
		callback(data, finalize);
	});
}

/**
 * Tries to get element of metainfo from document
 * @param  {HTMLDocument} doc       downloaded document
 * @param  {string[]} selectors array of selectors to look into
 * @return {string|null} 
 */
function getMetaTag(doc, selectors)
{
	var e;
	for(var i=0; i<selectors.length; i++) {
		e = doc.querySelector(selectors[i]);
		if(e)
		{
			switch(e.nodeName)
			{
				case "META":
					return e.getAttribute('content') || e.getAttribute('value');
				break;
				case "TITLE":
					return e.textContent;
				break;
				default:
					return e.textContent;
				break;
			}
		}
	}
	return null;
}

/**
 * Extracts meta info from page
 * @param  {string}   html     downloaded html page
 * @param  {Function} callback function that accepts object with info for curation link
 */
function parsePage(html, callback)
{
	console.log("[MI] GOT PAGE!" + typeof(html));
	var data = {};
	//var parser = new DOMParser();
	var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
             .createInstance(Components.interfaces.nsIDOMParser);
	var doc = parser.parseFromString(html, "text/html");

	function findProperty(property, selectors)
	{
		var p = getMetaTag(doc, selectors);
		if(p !== null)
			data[property] = p;
	}

	findProperty('headline', ['*[itemscope] *[itemprop="headline"]', 'title', 'meta[property="og:title"']);
	findProperty('description', ['*[itemscope] *[itemprop="description"]', '*[itemscope] *[itemprop="about"]', 'meta[name="description"', 'meta[property="og:description"']);
	findProperty('imageUrl', ['*[itemscope] *[itemprop="image"]', 'meta[property="og:image"']);
	findProperty('publisher', ['*[itemscope] *[itemprop="publisher"]', 'meta[property="og:site_name"']);
	findProperty('author', ['*[itemscope] *[itemprop="author"]']);
	findProperty('pubDate', ['*[itemscope] *[itemprop="dateCreated"]', '*[itemscope] *[itemprop="datePublished"]']);
	findProperty('twitter', ['meta[name="twitter:site"]', 'meta[name="twitter:creator"]']);

	if(data.pubDate)
	{
		data.pubDate = (new Date(data.pubDate)).getTime() - new Date().getTimezoneOffset()*60*1000;;
	}

	console.log("[MI] metas", data);
	//tree.updateNodeInfo(guid, data);
	callback(data);
}

/**
 * Downloads and extracts meta info from url
 * @param  {string}   url      
 * @param  {Function} callback function that accepts object with info for curation link
 */
module.exports.getMetaInfo = function getMetaInfo (url, callback) {
	var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var uri;
	try
	{
		uri = ioService.newURI(url, null, null);
	}
	catch (e)
	{
		return;
	}
	downloadPage(uri, callback, parsePage);
}


},{"./utils.js":11}],6:[function(require,module,exports){
/**
 * Implements clipboard functionality for manipulating tree nodes
 * @module clipboard
 */

var debug = false;

var immovable = ['root', 'linkroot', 'curationroot', 'panelroot'];

module.exports = {
	data: null,
	node: null,
	type: null,
	action: null,

	/**
	 * Inits clipboard with object and action (copy or cut)
	 * @param {BaseObject} node   node to copy or cut
	 * @param {string} action "cut" or "copy"
	 */
	set: function(data, action)
	{
		this.data = data.guid ? [data] : data;
		this.action = action;
		if(!this.canManipulate(this.data))
		{
			this.clear();
		} 
		else
		{
			this.type = this.data[0].type;
			this.node = this.data[0];
		}
	},

	/**
	 * Clears clipboard
	 */
	clear: function()
	{
		this.data = null;
		this.type = null;
		this.node = null;
	},

	canManipulate: function (data) {
		var result = true;
		if(data.length == 0)
			return false;
		var type = data[0].type;
		for(var i=0; i<data.length; i++) 
		{
			if(data[i].type == 'root' || data[i].type == 'linkroot' || data[i].type == 'panel' || data[i].type == 'panelroot' || data[i].type == 'curationroot' || data[i].type == 'curationfile' || data[i].type == 'rsslink' || data[i].type !== type)
				return false;
		}
		return result;	
	},

	canDelete: function (data) {
		if(data.length == 0)
			return false;
		for(var i=0; i<data.length; i++) 
		{
			if(data[i].type == 'root' || data[i].type == 'linkroot' || data[i].type == 'panelroot' || data[i].type == 'curationroot' || data[i].type == 'rsslink')
				return false;
		}
		return true;
	},

	/**
	 * Checks if currently cut/copied node can be inserted into given node
	 * @param  {string} type type of node on which context menu has been invoked
	 * @param {BaseObject} [node] node on which context menu has been invoked. Optional.
	 * @param {string} [sourceType] when passed, the clipboard.type property is ignored and function acts like static utility method. Can be any valid node type string.
	 * @return {boolean}      true if node in clipboard can be pasted into node with given type
	 */
	compatible: function(type, node, sourceType)
	{
		console.log("[TV] Compat: " + this.type + " -> " + type);
		if(!this.type && !sourceType)
			return false;
		sourceType = sourceType || this.type;
		switch (sourceType)
		{
			case 'link':
				if (type == 'link' || type == 'linkroot')
					return true;
				break;

			case 'curationlink':
				if (type == 'link' && node && node.linkType == 'curation')
					return true;
				break;

			case 'panel':
				if (type == 'panelroot')
					return true;
				break;

			case 'group':
				if (type == 'panel')
					return true;
				break;

			case 'page':
				if (type == 'group')
					return true;
				break;

			case 'curationpanel':
				if (type == 'curationroot')
					return true;
				break;

			case 'curationgroup':
				if (type == 'curationfile')
					return true;
				break;

			case 'curationpage':
				if (type == 'curationgroup')
					return true;
				break;
		}
		console.log("[TV] Sorry :(");
		return false;
	}
};
},{}],7:[function(require,module,exports){
/**
 * Implements all history-related functions.
 * @module history
 */

// just an array of guids of pages
var history = [];
var forward = [];

var backCommand = null,
	forwardCommand = null,
	backBroadcaster = null,
	forwardBroadcaster = null;

var makingBack = false;

var debug = false;

var lastSelectedPage = null;

function maphistory()
{
	var a = history.map(function(val)
	{
		return tree.getObject(val).name.substr(0, 20);
	});
	var page = tree.getObject(lastSelectedPage);
	a.push("[" + (page ? page.name.substr(0,20) : "null") + "]");
	return a;
}

function mapforward()
{
	var a = forward.map(function(val)
	{
		return tree.getObject(val).name.substr(0, 20);
	});
	a.push("[" + tree.getObject(lastSelectedPage).name.substr(0,20) + "]");
	return a;
}

function getSelectedPage(node)
{
	while (node && node.type !== 'page')
	{
		node = tree.getObject(node.getLastChild());
	}
	return node;
}

/**
 * Pushes new page to history, but only if page is different from last selected. Also clears "forward" array.
 * @function addToHistory
 * @param {Page} data page to add to history
 * @return {boolean} true if page was added to history, false otherwise
 */
function addToHistory(data)
{
	if(makingBack)
		return;
	var node = tree.getSelected('page');//getSelectedPage(data.target);
	// this can happen if user just created group which has no pages
	if(!node)
	{
		return false;
	}
	if (data) {
		debug && console.log("[H] Updating... " + data.type + " " + data.name + ", page: " + node.name);
	}
	if (node.guid != lastSelectedPage)	
	{
		forward = [];
		history.push(lastSelectedPage);
		lastSelectedPage = node.guid;
		var size = utils.getSetting("historySize", "int");
		if (history.length > size + 1)
			history.shift();
		debug && console.log("[H] Updated", maphistory());
		return true;
	}
	lastSelectedPage = node.guid;
	return false;
}

/**
 * Called when a node is deleted. Checks if deleted node was a page and if it was in history, and deletes occurencies of this node.
 * @function checkHistory
 * @param  {BaseObject} data node that was deleted
 */
function checkHistory(data)
{
	var node = data;
	if (node.type == 'page')
	{
		history = history.filter(function(val) {
			return val !== node.guid;
		});

		forward = forward.filter(function(val) {
			return val !== node.guid;
		});

		updateState();
	}
}

/**
 * Updates state of "Back" and "Forward" commands (disabled/enabled)
 * @function updateState
 */
function updateState()
{
	backCommand.setAttribute("disabled", !canGoBack());
	forwardCommand.setAttribute("disabled", !canGoForward());

	//debug && console.log("[H] Modified. canGoBack: ", canGoBack(), "canGoForward: ", canGoForward(), history, forward);

	debug && (document.getElementById('oaff-log-text').textContent = maphistory().join(" -> "));
}

/**
 * Listens to 'treeModified' event and updates history according to changes
 * @function modifiedListener
 * @param  {Event} event 
 */
function modifiedListener(event)
{
	var data = event.detail;
	var update = false;
	switch (data.type)
	{
		case 'update':
			if (data.properties.indexOf('lastChild') > -1)
				update = addToHistory(data.target);
			break;

		case 'delete':
			checkHistory(data.target);
			update = true;
			break;
	}

	if (update)
	{
		updateState();
	}
}

/**
 * Initializes history module
 * @function init
 */
module.exports.init = function()
{
	backCommand = document.getElementById('tabsmoz_cmd_back');
	backCommand.addEventListener("command", function()
	{
		goBack();
	});

	forwardCommand = document.getElementById('tabsmoz_cmd_forward');
	forwardCommand.addEventListener("command", function()
	{
		goForward();
	});

	utils.addTabsmozListener(utils.treeModifiedEvent, modifiedListener);

	updateState();

	debug && console.log("[H] Init");

	if(debug) {
		document.getElementById("oaff-log").hidden = false;
	}

	lastSelectedPage = tree.getSelected('page').guid;
}

/**
 * Checks if you can go back in history
 * @function canGoBack
 * @static
 * @return {boolean}
 */
var canGoBack = module.exports.canGoBack = function()
{
	return history.length > 0;
}

/**
 * Checks if you can go forward in history
 * @function canGoForward
 * @static
 * @return {boolean}
 */
var canGoForward = module.exports.canGoForward = function()
{
	return forward.length > 0;
}

/**
 * Performs "back" action if possible
 * @function back
 * @static
 */
var goBack = module.exports.back = function()
{
	debug && console.log("[H] Begin back", maphistory());
	var guid = history.pop();
	if (guid)
	{
		makingBack = true;
		forward.push(lastSelectedPage);
		//debug && console.log("[H] Back", forward);
		lastSelectedPage = guid;
		tree.setDeepLastChild(lastSelectedPage);
		updateState();
		debug && console.log("[H] End back", maphistory());
		makingBack = false;
	}
}

/**
 * Performs "forward" action if possible
 * @function forward
 * @static
 */
var goForward = module.exports.forward = function()
{
	debug && console.log("[H] Going forward", forward);
	debug && console.log("[H] GOING FORWAARD", mapforward());
	var guid = forward.pop();
	if (guid)
	{
		makingBack = true;
		history.push(lastSelectedPage);
		lastSelectedPage = guid;
		//history.push(guid);
		tree.setDeepLastChild(guid);
		updateState();
		debug && console.log("[H] FORWARD", mapforward());
		makingBack = false;
	}
	else
	{
		debug && console.log("[H] Sorry, no forward");
	}
}

/**
 * Clears history. Useful when loading file.
 */
var clear = module.exports.clear = function()
{
	history = [];
	forward = [];
	makingBack = false;
	updateState();
}

var tree = require('./tree.js'),
	utils = require('../utils.js');
},{"../utils.js":11,"./tree.js":9}],8:[function(require,module,exports){
/**
 * Contains main object modules
 * @module objects
 */

var utils = require('../utils.js');

var debug = false;
/**
 * Generates fairly unique identifier
 * @return {GUID} GUID string
 */
function generateUUID()
{
	var d = new Date().getTime();
	var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c)
	{
		var r = (d + Math.random() * 16) % 16 | 0;
		d = Math.floor(d / 16);
		return (c == 'x' ? r : (r & 0x3 | 0x8)).toString(16);
	});
	return uuid;
};

/**
 * tries to extract GUID from paremeter
 * @param  {any} object
 * @return {string|null}
 */
function getGUID(object)
{
	if (typeof(object) == 'object' && object !== null && object.guid)
	{
		return object.guid;
	}
	else if (typeof(object) == 'string')
	{
		return object;
	}
	return null;
}

/**
 * BaseObject constructor. Just creates object, to initialize use "init" method
 * @class BaseObject
 */
function BaseObject()
{

}

/**
 * Sets parent property
 * @param {GUID|BaseObject} parent
 */
BaseObject.prototype.setParent = function(parent)
{
	this.parent = getGUID(parent);
};

/**
 * Initializes common properties for object
 * @param  {BaseObject | GUID} parent  parent node
 * @param  {GUID | null} guid    GUID for this node
 * @param  {object} options key-value pairs of data
 */
BaseObject.prototype.init = function(parent, guid, options)
{
	this.setParent(parent);
	this.children = options.children ? options.children : [];
	this.created = options.created || (new Date()).getTime();
	if (guid)
	{
		this.guid = guid;
	}
	else
	{
		this.guid = generateUUID();
	}
	this.name = options.name || "";
	this.comment = options.comment || "";
	this.level = options.level || 0;
	this.open = options.open || false;
	this.lastChild = options.lastChild || null;
	this.tags = options.tags || [];
	if (options.type)
	{
		this.type = options.type;
	}
};

/**
 * Adds child node at given position(optional)
 * @param {GUID|BaseObject} child
 * @param {int} [position] index where to insert (at the end by default)
 * @return {int} index where child has been actually inserted
 */
BaseObject.prototype.addChild = function(child, position)
{
	var childGuid = getGUID(child);
	if (this.children.indexOf(childGuid) == -1)
	{
		if (position && (position >= 0 && position < this.children.length))
			this.children.splice(position, 0, childGuid);
		else
			this.children.push(childGuid);
		return this.children.indexOf(childGuid);
	}
	return -1;
};

/**
 * Removes node from children list
 * @param  {BaseObject | GUID} child
 */
BaseObject.prototype.removeChild = function(child)
{
	var childGuid = getGUID(child);
	var childIndex = this.children.indexOf(childGuid);
	if (childGuid == this.lastChild)
		this.lastChild = null;
	if (childIndex != -1)
	{
		this.children.splice(childIndex, 1);
	}
};

/**
 * Swaps two children in terms of tabs(when one is extracted from its place and inserted in another)
 * @param  {BaseObject|GUID} child1 object to replace
 * @param  {BaseObject|GUID} child2 object on which place should insert the first object
 */
BaseObject.prototype.swapChildren = function(child1, child2)
{
	var i1 = this.children.indexOf(getGUID(child1));
	var i2 = this.children.indexOf(getGUID(child2));
	if (i1 == i2)
		return;
	this.children.splice(i1, 1);
	this.children.splice(i2, 0, getGUID(child1));
}

/**
 * Returns last selected child of node. If it's not set, then returns first child
 * @return {GUID} id of last selected child
 */
BaseObject.prototype.getLastChild = function()
{
	if (!this.lastChild)
		this.lastChild = this.children.length ? this.children[0] : null;
	return this.lastChild;
};

BaseObject.prototype.getFullPath = function()
{
	var path = this.name ? [this.name] : [];
	var parent = this;// = tree.getObject(this.parent);
	do {
		parent = tree.getObject(parent.parent);
		if (parent)
			path.unshift(parent.name);
	} while (parent && parent.type !== 'root' && parent.type !== 'panel' && parent.type !== 'panelroot' && parent.type !== 'linkroot')
	return path;
}

/**
 * Panel constructor
 * @class  Panel
 * @extends {BaseObject}
 * @param {GUID | BaseObject} parent
 * @param {GUID | null} guid    guid for created object
 * @param {object} options key-value pairs of additional information
 */
var Panel = function(parent, guid, options)
{
	this.init(parent, guid, options);
	this.type = "panel";
	this.level = 2;
}
//utils.extend(Panel.prototype, BaseObject.prototype);
Panel.prototype = Object.create(BaseObject.prototype);

/**
 * Group constructor
 * @class Group
 * @extends {BaseObject}
 * @param {GUID | BaseObject} parent
 * @param {GUID | null} guid    guid for created object
 * @param {object} options key-value pairs of additional information
 */
var Group = function(parent, guid, options)
{
	this.init(parent, guid, options, options);
	this.type = 'group';
	this.level = 3;
}
//utils.extend(Group.prototype, BaseObject.prototype);
Group.prototype = Object.create(BaseObject.prototype);

Group.prototype.isOpen = function () {
	for(var i=0; i<this.children.length; i++) 
	{
		if(tree.getObject(this.children[i]).isOpen())
			return true;
	}
	return false;
}

/**
 * Page constructor
 * @class Page
 * @extends {BaseObject}
 * @param {GUID | BaseObject} parent
 * @param {GUID | null} guid    guid for created object
 * @param {object} options key-value pairs of additional information
 */
var Page = function(parent, guid, options)
{
	this.init(parent, guid, options);
	this.type = 'page';
	//this.url = options.url || null;
	this.link = options.link || null;
	this.level = 4;
}
//utils.extend(Page.prototype, BaseObject.prototype);
Page.prototype = Object.create(BaseObject.prototype);

Page.prototype.isOpen = function () {
	return this.children.length > 0;
}

/**
 * Subpage constructor
 * @class SubPage
 * @extends {BaseObject}
 * @param {GUID | BaseObject} parent
 * @param {GUID | null} guid    guid for created object
 * @param {object} options key-value pairs of additional information
 */
var SubPage = function(parent, guid, options)
{
	this.init(parent, guid, options);
	this.label = this.name;
	this.type = 'subpage';
	this.url = options.url || null;
	if (options.canClose !== undefined)
		this.canClose = options.canClose;
	else
		this.canClose = true;
	this.local = options.local || false;
	this.node = options.node || null; // node to show in management mode
	this.level = 5;
}
//utils.extend(SubPage.prototype, BaseObject.prototype);
SubPage.prototype = Object.create(BaseObject.prototype);

/**
 * Link constructor. All link types: <ul><li>web</li><li>folder</li><li>curation</li></ul>
 * @class Link
 * @extends {BaseObject}
 * @param {GUID | BaseObject} parent
 * @param {GUID | null} guid    guid for created object
 * @param {object} options key-value pairs of additional information
 * @param {string} options.linkType 'web', 'folder' or 'curation' or 'rss'. But curation folders should be created with CurationFolder constructor
 */
var Link = function(parent, guid, options)
{
	this.init(parent, guid, options);
	this.type = 'link';
	this.url = options.url || null;
	this.linkType = options.linkType || "web";
	if( (!this.url || this.url == '') && this.linkType == 'web' )
		this.linkType = 'folder';
	this.system = options.system || null;
	this.local = options.local == true;
	this.local = this.linkType == 'folder' || this.linkType == 'curation' || this.linkType == 'rss';

	var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	try
	{
		var uri = ioService.newURI(this.url, null, null);
		this.domain = uri.host;
	}
	catch (e)
	{
		this.domain = this.url;
	}
	if(this.linkType == 'folder') 
	{
		this.url = '';
		this.domain = 'folder';
	}
	if(this.linkType == 'rss') 
	{
		this.domain = 'rss';
	}
}
//utils.extend(Link.prototype, BaseObject.prototype);
Link.prototype = Object.create(BaseObject.prototype);

/**
 * Adds child to link folder, according to alphabetic order (no need for position)
 * @override
 * @param {GUID|BaseObject} child    node to add
 * @return {int} index where child has been actually inserted
 */
Link.prototype.addChild = function(child)
{
	var childGuid = getGUID(child);
	debug && console.log("[O] Adding Link child");
	if (this.children.indexOf(childGuid) == -1)
	{
		debug && console.log("[O] Adding Link");
		this.children.push(childGuid);
		this.sortChildren();
		debug && console.log("[O] Sorted children: ", this.children);
		return this.children.indexOf(childGuid);
	}
	return -1;
}

/**
 * Returns path of a link relative to link tree root
 * @override
 * @return {string[]} array of node names
 */
Link.prototype.getFullPath = function()
{
	var path = [this.name];
	var parent = tree.getObject(this.parent);
	while (parent && parent.type !== 'root')
	{
		if (parent)
			path.unshift(parent.name);
		parent = tree.getObject(parent.parent);
	}
	return path;
}

/**
 * Alphabetically sorts children
 */
Link.prototype.sortChildren = function()
{
	function compareChildren(a, b)
	{
		var ac = tree.getObject(a);
		var bc = tree.getObject(b);
		if(ac && bc)
			return ac.name.localeCompare(bc.name);
		return 0;
	}
	this.children.sort(compareChildren);
}

/**
 * Curation Folder constructor. Behaves like regular link, but contains Curation Links alongside with children. 
 * @class CurationFolder
 * @extends {Link}
 * @param {GUID|BaseObject} parent
 * @param {GUID|null} guid 
 * @param {object} options
 */
var CurationFolder = function(parent, guid, options)
{
	this.init(parent, guid, options);
	this.type = 'link';
	this.local = true;
	this.linkType = "curation";
	this.url = 'about:blank';
	this.domain = 'curation';

	// similar to "children" array, but not exactly it
	this.links = options.links || [];
}
//utils.extend(CurationFolder.prototype, Link.prototype);
CurationFolder.prototype = Object.create(Link.prototype);

/**
 * Adds child node at given position(optional). Overrides standart behavior in order to process Curation Links
 * @override
 * @param {GUID|BaseObject} child
 * @param {int} [position] index where to insert (at the end by default)
 * @return {int} index where child has been actually inserted
 */
CurationFolder.prototype.addChild = function(child, position)
{
	var childGuid = getGUID(child);
	var child = tree.getObject(child);
	//console.log("[O] Adding child to CurationFolder", child);
	if (child.type == 'curationlink')
	{
		if (this.links.indexOf(childGuid) == -1)
		{
			if (position && (position >= 0 && position < this.links.length))
				this.links.splice(position, 0, childGuid);
			else
				this.links.unshift(childGuid);
			return this.links.indexOf(childGuid);
		}
		return -1;
	}
	else
	{
		return Link.prototype.addChild.call(this, child, position);
	}
};

/**
 * Removes node from children or Curation Links list
 * @override
 * @param  {BaseObject | GUID} child
 */
CurationFolder.prototype.removeChild = function(child)
{
	var childGuid = getGUID(child);
	var child = tree.getObject(child);
	if (child.type == 'curationlink')
	{
		var childIndex = this.links.indexOf(childGuid);
		if (childGuid == this.lastChild)
			this.lastChild = null;
		if (childIndex != -1)
		{
			this.links.splice(childIndex, 1);
		}
	}
	else
	{
		BaseObject.prototype.removeChild.call(this, child);
	}
};

CurationFolder.prototype.getLastChild = function()
{
	if (!this.lastChild)
		this.lastChild = this.links.length ? this.links[0] : null;
	return this.lastChild;
}

CurationFolder.prototype.swapChildren = function(child1, child2)
{
	child1 = getGUID(child1);
	child2 = getGUID(child2);
	if(this.children.indexOf(child1) < 0)
		var p = 'links';
	else
		var p = 'children'
	var i1 = this[p].indexOf(getGUID(child1));
	var i2 = this[p].indexOf(getGUID(child2));
	if (i1 == i2)
		return;
	this[p].splice(i1, 1);
	this[p].splice(i2, 0, getGUID(child1));
}

/**
 * Curation link constructor. Contains url and some extra info.
 * @class CurationLink
 * @extends {BaseObject}
 * @param {GUID|BaseObject} parent
 * @param {GUID|null} guid
 * @param {object} options
 */
var CurationLink = function(parent, guid, options)
{
	this.init(parent, guid, options);
	this.type = 'curationlink';
	this.tags = options.tags || [];
	this.url = options.url || null;
	this.publisher = options.publisher || "";
	this.date = options.date || null;
	this.pubDate = options.pubDate || Date.now();
	this.author = options.author || "";
	this.description = options.description || "";
	this.rating = options.rating || null;
	this.headline = options.headline || "";
	this.imageUrl = options.imageUrl || null;
	this.pubType = options.pubType || null; // wtf is this
	this.twitter = options.twitter || "";
}
CurationLink.prototype = Object.create(BaseObject.prototype);

/**
 * Curatuion root constructor. Needed only for handling curation tree
 * @class CurationRoot
 * @extends {BaseObject}
 * @param {GUID|BaseObject} parent 
 * @param {GUID|null} guid 
 * @param {object} options only tags can be specified
 */
var CurationRoot = function(parent, guid, options)
{
	this.init(parent, guid, options);
	this.type = 'curationroot';
	this.tags = options.tags || [];
	this.local = true;
	this.url = "about:blank";
}
CurationRoot.prototype = Object.create(BaseObject.prototype);

/**
 * Curatuion file constructor.
 * @class CurationFile
 * @extends {BaseObject}
 * @param {GUID|BaseObject} parent 
 * @param {GUID|null} guid 
 * @param {object} options
 * @param {string} options.author author of file
 * @param {string} options.publisher publisher of a file
 */
var CurationFile = function(parent, guid, options)
{
	this.init(parent, guid, options);
	this.type = 'curationfile';
	this.tags = options.tags || [];
	this.comment = options.comment || "";
	this.author = options.author || "";
	this.publisher = options.publisher || "";
	this.local = true;
	this.url = "about:blank";
}
CurationFile.prototype = Object.create(BaseObject.prototype);

/**
 * Curatuion group constructor.
 * @class CurationGroup
 * @extends {BaseObject}
 * @param {GUID|BaseObject} parent 
 * @param {GUID|null} guid 
 * @param {object} options only tags can be specified
 */
var CurationGroup = function(parent, guid, options)
{
	this.init(parent, guid, options);
	this.type = 'curationgroup';
	this.tags = options.tags || [];
	this.comment = options.comment || "";
	this.local = true;
	this.url = "about:blank";
}
CurationGroup.prototype = Object.create(BaseObject.prototype);

/**
 * Curatuion page constructor. Attached to curation folder
 * @class CurationPage
 * @extends {BaseObject}
 * @param {GUID|BaseObject} parent 
 * @param {GUID|null} guid 
 * @param {object} options
 * @param {GUID} options.link curation folder guid
 */
var CurationPage = function(parent, guid, options)
{
	this.init(parent, guid, options);
	this.type = 'curationpage';
	this.link = options.link || null;
	this.tags = options.tags || [];
	this.comment = options.comment || "";
	this.local = true;
}
CurationPage.prototype = Object.create(BaseObject.prototype);

/**
 * RSS folder constructor. Stores rss items alongside with children nodes
 * @class RSSFolder
 * @extends {Link}
 * @param {GUID|BaseObject} parent 
 * @param {GUID|null} guid 
 * @param {object} options
 * @param {string} options.url url of feed
 * @param {string} options.feedUrl url to site where feed comes from (optional, parsed from feed)
 * @param {string} options.feedTitle title of feed (optional, parsed from feed)
 */
var RSSFolder = function (parent, guid, options) 
{
	this.init(parent, guid, options);
	this.type = 'link';
	this.local = true;
	this.linkType = "rss";
	this.url = options.url || "";
	this.domain = 'rss';
	this.feedUrl = options.feedUrl || this.url;
	this.feedTitle = options.feedTitle || this.name;

	// similar to "children" array, but not exactly it
	this.links = options.links || [];
}
RSSFolder.prototype = Object.create(Link.prototype);

/**
 * Adds child node at given position(optional). Overrides standart behavior in order to process rss links
 * @override
 * @param {GUID|BaseObject} child
 * @param {int} [position] index where to insert (at the end by default)
 * @return {int} index where child has been actually inserted
 */
RSSFolder.prototype.addChild = function(child, position)
{
	var childGuid = getGUID(child);
	var child = tree.getObject(child);
	if (child.type == 'rsslink')
	{
		if (this.links.indexOf(childGuid) == -1)
		{
			if (position && (position >= 0 && position < this.links.length))
				this.links.splice(position, 0, childGuid);
			else
				this.links.push(childGuid);
			return this.links.indexOf(childGuid);
		}
		return -1;
	}
	else
	{
		return Link.prototype.addChild.call(this, child, position);
	}
};

/**
 * Removes node from children or rss links list
 * @override
 * @param  {BaseObject | GUID} child
 */
RSSFolder.prototype.removeChild = function(child)
{
	var childGuid = getGUID(child);
	var child = tree.getObject(child);
	if (child.type == 'rsslink')
	{
		var childIndex = this.links.indexOf(childGuid);
		if (childGuid == this.lastChild)
			this.lastChild = null;
		if (childIndex != -1)
		{
			this.links.splice(childIndex, 1);
		}
	}
	else
	{
		BaseObject.prototype.removeChild.call(this, child);
	}
};

/**
 * RSS Link constructor. Holds info for one rss feed item
 * @class RSSLink
 * @extends {BaseObject}
 * @param {GUID|BaseObject} parent 
 * @param {GUID|null} guid 
 * @param {object} options
 * @param {string} options.title
 * @param {string} options.content
 * @param {string} options.pubDate
 * @param {string} options.url
 * @param {string} options.author
 * @param {string} options.img 
 */
var RSSLink = function (parent, guid, options) 
{
	this.init(parent, guid, options);
	this.type = 'rsslink';
	this.title = options.title || "";
	this.content = options.content || "";
	this.pubDate = options.pubDate || "";
	this.url = options.url || "";
	this.author = options.author || "";
	this.img = options.img || null;
	this.read = options.read || false;
	this.tags = options.tags || [];
}
RSSLink.prototype = Object.create(BaseObject.prototype);

RSSLink.prototype.equal = function (info) 
{
	return this.url == info.url && this.title == info.title;
}

/**
 * Search container constructor. Temporary object for holding search results. Never inserted in tree, and never should be passed as a parent to any node
 * @param {GUID|BaseObject} parent  
 * @param {GUID|null} guid    
 * @param {object} options
 * @param {string} options.term search query
 * @param {bool} options.searchTabs flag to search in panel tree
 * @param {bool} options.searchRSS flag to search in rss folders
 * @param {bool} options.searchCuration flag to search in curation folders
 */
var SearchContainer = function(parent, guid, options)
{
	this.init(parent, guid, options);
	this.type = 'search';
	this.local = true;
	this.url = 'about:blank';
	this.term = '';
	this.searchTabs = options.searchTabs === undefined ? true :	 options.searchTabs;
	this.searchRSS = options.searchRSS === undefined ? true :	 options.searchRSS;
	this.searchCuration = options.searchCuration === undefined ? true :	 options.searchCuration;
}
SearchContainer.prototype = Object.create(BaseObject.prototype);

/**
 * Creates object from raw data with correct type
 * @static
 * @param {string} guid guid for created object
 * @param {object} data key-value pairs with properties of an object
 */
var Load = function(guid, data)
{
	var result = null;
	switch (data.type)
	{
		case 'root':
			result = new BaseObject();
			data.level = 0;
			result.init(null, guid, data);
			break;

		case 'panelroot':
			result = new BaseObject();
			data.level = 1;
			result.init(data.parent, guid, data);
			break;

		case 'linkroot':
			/*result = {};
			utils.extend(result, BaseObject);
			data.level = 1;
			result.init(data.parent, guid, data);
			result.url = data.url;
			result.addChild = Link.prototype.addChild;*/
			result = new Link(data.parent, guid, data);
			result.type = 'linkroot';
			//data.level = 1;
			break;

		case 'curationroot':
			result = new CurationRoot(data.parent, guid, data);
		break;

		case 'curationfile':
			result = new CurationFile(data.parent, guid, data);
		break;

		case 'curationgroup':
			result = new CurationGroup(data.parent, guid, data);
		break;

		case 'curationpage':
			result = new CurationPage(data.parent, guid, data);
		break;

		case 'panel':
			result = new Panel(data.parent, guid, data);
			break;

		case 'group':
			result = new Group(data.parent, guid, data);
			break;

		case 'page':
			result = new Page(data.parent, guid, data);
			break;

		case 'subpage':
			result = new SubPage(data.parent, guid, data);
			break;

		case 'link':
			if(data.linkType == 'curation') {
				result = new CurationFolder(data.parent, guid, data);
			} else if(data.linkType == 'rss') {
				result = new RSSFolder(data.parent, guid, data);
			} else {
				if(data.linkType == 'empty') // for really old versions
				{
					data.linkType = 'folder';
					data.local = true;
				}
				result = new Link(data.parent, guid, data);
			}
			break;

		case 'curationlink':
			result = new CurationLink(data.parent, guid, data);
			break;

		case 'rsslink':
			result = new RSSLink(data.parent, guid, data);
			break;
	}
	try {
	if (!('tags' in result))
		result.tags = [];
	} catch(e) {
		console.log("[T] LOAD ERROR", data);
	}
	return result;
}

/**
 * Creates a copy of object, but without any links to other objects (children, parent)
 * @static
 * @param {BaseObject} source object to clone
 */
var Clone = function(source)
{
	var data = {};
	for (var i in source)
		if (source.hasOwnProperty(i) && i != 'guid' && i != 'children' && i != 'created' && i != 'lastChild' && i != 'links')
		{
			data[i] = source[i];
		}
	return Load(null, data);
}

module.exports = {
	baseObject: BaseObject,
	panel: Panel,
	group: Group,
	page: Page,
	subPage: SubPage,
	search: SearchContainer,
	load: Load,
	clone: Clone
};

var tree = require('./tree.js');
},{"../utils.js":11,"./tree.js":9}],9:[function(require,module,exports){
/**
 * Contains all operations for manipulating tree. Also emits events when modification occurs.
 * @module  tree
 */

var objects = require('./objects.js'),
	utils = require('../utils.js'),
	rss = require('../rss.js'),
	version = require('../version.js');

var debug = false;

// key-value container to store all tree objects
// format: 'guid': {object}
var data = {},
	root = null,
	panelRoot = null,
	linkRoot = null,
	unsortedLinks = null,
	curationFolders = null,
	curationRoot = null,
	rssRoot = null,
	tree = {};

var eventModified = utils.treeModifiedEvent;

/**
 * returns an object from tree by its GUID
 * @function getObject
 * @static
 * @param  {string | BaseObject} id
 * @return {BaseObject|null}
 */
tree.getObject = function(id)
{
	if (typeof(id) == 'object' && id !== null)
	{
		return id;
	}
	else if (typeof(id) == 'string')
	{
		return data[id];
	}
	return null;
}

/**
 * returns an object from tree strictly by its GUID
 * @function getByGUID
 * @static
 * @param  {string} guid
 * @return {BaseObject|null}
 */
tree.getByGUID = function(guid)
{
	return data[guid] || null;
}

/**
 * Gets all items of specified type in form of key-value pairs
 * @function getAllOfType
 * @static
 * @param  {string} type
 * @return {object} key-value pairs of objects
 */
tree.getAllOfType = function(type)
{
	var result = {};

	for (var i in data)
	{
		if (data.hasOwnProperty(i) && data[i].type == type)
		{
			result[i] = data[i];
		}
	}

	return result;
}

/**
 * Returns all items of specified type in form of array
 * @function getArrayOfType
 * @static
 * @param  {string} type
 * @return {BaseObject[]}
 */
tree.getArrayOfType = function(type)
{
	var result = [];

	for (var i in data)
	{
		if (data.hasOwnProperty(i) && data[i].type == type)
		{
			result.push(data[i]);
		}
	}

	return result;
}

/**
 * Returns number of items of certain type in tree
 * @function getCountOfType
 * @static
 * @param  {string} type
 * @return {number}
 */
tree.getCountOfType = function(type)
{
	var result = 0;
	for (var i in data)
	{
		if (data.hasOwnProperty(i) && data[i].type == type)
		{
			result++;
		}
	}
	return result;
}

/**
 * Gets subtree of main tree to display in tree view
 * @function getSubtree
 * @static
 * @param  {BaseObject | GUID} node - element or it's guid to get subtree of
 * @return {object}      root of subtree, usable for JSTree
 */
tree.getSubtree = function(node)
{
	node = this.getObject(node) || root;

	function traverse(path, node)
	{
		var n = {
			text: node.name,
			type: node.type,
			id: node.guid,
			path: '/' + node.name
		};

		if (node.children && node.children.length && node.type != 'page')
		{
			n.children = [];
			for (var i = 0; i < node.children.length; i++)
			{
				var c = tree.getObject(node.children[i]);
				n.children.push(traverse(n.path, c));
			}
		}

		return n;
	}

	var result = traverse('', node);

	return result;
}

/**
 * Gets list of children of node
 * @function getChildren
 * @static
 * @param  {BaseObject | GUID} node
 * @return {BaseObject[]}
 */
tree.getChildren = function(node)
{
	node = this.getObject(node);
	var result = [];
	for (var i = 0; i < node.children; i++)
	{
		result.push(getByGUID(node.children[i]));
	}
	return result;
}

/**
 * Sets given object as the last selected child of its parent
 * @function setLastChild
 * @static
 * @param {BaseObject} child object to be the last child
 * @param {boolean} [silent] flag to not fire update event
 */
tree.setLastChild = function(child, silent)
{
	var child = this.getObject(child),
		parent = this.getObject(child.parent);
	debug && console.log("[T] Setting last child " + child.name);
	if (!parent)
	{
		debug && console.log("[T] Problem with " + child.name + " (" + child.type + ")");
	}
	parent.lastChild = child.guid;

	if (!silent)
		utils.emitEvent(eventModified,
		{
			target: parent,
			type: 'update',
			properties: ['lastChild']
		});
}

/**
 * Sets "lastChild" property for all chain of panel/group/page hierarchy, so the specified node will be selected even if previously selected node was in another part of a tree
 * @function setDeepLastChild
 * @static
 * @param {GUID|BaseObject} child  an object to be selected
 * @param {boolean} [silent] flag to not fire an update event
 */
tree.setDeepLastChild = function(child, silent)
{
	child = this.getObject(child);
	var curr = child;
	while (curr.parent !== null)
	{
		this.setLastChild(curr, silent);
		curr = this.getObject(curr.parent, true);
	}
	/*if (!silent)
		utils.emitEvent(eventModified,
		{
			target: curr,
			type: 'update',
			properties: ['lastChild']
		});*/
}

/**
 * Returns currently selected node from panel tree of desired type
 * @param  {string} level one of node types: 'panel', 'group', 'page' or 'subpage'
 * @return {BaseObject}       selected node
 */
tree.getSelected = function(level)
{
	var node = panelRoot;
	while (node && node.type != level)
	{
		node = this.getObject(node.getLastChild());
	}
	return node;
}

function convertLinkToRSS(link)
{
	link.linkType = 'rss';
	var rsslink = objects.load(link.guid, link);
	console.log("CONVERTED WEB->RSS", rsslink);
	data[rsslink.guid] = rsslink;
}

function convertRSSToLink(rsslink)
{
	rsslink.linkType = 'web';
	var link = objects.load(rsslink.guid, rsslink);
	data[link.guid] = link;
}

tree.updateLinkRSSStatus = function(isRSS, url, guid)
{
	var node = tree.getObject(guid);
	console.log("[T] RSS checked", isRSS, node);
	// maybe it's deleted already
	if(!node)
		return;
	// maybe it's changed
	if(node.url !== url)
		return;
	var update = false;
	if(node.linkType != 'rss' && isRSS)
	{
		/*node.linkType = 'rss';
		node.domain = 'rss';
		node.local = true;
		var rsslink = tree.createLink(node, false, true);*/
		convertLinkToRSS(node);
		node = data[node.guid];
		tree.refreshRSSLink(node);
		update = true;
	}
	if(node.linkType == 'rss' && !isRSS)
	{
		/*node.linkType = 'web';
		node.local = false;
		var weblink = tree.createLink(node, false, true);*/
		convertRSSToLink(node);
		node = data[node.guid];
		update = true;
	}
	console.log("[T] RSS update", update);
	if(update)
	{
		utils.emitEvent(eventModified,
		{
			target: node,
			type: 'update',
			properties: ['linkType', 'local']
		});
		var subpages = tree.getArrayOfType('subpage');
		for(var i=0; i<subpages.length; i++) {
			var sp = tree.getObject(subpages[i]);
			if(sp.node == guid) 
			{
				console.log("[T] Update RSS subpage");
				tree.setSubpageToLink(sp, node);
			}
		}
		tree.setLastChild(tree.getSelected('subpage'));
	}
}

/**
 * Updates feed of rss link
 * @param  {Link} link a link to refresh
 */
tree.refreshRSSLink = function (link) 
{
	if(!link || link.linkType !== 'rss')
		return;
	console.log("[T] Refreshing link");
	rss.getFeed(link.url, function (data) 
	{
		console.log("[T] Got feed");
		var oldlinks = {};
		for(var i=0; i<link.links.length; i++)
			oldlinks[link.links[i]] = false;

		var added = 0,
			removed = 0;

		for(var i=0; i<data.posts.length; i++)
		{
			var add = true;
			for(var j=0; j<link.links.length; j++)
			{
				if(tree.getObject(link.links[j]).equal(data.posts[i]))
				{
					oldlinks[link.links[j]] = true;
					add = false;
				}
			}
			if(add)
			{
				data.posts[i].parent = link.guid;
				data.posts[i].read = false;
				var item = tree.createRSSLink(data.posts[i]);
				//console.log("REFRESH", data.posts[i].tags, item.tags);
				added++;
			}
		}
		for(var i in oldlinks)
		{
			if(oldlinks[i] == false)
			{
				tree.removeNode(i);
				removed++;
			}
		}

		var l = utils.getSetting('rssItemsCount', 'int', 0);
		while(l && link.links.length > l)
		{
			tree.removeNode(link.links[l]);
		}

		link.feedTitle = data.title;
		link.feedUrl = data.url;
		console.log("[RSS] Refreshed, added " + added + " removed " + removed);
		utils.emitEvent(utils.rssLoadedEvent, {
			target: link
		});
	});
}

/**
 * Updates properties of node and fires event about update
 * @function updateNodeInfo
 * @static
 * @param  {BaseObject} node
 * @param  {object} info   key-value pairs in format "property name": "property value"
 * @param  {boolean} [silent] flag to not fire an update event
 */
tree.updateNodeInfo = function(node, info, silent)
{
	node = this.getObject(node);
	if(node.type == 'root' || node.type == 'panelroot' || node.type == 'linkroot')
		return;

	var properties = [];
	for (var i in info)
		if (info.hasOwnProperty(i) && i != 'guid')
		{
			node[i] = info[i];
			properties.push(i);
		}

	if (node.type == 'link')
	{
		if(node.linkType == 'web' && !node.url)
		{
			node.linkType = 'folder';
			node.domain = 'folder';
			node.local = true;
		}
		if(node.linkType == 'folder' && node.url)
		{
			node.linkType = 'web';
			node.local = false;
		}

		if(properties.indexOf('url') > -1 && node.linkType == 'web') {
			var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
			try
			{
				var uri = ioService.newURI(node.url, null, null);
				node.domain = uri.host;
			}
			catch (e)
			{
				node.domain = node.url;
			}
		}

		if(properties.indexOf('url') > -1)
		{
			console.log("UPDATING RSS STATUS");
			rss.detectRSS(node.url, node.guid, this.updateLinkRSSStatus);
		}
		
		if(properties.indexOf('name') > -1) {
			var parent = this.getObject(node.parent);
			if (parent)
				parent.sortChildren();
		}
	}
	// this can happen if user created node. The node exists, but not appended to tree
	if (!data[node.guid])
	{
		debug && console.log("[T] Adding an updated node");
		this.addNode(node, null, silent);
	}
	if (!silent)
		utils.emitEvent(eventModified,
		{
			target: node,
			type: 'update',
			properties: properties
		});
}

/**
 * adds a node to tree and fires an event. For links it also sorts resulted tree
 * @function addNode
 * @static
 * @param {BaseObject} node   node to insert
 * @param {int} [position] index where to insert (adds to the end by default)
 * @param {boolean} [silent] flag to not fire an event
 */
tree.addNode = function(node, position, silent, doNotSwitch)
{
	data[node.guid] = node;
	if (node.parent)
	{
		debug && console.log("[T] Adding node ", node.name, node.guid, ", parent: ", node.parent);
		var index = this.getObject(node.parent).addChild(node.guid, position);
		debug && console.log("[T] Added node " + node.name + " at index " + index);
		node.level = this.getObject(node.parent).level + 1;
	}
	if (!silent)
		utils.emitEvent(eventModified,
		{
			target: node,
			type: 'add',
			data:
			{
				position: index,
				doNotSwitch: doNotSwitch
			}
		});
}

/**
 * Checks if link can be safely removed. For example, returns false is deleting link causes removing all of pages
 * @param  {Link} link   link to delete
 * @param  {bool} [silent] flag to not fire events for deleted page
 * @return {bool}        true if link can be safely deleted, false otherwise
 */
function canRemoveLink(link, silent)
{
	var allLinks = [];

	function traverse(node)
	{
		allLinks.push(node);
		for(var i=0; i<node.children.length; i++) 
		{
			traverse(tree.getObject(node.children[i]));
		}
	}

	traverse(link);

	var pages = tree.getArrayOfType('page');
	var toDelete = [];
	for(var i=0; i<allLinks.length; i++)
	{
		for(var j=0; j<pages.length; j++)
		{
			if(pages[j].link == allLinks[i].guid)
				toDelete.push(pages[j]);
		}
	}

	if(toDelete.length == pages.length)
	{
		alert("Can't delete all pages!");
		return false;
	}

	if(toDelete.length == 0)
		return true;

	if(Tabsmoz.promptLinkDelete(link, toDelete))
	{
		for(var i=0; i<toDelete.length; i++)
			tree.removeNode(toDelete[i], silent);
		return true;
	}

	return false;
}

/**
 * Removes specified node from tree with all its children.<br>
 * If removing a link, it will prompt user about deleting related pages.<br>
 * If removing a part of panel tree and this was the only child, then it removes parent too.<br>
 * @function removeNode
 * @static
 * @param  {BaseObject | GUID} node
 * @param  {boolean} [silent] flag to not fire an event
 * @return {null}
 */
tree.removeNode = function(node, silent)
{
	node = this.getObject(node) || node;
	var topNode = node;
	var self = this;

	if(node.type == 'search')
	{
		delete data[node.guid];
		return;
	}

	if (node.type == 'page')
	{
		var group = this.getObject(node.parent);
		if (group && group.children.length == 1)
		{
			if (utils.getSetting('warnLastPage', 'bool') && !Tabsmoz.warnings.lastPage())
				return;
		}
	}

	if (node.type == 'group' && node.children.length > 0)
	{
		if (utils.getSetting('warnDeleteGroup', 'bool') && !Tabsmoz.warnings.group())
			return;
	}

	if (node.type == 'panel' && node.children.length > 0)
	{
		if (utils.getSetting('warnDeletePanel', 'bool') && !Tabsmoz.warnings.panel())
			return;
	}

	if (node.type == 'link')
	{
		if(!canRemoveLink(node, silent))
			return;
	}

	var targetNode = node;

	function remove(node)
	{
		// the trick: node itself can be not in tree, but its children are.
		var node = self.getObject(node) || node;

		debug && console.log("[T] Deleting node ", node.type, node.name);

		if (node.children && node.children.length)
		{
			while (node.children.length)
			{
				remove(node.children[0]);
			}
		}

		// additionally delete all curationlinks from curation folder
		if (node.type == 'link' && node.linkType == 'curation')
		{
			for(var i=0; i<node.links.length; i++)
				self.removeNode(node.links[i]);
		}

		var parent = self.getObject(node.parent);
		if (parent)
		{
			if (parent.level < topNode.level)
				topNode = parent;
			var index = parent.children.indexOf(node.guid);
			if (parent.children.length > 1 && parent.lastChild == node.guid)
			{
				if (index > 0)
					parent.lastChild = parent.children[index - 1];
				else
					parent.lastChild = parent.children[0];

				debug && console.log("[T] Setting lastchild ", self.getObject(parent.lastChild).name);
			}
			if (parent.children.length == 1 && node.type == 'subpage' && targetNode.type == 'subpage')
			{
				if (!self.switchToPreviousPage(parent, true))
					topNode = self.getSelected('panel');
				else
					topNode = self.getObject(parent.parent);
			}
			parent.removeChild(node.guid);
		}
		delete data[node.guid];
		if (!silent)
		{
			utils.emitEvent(eventModified,
			{
				target: node,
				type: 'delete'
			});
		}

		if (parent && (parent.type == 'panel' || parent.type == 'group') && parent.children.length == 0)
		{
			remove(parent);
		}
	}

	remove(node);

	debug && console.log("[T] Removed node, topnode: ", topNode.name);

	if (!silent)
	{
		utils.emitEvent(eventModified,
		{
			target: topNode,
			type: 'update',
			properties: ['lastChild']
		})
	}
}

/**
 * Swaps two sibling in terms of tabs (first node inserted between second and a node adjacent to second).<br>
 * If nodes belongs to different parents, function moves first node to second and then performs swap.
 * @function swapNodes
 * @static
 * @see BaseObject.swapChildren
 * @param  {BaseObject|GUID} node1
 * @param  {BaseObject|GUID} node2
 */
tree.swapNodes = function(node1, node2)
{
	node1 = this.getObject(node1);
	node2 = this.getObject(node2);
	debug && console.log("[T] Swap. Same parent: (" + node1.name + ", " + node2.name + ", " + node1.parent + ", " + node2.parent);
	if (node1.type == node2.type && node1.parent == node2.parent)
	{
		var node = this.getObject(node1.parent);
		node.swapChildren(node1, node2);
		utils.emitEvent(eventModified,
		{
			target: node,
			type: 'update',
			properties: ['swap'],
			data:
			{
				c1: node1.guid,
				c2: node2.guid
			}
		});
	} else {
		// nodes are from different parents. That's not very good, but we'll deal with it.
		if(this.getObject(node1.parent).type == this.getObject(node2.parent).type) {
			tree.moveSubtree(node1, this.getObject(node2.parent));
			this.swapNodes(node1, node2);
		}
	}
}

/**
 * Switches open/closed state for a node. Used by a tree view
 * @function toggleOpen
 * @static
 * @param  {BaseObject|GUID} node
 * @param  {boolean} [state] desired state of a node. If undefined, just toggles the current state
 */
tree.toggleOpen = function(node, state)
{
	node = this.getObject(node);
	if (state === undefined)
		node.open = !node.open;
	else
		node.open = state;
	utils.emitEvent(eventModified,
	{
		target: node,
		type: 'update',
		properties: ['open']
	});
}

/**
 * Creates new node and tries to guess its type from data. Basically you can just pass existing node as a parameter, but don't forget to remove 'id' property.
 * @function createNode
 * @static
 * @param  {object} data        key-value pairs of properties. The same as in type of node you want to create
 * @param  {boolean} [doNotInsert] indicates that new node shouldn't be inserted into tree (for example when it is just created by user)
 * @return {Link|Panel|Group|Page}             
 */
tree.createNode = function(data, doNotInsert)
{
	switch (data.type)
	{
		case 'link':
			return this.createLink(data, doNotInsert);
			break;
		case 'curationlink':
			return this.createCurationLink(data, doNotInsert);
			break;
		case 'rsslink':
			return this.createRSSLink(data, doNotInsert);
			break;
		case 'panel':
			return this.createPanel(data, doNotInsert);
			break;
		case 'group':
			return this.createGroup(data, doNotInsert);
			break;
		case 'page':
			return this.createPage(data, doNotInsert);
			break;
		case 'curationfile':
			return this.createCurationFile(data, doNotInsert);
			break;
		case 'curationgroup':
			return this.createCurationGroup(data, doNotInsert);
			break;
		case 'curationpage':
			return this.createCurationPage(data, doNotInsert);
			break;
	}
}

/**
 * Creates new panel with given data, and a new group inside of it
 * @function createPanel
 * @static
 * @param  {object} data key-value pairs of initial properties
 * @param {boolean} [doNotInsert] indicates that new node shouldn't be inserted into tree (for example when it is just created by user)
 * @return {BaseObject} panel
 */
tree.createPanel = function(data, doNotInsert)
{
	var name = data.name || "",
		group = data.group || null;

	var panel = objects.load(null,
	{
		parent: panelRoot.guid,
		type: 'panel',
		tags: data.tags,
		name: name,
		level: 2,
		comment: data.comment || ""
	});

	debug && console.log("[T] Creating panel 1: ", panelRoot.guid, panel.parent);

	if (!doNotInsert)
	{
		this.addNode(panel);

		if (!group)
		{
			group = tree.createGroup(
			{
				parent: panel.guid,
				name: "New Group",
				url: data.url,
				link: data.link || linkRoot.guid,
				pagename: "New page"
			});
		}

		// dirty hack :(
		this.setLastChild(panel);
	}

	return panel;
}

/**
 * Creates new group with given data, and a new page inside of it
 * @function createGroup
 * @static
 * @param  {object} data key-value pairs of initial properties
 * @param {boolean} [doNotInsert] indicates that new node shouldn't be inserted into tree (for example when it is just created by user)
 * @return {BaseObject}      group
 */
tree.createGroup = function(data, doNotInsert)
{
	var name = data.name || "",
		parent = data.parent || null,
		page = data.page || null;

	var group = objects.load(null,
	{
		parent: parent,
		type: 'group',
		name: name,
		tags: data.tags,
		level: 3,
		comment: data.comment || ""
	});

	if (!doNotInsert)
	{
		this.addNode(group);
		//console.log("[T] Creating group, url " + data.url);
		console.log("[T] Creating group", data.link, data.url, data.pagename);
		if (!page)
		{
			page = this.createPage(
			{
				parent: group.guid,
				url: data.url || null,
				link: data.link || (data.url ? null : linkRoot.guid),
				name: data.pagename ? data.pagename : tree.getObject(data.link).name
			});
		}
	}

	return group;
}

/**
 * Creates new page with given data, and a new link if page created from url
 * @function createPage
 * @static
 * @param  {object} data key-value pairs with properties
 * @param {boolean} [doNotInsert] indicates that new node shouldn't be inserted into tree (for example when it is just created by user)
 * @return {BaseObject}      page
 */
tree.createPage = function(data, doNotInsert)
{
	var name = data.name || null,
		parent = data.parent || null,
		link = data.link || null;

	if (link && !name)
	{
		name = this.getObject(link).name;
	}
	if (!link && !name)
	{
		name = "";
	}

	var page = objects.load(null,
	{
		parent: parent,
		type: 'page',
		name: name,
		link: link,
		tags: data.tags,
		level: 4,
		comment: data.comment || ""
	});

	if (!link)
	{
		if (data.url)
		{
			console.log("[T] Creating link for page, url " + data.url);
			var link = this.createLink(
			{
				name: name,
				url: data.url
			});
		}
		else
		{
			var link = unsortedLinks;
		}
		page.link = link.guid;
		utils.emitEvent(eventModified,
		{
			target: page,
			type: 'update',
			properties: ['link']
		});
	}

	if (!doNotInsert)
		this.addNode(page);

	return page;

	/*if(data.select) {
		this.setLastChild(page);
	}*/
}

/**
 * Creates new link with given data
 * @function createLink
 * @static
 * @param  {object} data key-value pairs with properties
 * @param {boolean} [doNotInsert] indicates that new node shouldn't be inserted into tree (for example when it is just created by user)
 * @param {boolean} [skipRSSCheck] flag to not check rss status of link - by default all links are tested when created
 * @return {BaseObject}      link
 */
tree.createLink = function(data, doNotInsert, skipRSSCheck)
{
	var parent = data.parent || unsortedLinks.guid,
		url = data.url || "",
		linkType = data.linkType || "web",
		name = data.name || "";

	var link = objects.load(null,
	{
		parent: parent,
		type: 'link',
		linkType: linkType,
		tags: data.tags,
		url: url,
		name: name,
		level: this.getObject(parent).level,
		comment: data.comment || ""
	});

	if (!doNotInsert) {
		if(!skipRSSCheck && link.url !== '' && link.url.indexOf('about:') < 2)
			rss.detectRSS(link.url, link.guid, this.updateLinkRSSStatus);
		this.addNode(link);
	}

	return link;
}

/**
 * Creates new curation link with given data
 * @static
 * @param  {object} data key-value pairs with properties
 * @param {boolean} [doNotInsert] indicates that new node shouldn't be inserted into tree (for example when it is just created by user)
 * @return {BaseObject}      curation link
 */
tree.createCurationLink = function(data, doNotInsert)
{
	var parent = data.parent || null,
		url = data.url || "",
		headline = data.headline || "";

	if (!parent)
	{
		debug && console.log("[T] CurationLinks must have parent");
		return null;
	}
	var link = objects.load(null,
	{
		parent: parent,
		type: 'curationlink',
		url: url,
		publisher: data.publisher,
		description: data.description,
		date: data.date,
		pubDate: data.pubDate,
		author: data.author,
		rating: data.rating ,
		headline: data.headline,
		imageUrl: data.imageUrl,
		pubType: data.pubType,
		tags: data.tags,
		twitter: data.twitter
	});

	if (!doNotInsert)
		this.addNode(link);

	return link;
}

/**
 * Creates new rss link with given data
 * @static
 * @param  {object} data key-value pairs with properties
 * @param {boolean} [doNotInsert] indicates that new node shouldn't be inserted into tree (for example when it is just created by user)
 * @return {BaseObject}      rss link
 */
tree.createRSSLink = function (data, doNotInsert) 
{
	var link = objects.load(null,
	{
		parent: data.parent || null,
		type: 'rsslink',
		url: data.url,
		title: data.title,
		author: data.author,
		pubDate: data.pubDate,
		content: data.content,
		tags: data.tags,
		img: data.img
	});

	//console.log("[T] TAGS", link.tags);

	if(!doNotInsert)
		this.addNode(link);

	return link;
}

/**
 * Creates new curation file with given data
 * @static
 * @param  {object} data key-value pairs with properties
 * @param {boolean} [doNotInsert] indicates that new node shouldn't be inserted into tree (for example when it is just created by user)
 * @return {BaseObject}      curation file
 */
tree.createCurationFile = function(data, doNotInsert)
{
	var parent = curationRoot.guid,
		name = data.name || '';

	var node = objects.load(null,
	{
		type: 'curationfile',
		parent: parent,
		level: 2,
		name: name,
		tags: data.tags,
		comment: data.comment || '',
		author: data.author || '',
		publisher: data.publisher || ''
	})
	if(!doNotInsert)
		this.addNode(node);
	return node;
}

/**
 * Creates new curation group with given data
 * @static
 * @param  {object} data key-value pairs with properties
 * @param {boolean} [doNotInsert] indicates that new node shouldn't be inserted into tree (for example when it is just created by user)
 * @return {BaseObject}      curation group
 */
tree.createCurationGroup = function(data, doNotInsert)
{
	var parent = data.parent || '',
		name = data.name || '';

	var node = objects.load(null,
	{
		type: 'curationgroup',
		parent: parent,
		level: 3,
		tags: data.tags,
		name: name,
		comment: data.comment || ''
	})
	if(!doNotInsert)
		this.addNode(node);
	return node;
}


/**
 * Creates new curation page with given data
 * @static
 * @param  {object} data key-value pairs with properties
 * @param {boolean} [doNotInsert] indicates that new node shouldn't be inserted into tree (for example when it is just created by user)
 * @return {BaseObject}      curation page
 */
tree.createCurationPage = function(data, doNotInsert)
{
	var parent = data.parent || '',
		link = data.link || null,
		name = data.name || '';

	var node = objects.load(null,
	{
		type: 'curationpage',
		parent: parent,
		link: link,
		level: 4,
		tags: data.tags,
		name: name,
		comment: data.comment || ''
	})
	if(!doNotInsert)
		this.addNode(node);
	return node;
}

/**
 * Implements complex selection of page when selected one is closed. Tries to select closest page with opened subpages, and there are no such pages, selects the first page in first group in selected panel.<br>
 * Does not emit events by itself. 
 * @param  {Page} page
 * @param {bool} silent
 * @return {bool} true if new page is found in the same group, false otherwise
 */
tree.switchToPreviousPage = function(page, silent)
{
	//console.log("[T] switchToPreviousPage");
	var group = this.getObject(page.parent);
	if (page.guid !== this.getSelected('page').guid)
		return true;
	var idx = group.children.indexOf(page.guid);
	var newPage = null;
	// scan backwards
	for (var i = idx - 1; i >= 0; i--)
	{
		newPage = this.getObject(group.children[i]);
		if (newPage.children.length)
		{
			debug && console.log("[T] Switching: found page before");
			break;
		}
		else
		{
			newPage = null;
		}
	}
	// scan forward
	if (!newPage)
	{
		for (var i = idx + 1; i < group.children.length; i++)
		{
			newPage = this.getObject(group.children[i]);
			if (newPage.children.length)
			{
				debug && console.log("[T] Switching: found page after");
				break;
			}
			else
			{
				newPage = null;
			}
		}
	}
	// no other pages :( select first one
	if (!newPage)
	{
		var panel = this.getSelected('panel');
		group = this.getObject(panel.children[0]);
		newPage = this.getObject(group.children[0]);
		this.setDeepLastChild(newPage, silent);
		debug && console.log("[T] Switching: selected first page in group " + group.name);
		return false;
	}
	else
	{
		this.setLastChild(newPage, silent);
		return true;
	}
}

/**
 * Closes (not deletes) page tab. Sets "closed" attribute and deletes all children subpages
 * @function closePage
 * @static
 * @param  {Page|GUID} page
 */
tree.closePage = function(page)
{
	page = this.getObject(page);
	var group = this.getObject(page.parent);

	if (page.guid == group.lastChild)
	{
		this.switchToPreviousPage(page);
	}

	while (page.children.length > 0)
	{
		debug && console.log("[T] Closing page, ", this.getObject(page.children[0]).name);
		this.removeNode(page.children[0]);
	}
}

/**
 * Closes all opened pages in group
 * @param  {Group} group 
 */
tree.closeGroup = function (group) 
{
	group = this.getObject(group);
	var page = group.getLastChild();
	for(var i=0; i<group.children.length; i++) 
	{
		if(page != group.children[i])
			this.closePage(group.children[i]);
	}
	this.closePage(page);
}

/**
 * Returns subtree of a given tree, based on selection
 * @param  {BaseObject} rootNode   root of exported subtree
 * @param  {object} selection  list of nodes to export, format "guid: true/false"
 * @param  {object} [sourceData] raw node list to use as a source. Current tree data by default
 * @return {object} raw node list, format "guid: BaseObject"
 */
tree.exportSubtree = function(rootNode, selection, sourceData)
{
	sourceData = sourceData || data;
	var systemFolders = {};
	for(var i in sourceData)
	{
		switch(sourceData[i].type)
		{
			case 'root': systemFolders.root = sourceData[i]; break;
			case 'panelroot': systemFolders.panelRoot = sourceData[i]; break;
			case 'curationroot': systemFolders.curationRoot = sourceData[i]; break;
			case 'linkroot': 
				switch(sourceData[i].system) {
					case 'root': systemFolders.linkRoot = sourceData[i]; break;
					case 'unsorted': systemFolders.unsortedLinks = sourceData[i]; break;
					case 'curation': systemFolders.curationFolders = sourceData[i]; break;
					case 'rss': systemFolders.rssRoot = sourceData[i]; break;
				}
				break;
		}
	}

	function clone(source)
	{
		var data = {};
		for (var i in source)
			if (source.hasOwnProperty(i) && i != 'children' && i != 'lastChild')
			{
				data[i] = source[i];
			}
		return objects.load(data.guid, data);
	}

	function o(guid)
	{
		return newData[guid] || null;
	}

	function s(guid)
	{
		return sourceData[guid] || null;
	}

	var newData = {};
	newData[systemFolders.root.guid] = systemFolders.root;
	newData[systemFolders.panelRoot.guid] = clone(systemFolders.panelRoot);
	newData[systemFolders.linkRoot.guid] = clone(systemFolders.linkRoot);
	newData[systemFolders.unsortedLinks.guid] = clone(systemFolders.unsortedLinks);
	newData[systemFolders.curationFolders.guid] = clone(systemFolders.curationFolders);
	newData[systemFolders.curationRoot.guid] = clone(systemFolders.curationRoot);
	newData[systemFolders.rssRoot.guid] = clone(systemFolders.rssRoot);

	o(systemFolders.linkRoot.guid).addChild(systemFolders.unsortedLinks.guid);
	o(systemFolders.linkRoot.guid).addChild(systemFolders.curationFolders.guid);
	o(systemFolders.linkRoot.guid).addChild(systemFolders.rssRoot.guid);

	function addLink(guid)
	{
		var orig = sourceData[guid];
		var cascade = [];
		while(orig.type != 'linkroot')
		{
			cascade.push(orig.guid);
			orig = s(orig.parent);
		}
		while(cascade.length > 0)
		{
			orig = s(cascade.pop());
			if(o(orig.guid) == null)
			{
				newData[orig.guid] = clone(orig);
				newData[orig.parent].addChild(orig.guid);

				if(orig.linkType == 'rss' || orig.linkType == 'curation')
				{
					for(var i=0; i<orig.links.length; i++)
					{
						newData[orig.links[i]]= clone(s(orig.links[i]));
					}
				}
			}
		}
	}

	function extendSelection(guid)
	{
		if(selection[guid])
		{
			var orig = s(guid)
			var node = newData[guid] || clone(orig);
			newData[guid] = node;
			if(!o(node.parent))
			{
				console.log("Error in export", node);
				return;
			}
			o(node.parent).addChild(node.guid);
			if(node.type == 'page')
			{
				addLink(node.link);
			} else {
				for(var i=0; i<orig.children.length; i++)
					extendSelection(orig.children[i]);
			}
		}
	}

	extendSelection(rootNode.guid);

	return {
		data: newData,
		system: systemFolders
	};
}

/**
 * Imports selected nodes from external tree and reloads tree
 * @param  {object} newData   raw data list of nodes
 * @param  {object} selection list of nodes to export, format "guid: true/false"
 */
tree.importSubtree = function(newData, selection)
{
	var rootNode = null;
	for(var i in newData)
	{
		if(newData[i].type == 'panelroot')
		{
			rootNode = newData[i];
			break;
		}
	}
	//console.log(rootNode);
	var imported = tree.exportSubtree(rootNode, selection, newData);
	var idata = imported.data;
	// now loop through all nodes, replace guids and insert them in tree
	var guidMap = {}; // { oldGuid: newGuid }

	function getLocalSystemFolder(node)
	{
		switch(node.type)
		{
			case 'root': return root.guid; break;
			case 'panelroot': return panelRoot.guid; break;
			case 'linkroot': 
				switch(node.system)
				{
					case 'root': return linkRoot.guid; break;
					case 'unsorted': return unsortedLinks.guid; break;
					case 'rss': return rssRoot.guid; break;
					case 'curation': return curationFolders.guid; break;
				}
				break;
		}
		return node.guid;
	}

	/**
	 * Clones src and copies it under dst
	 * @param  {BaseObject} src node in imported tree
	 * @param  {BaseObject} dst node in local tree
	 */
	function importNode(src, dst)
	{
		if(!src) 
			return;
		var clone = objects.clone(src);
		clone.guid = src.guid;
		var target = getLocalSystemFolder(clone);
		guidMap[src.guid] = target;
		
		clone.parent = dst.guid;

		if(clone.type == 'page')
		{
			clone.link = guidMap[clone.link];
		}

		if(clone.guid == target) // not a system folder
		{
			if(data[src.guid])
			{
				// overwrite
				console.log("[T] Overwrite: " + clone.name + " " + clone.type);
				var c = {};
				for(var i in clone)
					if(i != 'children' && i != 'links')
						c[i] = clone[i];
				tree.updateNodeInfo(c.guid, c);
			} else {
				// add
				// console.log("[T] Import: " + clone.name + " " + clone.type);
				tree.addNode(clone, undefined, false, true);
			}
		} else {
			clone.guid = target;
		}

		for(var i=0; i<src.children.length; i++)
		{
			importNode(idata[src.children[i]], clone);
		}

		if(src.links)
		{
			for(var i=0; i<src.links.length; i++)
			{
				importNode(idata[src.links[i]], clone);
			}
		}
	}
	// links first
	importNode(imported.system.linkRoot, root);

	importNode(imported.system.panelRoot, root);
}

/**
 * copies a part of tree to another part of tree
 * @function copySubtree
 * @static
 * @param  {BaseObject} source      root of a subtree to copy
 * @param  {BaseObject} destination parent of a new subtree
 */
tree.copySubtree = function(source, destination)
{
	// check if destination is not a subtree of source
	var node = destination;
	while (node != null)
	{
		if (node.guid == source.guid)
		{
			alert("Cannot copy node to it's subtree!");
			return;
		}
		node = this.getObject(node.parent);
	}

	var self = this;
	var topNode = null;
	function traverse(src, dst)
	{
		var clone = objects.clone(src);
		clone.parent = dst.guid;
		if(clone.type == 'curationlink' && src.parent == dst.guid)
		{
			clone.headline += ' copy';
		}
		if(!topNode)
			topNode = clone;
		self.addNode(clone, undefined, false, true);
		if(src.type == 'page')
		{
			return;
		}
		for (var i = 0; i < src.children.length; i++)
		{
			traverse(self.getObject(src.children[i]), clone);
		}
		if (src.links)
			for (var i = 0; i < src.links.length; i++)
			{
				traverse(self.getObject(src.links[i]), clone);
			}
	}

	traverse(source, destination);
	if(topNode.type == 'group')
		tree.setLastChild(topNode);
}

/**
 * moves a part of tree to another place in tree. <br>
 * Though it not really removes all nodes of moved subtree and reassembling them in new place, function does emit 'delete' and 'add' events for every node of subtree for UI synchronization
 * @function moveSubtree
 * @static
 * @param  {BaseObject} source      root of a subtree to move
 * @param  {BaseObject} destination new parent of moved subtree
 */
tree.moveSubtree = function(source, destination)
{
	if(source.guid == destination.guid || source.parent == destination.guid)
	{
		return;
	}
	// check if destination is not a subtree of source
	var node = destination;
	while (node != null)
	{
		if (node.guid == source.guid)
		{
			alert("Cannot move node to it's subtree!");
			return;
		}
		node = this.getObject(node.parent);
	}

	var self = this;

	function traverse(node, type)
	{
		var data = {};
		if (type == 'add') {
			node.level = self.getObject(node.parent).level + 1;
			data = {
				position: self.getObject(node.parent).children.indexOf(node.guid),
				doNotSwitch: true
			}
		}
		utils.emitEvent(eventModified,
		{
			target: node,
			type: type,
			data: data
		});
		if(node.type !== 'page')
			for (var i = 0; i < node.children.length; i++)
				traverse(self.getObject(node.children[i]), type);
	}

	/*if(this.getCountOfType(source.type) == 1)
		return;*/

	var parent = this.getObject(source.parent);
	if(parent.children.length == 1 && parent.type == 'group') {
		if(!Tabsmoz.warnings.lastPage())
			return;
	}
	parent.removeChild(source);
	if(parent.children.length == 0 && (parent.type == 'panel' || parent.type == 'group')) {
		this.removeNode(parent);
	}

	traverse(source, 'delete');

	destination.addChild(source);
	source.parent = destination.guid;

	traverse(source, 'add');

	if( (source.type == 'group' || source.type == 'page'))
	{
		this.setDeepLastChild(source);
	}
}

/**
 * Sets subpage's url to url of a link
 * @function setSubpageToLink
 * @static
 * @param {BaseObject|GUID} subpage
 * @param {BaseObject|GUID} link
 */
tree.setSubpageToLink = function(subpage, link)
{
	subpage = this.getObject(subpage);
	link = this.getObject(link);
	subpage.url = link.url === undefined ? subpage.url : link.url;
	if(link.local)
		subpage.url = 'about:blank';
	subpage.name = link.name;
	subpage.urlUpdate = true;
	subpage.local = link.local === undefined ? true : link.local;
	subpage.node = link.guid;

	//console.log("[T] Setting subpage to link " + link.name + " " + link.local);

	utils.emitEvent(eventModified,
	{
		target: subpage,
		type: 'update',
		properties: ['url', 'name', 'local', 'node']
	});
}

/**
 * Selects first subpage in page and sets it's url to link
 * @function openLinkInPage
 * @static
 * @param  {BaseObject|GUID} page
 * @param  {BaseObject|GUID} link
 */
tree.openLinkInPage = function(page, link)
{
	page = this.getObject(page);
	link = this.getObject(link);
	if (page && link && page.children.length)
	{
		this.setSubpageToLink(page.children[0], link);
		this.setLastChild(page.children[0]);
	}
}

/**
 * Updates all feeds in link tree. Used on launch
 */
function updateRSSFolders()
{
	var folders = tree.getArrayOfType('link');
	for(var i=0; i<folders.length; i++)
	{
		if(folders[i].linkType == 'rss' && folders[i].links.length == 0)
			tree.refreshRSSLink(folders[i]);
	}
}

/**
 * Returns user to main subpage of the page and sets it's url to url of the page's link
 * @function resetPage
 * @static
 * @param  {BaseObject|GUID} id page ot reset
 * @param {boolean} [soft] if true, defines that we shouldn't select first temp page
 */
tree.resetPage = function(id, soft)
{
	var page = this.getObject(id),
		subpage = this.getObject(page.children[0]),
		link = this.getObject(page.link);

	if(!subpage)
		return;

	if(!soft)
		this.setLastChild(subpage);

	this.setSubpageToLink(subpage, link);
}

/**
 * Parses previously saved data from JSON
 * @function loadJSON
 * @static
 * @param  {string} data JSON data
 * @param {bool} [forgetLast] clear lastChild property for default start
 * @param {bool} [doNotApply] don't load as main tree and just return prepared data. Used for import
 * @param {Function} [getString] function for getting strings by id for localization of system folder names. Optional.
 */
tree.loadJSON = function(jsonData, forgetLast, doNotApply, getString)
{
	forgetLast = utils.getSetting("onStartup", "string") || "normal";

	getString = getString || function(id) {
		var map = {
			'oaff.panelroot.label': 'Portal tree',
			'oaff.linkroot.label': 'Optimal Bookmark',
			'oaff.curationroot.label': 'Curation tree',
			'oaff.panelroot.label': 'Portal root',
			'oaff.curationfolders.label': 'Curation folders',
			'oaff.rssfolders.label': 'RSS Bookmarks',
			'oaff.unsorted.label': 'Unsorted Bookmarks'
		};
		return map[id];
	}

	try
	{
		var newData = {};
		json = JSON.parse(jsonData);
		//console.log("[T] JSON parsed");
		json.version = json.version || 1;
		var systemFolders = {};
		systemFolders.root = null;
		systemFolders.panelRoot = null;
		systemFolders.linkRoot = null;
		systemFolders.unsortedLinks = null;
		systemFolders.curationFolders = null;
		for (var i in json.data)
		{
			if (json.data.hasOwnProperty(i) && json.data[i].type !== 'subpage' && json.data[i].type !== 'search')
			{
				newData[i] = objects.load(i, json.data[i]);
				if (forgetLast == "normal")
					newData[i].lastChild = null;
				switch (json.data[i].type)
				{
					case 'root':
						systemFolders.root = newData[i];
						systemFolders.root.name = "Optimal Access";
						break;
					case 'panelroot':
						systemFolders.panelRoot = newData[i];
						break;
					case 'linkroot':
						if(json.version < 2) {
							// linkroot
							if(newData[i].level == 1)
							{
								systemFolders.linkRoot = newData[i];
								systemFolders.linkRoot.url = utils.getOAPage(); //utils.getHomePage();
								systemFolders.linkRoot.linkType = 'folder';
								systemFolders.linkRoot.local = true;
								systemFolders.linkRoot.name = "Optimal Bookmark";
								systemFolders.linkRoot.system = "root";
							} else {
								systemFolders.unsortedLinks = newData[i];
								systemFolders.unsortedLinks.url = ""; //utils.getHomePage();
								systemFolders.unsortedLinks.linkType = 'folder';
								systemFolders.unsortedLinks.local = true;
								systemFolders.unsortedLinks.name = "​Unsorted Bookmarks";
								systemFolders.unsortedLinks.system = "unsorted";
							}
						}
						if (newData[i].system == 'root')
						{
							systemFolders.linkRoot = newData[i];
							systemFolders.linkRoot.url = utils.getOAPage();
							systemFolders.linkRoot.linkType = 'web';
							systemFolders.linkRoot.local = false;
							systemFolders.linkRoot.name = "Optimal Bookmark";
							systemFolders.linkRoot.system = "root";
						}
						if (newData[i].system == 'unsorted')
						{
							systemFolders.unsortedLinks = newData[i];
							systemFolders.unsortedLinks.url = ""; //utils.getHomePage();
							systemFolders.unsortedLinks.linkType = 'folder';
							systemFolders.unsortedLinks.local = true;
							systemFolders.unsortedLinks.name = "​Unsorted Bookmarks";
							systemFolders.unsortedLinks.system = "unsorted";
						}
						if (newData[i].system == 'curation')
						{
							//console.log("[T] Curation root!");
							systemFolders.curationFolders = newData[i];
							systemFolders.curationFolders.url = ""; //utils.getHomePage();
							systemFolders.curationFolders.linkType = 'folder';
							systemFolders.curationFolders.local = true;
							systemFolders.curationFolders.name = "​Curation Folders";
							systemFolders.curationFolders.system = "curation";
						}
						if (newData[i].system == 'rss')
						{
							systemFolders.rssRoot = newData[i];
							systemFolders.rssRoot.url = ""; //utils.getHomePage();
							systemFolders.rssRoot.linkType = 'folder';
							systemFolders.rssRoot.local = true;
							systemFolders.rssRoot.name = "RSS Bookmarks";
							systemFolders.rssRoot.system = "rss";
						}
						break;
					case 'curationroot':
						systemFolders.curationRoot = newData[i];
						systemFolders.curationRoot.name = "Curation Root";
						systemFolders.curationRoot.level = 1;
						break;
					case 'page':
						newData[i].children = [];
						break;
				}
			}
		}
		//console.log("[T] Check: ", root, linkRoot);
		// backward compatibility!
		if(!systemFolders.curationRoot || json.version < 3)
		{
			var cr = objects.load(null, {
				"type": "curationroot",
				"parent": systemFolders.root.guid,
				"name": "Curation Root",
				"open": false,
				"children": [],
				"level": 1
			});
			newData[cr.guid] = cr;
			systemFolders.curationRoot = cr;
			systemFolders.root.children.push(cr.guid);
		}
		if(!systemFolders.rssRoot || json.version < 4)
		{
			var rr = objects.load(null, {
				"type": "linkroot",
				"parent": systemFolders.linkRoot.guid,
				"name": "RSS Bookmarks",
				"open": false,
				"children": [],
				"level": 2,
				"system": "rss",
				"linktype": "folder",
				"url": ""
			});
			newData[rr.guid] = rr;
			systemFolders.rssRoot = rr;
			systemFolders.linkRoot.children.push(rr.guid);
		}
		if(!systemFolders.curationFolders)
		{
			//console.log("[T] Adding curation folders!");
			var cf = objects.load(null, {
				"type": "linkroot",
				"linktype": "folder",
				"parent": systemFolders.linkRoot.guid,
				"name": "​Curation Folders",
				"system": "curation",
				"level": 2,
				"open": false,
				"url": "",
				"children": []
			});
			//console.log("[T] CF Created!", cf);
			newData[cf.guid] = cf;
			systemFolders.curationFolders = cf;
			systemFolders.linkRoot.children.push(cf.guid);
			systemFolders.curationFolders.url = utils.getHomePage();
			systemFolders.curationFolders.name = "​Curation Folders";
		}

		systemFolders.panelRoot.name = getString('oaff.panelroot.label');
		systemFolders.linkRoot.name = getString('oaff.linkroot.label');
		systemFolders.curationRoot.name = getString('oaff.curationroot.label');
		systemFolders.panelRoot.name = getString('oaff.panelroot.label');
		systemFolders.curationFolders.name = getString('oaff.curationfolders.label');
		systemFolders.rssRoot.name = getString('oaff.rssfolders.label');
		systemFolders.unsortedLinks.name = getString('oaff.unsorted.label');

		if(doNotApply)
		{
			return newData;
		} else {
			root = systemFolders.root;
			panelRoot = systemFolders.panelRoot;
			linkRoot = systemFolders.linkRoot;
			unsortedLinks = systemFolders.unsortedLinks;
			curationFolders = systemFolders.curationFolders;
			curationRoot = systemFolders.curationRoot;
			rssRoot = systemFolders.rssRoot;
			//console.log(panelRoot, systemFolders.panelRoot);
			data = newData;
			updateRSSFolders();
		}
	}
	catch (e)
	{
		console.log("[T] ERROR", e)
		alert("Invalid data file");
	}
}

/**
 * returns tree data in JSON form
 * @function serializeJSON
 * @static
 * @param {object} [externalData] parameter to override loaded data with somethin other. Used for exporting
 * @return {string} JSON-encoded data
 */
tree.serializeJSON = function(externalData)
{
	var tree = {};
	if(externalData)
	{
		tree = externalData;
	}
	else
	{
		var node, parent;
		for (var i in data)
		{
			node = this.getObject(i);
			if (node.parent)
			{
				parent = this.getObject(node.parent);
				if (parent && node.type != 'subpage')
				{
					tree[i] = utils.clone(node);
					if (node.type == 'page')
					{
						tree[i].children = [];
						tree[i].lastChild = null;
					}
				}
			}
			else
			{
				if(node.type != 'search')
					tree[i] = node;
			}
		}
	}
	return JSON.stringify(
	{
		extensionVersion: version.extVersion,
		version: version.fileVersion,
		data: tree
	});
}

/**
 * Returns raw tree data
 * @function getData
 * @static
 * @return {object} tree data in format "GUID": "BaseObject"
 */
tree.getData = function()
{
	return data;
};

/**
 * Returns root node of a tree
 * @function getRoot
 * @static
 * @return {BaseObject} root
 */
tree.getRoot = function()
{
	return root;
};

/**
 * Returns root of panel tree
 * @function getPanelRoot
 * @static
 * @return {BaseObject} root of panel tree
 */
tree.getPanelRoot = function()
{
	return panelRoot;
};

/**
 * Returns root of a link tree
 * @function getLinkRoot
 * @static
 * @return {BaseObject} root of link tree
 */
tree.getLinkRoot = function()
{
	return linkRoot;
};

tree.getUnsorted = function()
{
	return unsortedLinks;
};

tree.getCurationRoot = function()
{
	return curationRoot;
}

tree.getCurationFolders = function()
{
	return curationFolders;
}

tree.getRSSRoot = function()
{
	return rssRoot;
}

module.exports = tree;
},{"../rss.js":10,"../utils.js":11,"../version.js":12,"./objects.js":8}],10:[function(require,module,exports){
/**
 * Module contating functions to fetch and parse rss feeds
 * @module rss
 */

/**
 * Searches for images in rss entry. Due to large variations in rss formats it can be challenging
 * @param  {RSSEntry} item 
 * @return {string|null}      url of image, null if not found
 */
function extractPictureURL(item, textContent)
{
	var url = null;
	var node = item.querySelector('encoded');
	if(node)
	{
		var match = node.textContent.match(/<img[^>]+src="(http[^">]+)/);
		if(match)
			url = match[1];
	}
	if(textContent)
	{
		var match = textContent.match(/<img[^>]+src="(http[^">]+)/);
		if(match)
			url = match[1];
	}
	node = item.querySelector('content');
	if(node && node.tagName == 'media:content' && node.hasAttribute('url'))
	{
		url = node.getAttribute('url');
		//console.log("[RSS] media:content url", url);
	}
	return url;
}

function decodeHTMLEntities(text) {
    var entities = [
        ['apos', '\''],
        ['amp', '&'],
        ['lt', '<'],
        ['gt', '>']
    ];

    for (var i = 0, max = entities.length; i < max; ++i) 
        text = text.replace(new RegExp('&'+entities[i][0]+';', 'g'), entities[i][1]);

    return text;
}

/**
 * Parses rss feed from downloaded xml document
 * @param  {XMLDocument}   xml      
 * @param  {function} callback callback for returning results
 */
function parseFeed(xml, callback)
{
	var feed = xml.getElementsByTagName('entry');
	if(feed.length == 0)
		feed = xml.getElementsByTagName('item');
	
	var data = {};
	var node;

	node = xml.querySelector('title');
	//console.log("[RSS] Title " + node.textContent);
	data.title = node ? node.textContent : ""; 

	node = xml.querySelector('link:not([type="application/rss+xml"])');
	//console.log("[RSS] URL " + node.textContent);
	data.url = node ? (node.hasAttribute('href') ? node.getAttribute('href') : node.textContent) : "";

	data.posts = [];
	var hasDate = false;
	for(var i=0; i<feed.length; i++)
	{
		var item = feed[i];
		//console.log(item);
		var post = {};
		post.title = item.querySelector('title').textContent;

		node = item.querySelector('description') || item.querySelector('content');
		post.content = node ? node.textContent : '';
		var nodes = item.querySelectorAll('description');
		for(var j=0; j<nodes.length; j++)
		{
			if(nodes[j].tagName == 'media:description')
			{
				post.content = nodes[j].textContent;
			}
		}

		node = item.querySelector('pubDate') || item.querySelector('published');
		if(node)
		{
			post.pubDate = (new Date(node.textContent)).getTime();
			hasDate = true;
		} else {
			post.pubDate = null;
		}

		node = item.querySelectorAll('category');
		//console.log("TAGS", node);
		if(node && node.length == 1)
		{
			post.tags = node[0].textContent.split(',');
		}
		if(node && node.length > 1)
		{
			post.tags = [];
			for(var j=0; j<node.length; j++)
			{
				post.tags.push(node[j].textContent);
			}
		}
		//console.log(post.tags);

		node = item.querySelector('link');
		post.url = node.hasAttribute('href') ? node.getAttribute('href') : node.textContent;

		node = item.querySelector('author') || item.querySelector('creator');
		post.author = node ? node.textContent : null;

		var pic = extractPictureURL(item, post.content);
		if(pic)
		{
			post.img = pic;
		} else {
			post.img = null;
		}

		post.content = decodeHTMLEntities(post.content.replace(/<script.*\/script>/gi, '').replace(/\<[^\>]+\>/g, ''));

		data.posts.push(post);
	}

	if(hasDate)
	{
		//console.log("Sorting rss");
		data.posts.sort(function(a, b) {
			if(a.pubDate < b.pubDate)
				return 1;
			if(a.pubDate > b.pubDate)
				return -1;
			return 0;
		});
	}

	callback(data);
}

/**
 * Gets rss feed for url, parses it and returns result via callback
 * @static
 * @param  {string}   url      url to get feed from
 * @param  {Function} callback 
 */
function getFeed (url, callback)
{
	var xhr = new XMLHttpRequest();
	xhr.onload = function() {
		//console.log("[RSS] Got feed " + url);
	  	parseFeed(xhr.responseXML, callback);
	}
	xhr.onerror = function() {
	  //console.log("Error while getting XML.");
	}
	xhr.open("GET", url);
	xhr.responseType = "document";
	xhr.send();
}

var contentTypes = [
	"application/atom+xml",
	"application/rss+xml",
	"application/xml",
	"text/xml"
];

/**
 * Durable check if url is rss feed. Download document and check contents
 * @param  {string}   url      url to check
 * @param  {GUID}   guid     guid of element that holds url
 * @param  {Function} callback function(isRSS, url, guid)
 */
function checkHTML(url, guid, callback)
{
	var httpRequest = new XMLHttpRequest();
	httpRequest.open('GET', url, true);
	httpRequest.addEventListener('readystatechange', function() {
		if (httpRequest.readyState === XMLHttpRequest.DONE) {
			if (httpRequest.status === 200) {
				var xml = httpRequest.responseXML;
				if(!xml)
				{
					callback(false, url, guid);
					return;
				}
				if(xml.activeElement.tagName == 'rss' || xml.activeElement.tagName == 'feed')
				{
					var title = xml.querySelector('title');
					title = title ? title.textContent : 'RSS Feed';
					callback(title, url, guid);
				}
				//console.log("[RSS]", xml);
			} else {
				//console.log("[RSS] Error");
				callback(false, url, guid);
			}
		}
	});
	try {
		httpRequest.send(null);
	} 
	catch(e) {
		//console.log("Error requesting rss", e);
		callback(false, url, guid);
	};
}

/**
 * Checks if document on the url is rss feed. Check is done through HEAD request, checking MIME type, and loading the document, if necessary
 * @static
 * @param  {string}   url      url to check
 * @param  {GUID}   guid     guid of element that holds url
 * @param  {Function} callback function(isRSS, url, guid)
 */
function detectRSS (url, guid, callback) { 
	//checkHTML(url, guid, callback);
	//return;
	var nameCheck = url.match(/[^a-z]?(rss|feed|feeds)[^a-z]?/i) ? true : false;
	nameCheck = nameCheck || (url.match(/(\.|\=)xml$/i) ? true : false);
	var trueUrl = url;
	if(!trueUrl.match(/^[a-z]+:\/\//i))
		trueUrl = "http://" + trueUrl;
	var httpRequest = new XMLHttpRequest();
	try {
		httpRequest.open('HEAD', trueUrl, true);
	} catch (e) {
		return;
	}
	httpRequest.addEventListener('readystatechange', function() {
		if (httpRequest.readyState === XMLHttpRequest.DONE) {
			if (httpRequest.status === 200) {
				var type = httpRequest.getResponseHeader('Content-Type');
				var headerCheck = false;
				for(var i=0; i<contentTypes.length; i++)
				{
					if(type.indexOf(contentTypes[i]) > -1)
						headerCheck = true;
				}
				//console.log("[RSS] Final result: ", nameCheck, headerCheck, type);
				if(type.indexOf("text/html") > -1)
				{
					checkHTML(url, guid, callback);
				} else {
					if(callback)
						callback(nameCheck && headerCheck, url, guid);
				}
			} else {
				//console.log("[RSS] Error");
			}
		}
	});
	try {
		httpRequest.send(null);
	} 
	catch(e) {
		//console.log("Error requesting rss", e);
	};
}

module.exports = {
	detectRSS: detectRSS,
	getFeed: getFeed
};
},{}],11:[function(require,module,exports){
/**
 * Contains utility functions for working with filesystem and preferences
 * @module utils
 */

var debug = false;

/**
 * Returns an nsIFile instance of "Optimal Data" folder in ff user's profile. Creates it if it doesn't exists
 * @static
 * @return {nsIFile} local directory
 */
function getLocalDir()
{
	Components.utils.import("resource://gre/modules/FileUtils.jsm");

	var directoryService = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties);
	var localDir = directoryService.get("ProfD", Ci.nsIFile);
	localDir.append("Optimal Data");

	if (!localDir.exists() || !localDir.isDirectory())
	{
		// read and write permissions to owner and group, read-only for others.
		localDir.create(Ci.nsIFile.DIRECTORY_TYPE, 508);
	}
	return localDir;
}

/**
 * Returns nsIFile instance of backups folder inside "Optimal Data" directory. Creates it if it doesn't exists
 * @static
 * @return {nsIFile} backup directory
 */
function getBackupDir()
{
	var dir = getLocalDir();
	dir.append('backup');
	if (!dir.exists() || !dir.isDirectory())
	{
		// read and write permissions to owner and group, read-only for others.
		dir.create(Ci.nsIFile.DIRECTORY_TYPE, 508);
	}
	debug && console.log("[U] Getting backup dir " + dir.path);
	return dir;
}

/**
 * Returns array of backup files
 * @static
 * @return {nsIFile[]} array of files
 */
function getBackupFiles()
{
	var dir = getBackupDir();
	var entries = dir.directoryEntries;
	var array = [];
	while (entries.hasMoreElements())
	{
		var entry = entries.getNext();
		entry.QueryInterface(Components.interfaces.nsIFile);
		if (entry.path.match(/\.bak$/i))
			array.push(entry);
	}
	return array;
}

/**
 * Checks file existense and adds appropriate postfix (n) if so. Correctly handles files which already have this postfix.
 * @param  {nsIFile} file file to check
 * @return {nsIFile}      file with fixed file name
 */
function postfixFile(file)
{
	var fname = file.leafName.slice(0, file.leafName.lastIndexOf('.'));
	var ext = file.leafName.slice(file.leafName.lastIndexOf('.'), 100);
	var match = fname.match(/\(([0-9]+)\)$/);
	var index = 0;
	if (match)
	{
		fname = fname.slice(0, fname.lastIndexOf('('));
		index = parseInt(match[1], 10);
	}
	debug && console.log("[U] Fixing file: '" + file.leafName + "' stripped to '" + fname + "'. Index: " + index);
	while (file.exists())
	{
		index++;
		file.leafName = fname + '(' + index + ')' + ext;
	}
	return file;
}

/**
 * Reads contents of a local file
 * @static
 * @param  {string|nsIFile}   filename - filename or instance of nsIFile. If file name is given, file is taken from ff user's directory
 * @param  {Function} callback
 */
function asyncRead(filename, callback)
{
	Components.utils.import("resource://gre/modules/NetUtil.jsm");
	if (typeof(filename) == 'string')
	{
		if (filename.indexOf('chrome://') == 0)
		{
			var file = filename;
		}
		else
		{
			var file = getLocalDir();
			file.append(filename);
		}
	}
	else
	{
		var file = filename;
	}
	NetUtil.asyncFetch(file, function(inputStream, status)
	{
		if (!Components.isSuccessCode(status))
		{
			// Handle error!
			return;
		}

		// The file data is contained within inputStream.
		// You can read it into a string with
		var data = NetUtil.readInputStreamToString(inputStream, inputStream.available());
		var utf8Converter = Components.classes["@mozilla.org/intl/utf8converterservice;1"].
		getService(Components.interfaces.nsIUTF8ConverterService);
		data = utf8Converter.convertURISpecToUTF8(data, "UTF-8");
		callback(data);
	});
}

/**
 * Checks existence of a file in user's directory
 * @static
 * @param  {string} filename
 * @return {boolean}          true if file exists, false otherwise
 */
function checkLocalFile(filename)
{
	var localDir = getLocalDir();
	localDir.append(filename);

	return localDir.exists();
}

/**
 * Writes data to local file
 * @static
 * @param  {string|nsIFile}   file     filename or instance of nsIFile. If file name is given, then file is placed in ff user's folder
 * @param  {string}   data     text to write in file
 * @param  {Function} callback
 */
function asyncWriteLocal(file, data, callback)
{
	Components.utils.import("resource://gre/modules/NetUtil.jsm");
	if (typeof(file) == 'string')
	{
		var localDir = getLocalDir();
		localDir.append(file);
	}
	else
	{
		var localDir = file;
	}
	var ostream = FileUtils.openSafeFileOutputStream(localDir);

	var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].
	createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	converter.charset = "UTF-8";
	data = data.normalize('NFKD');
	var istream = converter.convertToInputStream(data);

	// The last argument (the callback) is optional.
	NetUtil.asyncCopy(istream, ostream, function(status)
	{
		if (!Components.isSuccessCode(status))
		{
			// Handle error!
			debug && console.log("Error while writing");
			return;
		}
		debug && console.log("Successfully written");
		// Data has been written to the file.
		if(callback)
			callback();
	});
}

/**
 * Gets value from extension's internal storage
 * @static
 * @param  {string} name - name of the property
 * @param  {string} type - type of value (can be 'bool', 'int', or 'string')
 * @param {string} [branch] - optional, branch of a settings tree. Used for access to other browser-wise settings
 * @return {boolean|string|number|null}      value of property
 */
function getSetting(name, type, branch)
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	var branch = prefs.getBranch(branch || "extensions.tabsmoz.");
	debug && console.log("[U] Getting " + name, branch.getPrefType(name));
	if (branch.getPrefType(name))
	{
		var value;
		switch (type)
		{
			case 'bool':
				value = branch.getBoolPref(name);
				break;
			case 'int':
				value = branch.getIntPref(name);
				break;
			case 'char':
				value = branch.getCharPref(name);
				break;
			case 'string':
				value = branch.getComplexValue(name, Components.interfaces.nsISupportsString).data;
				break;
		}
	}
	else
	{
		debug && console.log("[U] No value at " + name);
		var value = null;
	}
	//debug && console.log("[U] Get " + name + ": " + value);
	return value;
}

/**
 * Saves value to extension's internal storage
 * @static
 * @param  {string} name  - name of property
 * @param  {string} type  type of value (can be 'int', 'bool' or 'string')
 * @param  {boolean|int|string} value
 * @param {string} [branch] - optional, branch of a settings tree. Used for access to other browser-wise settings
 */
function saveSetting(name, type, value, branch)
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService);
	var branch = prefs.getBranch(branch || "extensions.tabsmoz.");
	switch (type)
	{
		case 'bool':
			branch.setBoolPref(name, value);
			break;
		case 'int':
			branch.setIntPref(name, value);
			break;
		case 'char':
			branch.setCharPref(name, value);
			break;
		case 'string':
			debug && console.log("[U] Saving string '" + value + "' as " + name);
			var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
			str.data = value;
			branch.setComplexValue(name, Components.interfaces.nsISupportsString, str);
			break;
	}
	prefs.savePrefFile(null);
}

/**
 * Fires custom event with given name and data
 * @static
 * @param  {string} eventName name of event
 * @param  {object} data      - data to attach to event
 */
function emitEvent(eventName, data)
{
	debug && console.log("Emitting event " + eventName + '\n' + data.type);
	var event = new CustomEvent(eventName,
	{
		'detail': data
	});
	if (!eventDispatcher)
		eventDispatcher = document.getElementById("tabsmozEventDispatcher");
	eventDispatcher.dispatchEvent(event);
}

function addTabsmozListener(eventName, callback)
{
	if (!eventDispatcher)
		eventDispatcher = document.getElementById("tabsmozEventDispatcher");
	eventDispatcher.addEventListener(eventName, callback, false);
}
var eventDispatcher = null;

/**
 * Gets OS name. See https://developer.mozilla.org/en-US/docs/OS_TARGET
 * @static
 * @return {string} 
 */
function getOSName()
{
	return Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;  
}

/**
 * Gets correct home page url from Firefox
 * @static
 * @return {string} homepage or 'about:home' (default)
 */
function getHomePage()
{
	var homepage = getSetting("homepage", "string", "browser.startup.");
	if(homepage == "chrome://branding/locale/browserconfig.properties")
		return "about:home";
	return homepage;
}

function setHomePage(url)
{
	saveSetting("homepage", "string", url, "browser.startup.");
}

function getOAPage()
{
	return "http://search.optimalaccess.com";
}

/**
 * Copies source's properties to destination object
 * @static
 * @param  {object} destination
 * @param  {object} source
 * @return {object}             mutated destination object
 */
function extend(destination, source)
{
	for (var k in source)
	{
		if (source.hasOwnProperty(k))
		{
			destination[k] = source[k];
		}
	}
	return destination;
}

/**
 * Making clone of an object without its functions
 * @static
 * @param  {object} source
 * @return {object}        cloned object
 */
function clone(source)
{
	return JSON.parse(JSON.stringify(source), true);
}

/**
 * Utility function that extracts useful information from DataTransfer object, generated by firefox<br>
 * There are three general things that can be dragged: <br>
 *  - ordinary links(such as from address bar): contains url and text, <br>
 *  - OptimalAccess links: contains url, text and guid of link <br>
 *  - OptimalAccess tab: contains only guid of object related to tab <br>
 * @param  {DataTransfer} dataTransfer
 * @return {object}              key-value pairs of extracted information. If 'web' is true, then it's a url; otherwise it's a tab
 */
var extractURL = function(dataTransfer)
{
	var url = dataTransfer.getData("URL");
	var guid = dataTransfer.getData('text/x-tabsmoz-link');
	var type = dataTransfer.getData('text/x-tabsmoz-type');
	var linkType = dataTransfer.getData('text/x-tabsmoz-linktype');
	var tab = dataTransfer.getData('text/x-tabsmoz-tab');
	var mozUrl = dataTransfer.getData('text/x-moz-url');
	var mozDesc = dataTransfer.getData('text/x-moz-url-desc');
	var node = dataTransfer.getData('text/x-tabsmoz-node');
	var nodelist = dataTransfer.getData('text/x-tabsmoz-nodelist');
	var nodetype = dataTransfer.getData('text/x-tabsmoz-nodetype');
	var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	try
	{
		var uri = ioService.newURI(dataTransfer.getData('text/plain'), null, null);
		url = uri.asciiSpec;
	}
	catch (e)
	{
		url = url;
	};
	var result = {};
	if(nodelist)
	{
		return {
			web: false,
			nodelist: nodelist.split(','),
			nodetype: nodetype
		}
	}
	if (node)
		if (type == 'curationlink')
		{
			return {
				web: true,
				node: node,
				url: url || mozUrl,
				type: 'curationlink'
			};
		} else if(type == 'rsslink') {
			return {
				web: true,
				node: node,
				url: url || mozUrl,
				type: 'rsslink'
			};
		} else {
			return {
				web: false,
				tab: tab || null,
				node: node
			};
		}
	if(tab && mozUrl) { // for temp pages
		return {
			web: true,
			tab: tab,
			url: mozUrl,
			name: mozDesc
		};
	}
	if (tab) // for regular tabs
		return {
			web: false,
			tab: tab,
			url: url
		};
	if (guid) // for links
		return {
			web: true,
			link: guid,
			linkType: linkType
		};
	if (mozUrl)
		return {
			web: true,
			url: url || mozUrl,
			name: mozUrl.split('\n')[1]
		};
	return {
		web: true,
		url: url || mozUrl,
		name: mozDesc
	};
}

function createDate(date) {
	if(typeof(date) == 'string') {
		var t = date.split('-');
		var result = new Date(parseInt(t[0], 10), parseInt(t[1], 10), parseInt(t[2], 10));
		return result.getTime();
	}
	return (new Date(date)).getTime();
}

function stripDate(timestamp) {
	var result = (new Date(timestamp)).getTime() - new Date().getTimezoneOffset()*60*1000;
}

module.exports = {
	getLocalDir: getLocalDir,
	getBackupDir: getBackupDir,
	getBackupFiles: getBackupFiles,
	asyncRead: asyncRead,
	asyncWriteLocal: asyncWriteLocal,
	checkLocalFile: checkLocalFile,
	getSetting: getSetting,
	saveSetting: saveSetting,
	emitEvent: emitEvent,
	addTabsmozListener: addTabsmozListener,
	postfixFile: postfixFile,
	extend: extend,
	clone: clone,
	createDate: createDate,
	getOSName: getOSName,
	getHomePage: getHomePage,
	setHomePage: setHomePage,
	getOAPage: getOAPage,
	extractURL: extractURL,
	uiModifiedEvent: "oaff-ui-modified",
	treeModifiedEvent: "oaff-tree-modified",
	faviconLoadEvent: "oaff-favicon-load",
	rssLoadedEvent: "oaff-rss-loaded"
};
},{}],12:[function(require,module,exports){
/**
 * Contains current extension version and file format version
 * @module version
 */

module.exports.extVersion = '1.50.29';
module.exports.fileVersion = 4;
},{}],13:[function(require,module,exports){
/**
 * Handles message dispatching, such as events in Firefox, and events generated by app
 * @module events
 */

var events = {};

var eventData = {};

var hoveredTab = null;

var debug = false;

/**
 * Handles click events on tabs
 * @function tabClick
 * @static
 * @param  {MouseEvent} event
 */
events.tabClick = function(event)
{
	var target = event.currentTarget;
	var tab = tree.getObject(target.getAttribute('data-guid'));
	/*switch(tab.type) {
		case 'group': xul.selectGroup(tab.guid); break;
		case 'page': xul.selectPage(tab.guid); break;
		case 'subpage': xul.selectSubpage(tab.guid); break;
	}*/
	debug && console.log('[E] Clicked ' + tab.guid);
	tree.setLastChild(tab);
}

/**
 * Handles click on plus tab. Automatically determines type of tab
 * @param  {Event} event
 */
events.plusTabMouseUp = function(event)
{
	if (event.button != 2)
	{
		var target = event.currentTarget;
		var type = target.getAttribute('data-type');
		var showProperties = utils.getSetting('showPropertiesOnCreate', 'bool');
		switch (type)
		{
			case 'subpage':
				xul.openSubpage(
				{
					url: utils.getOAPage()
				});
				break;
			case 'page':
				var page = tree.createPage(
				{
					parent: tree.getSelected('group').guid
				}, true);
				Tabsmoz.showProperties(page, true, { createdClean: true });
				break;
			case 'group':
				var group = tree.createGroup(
				{
					parent: tree.getSelected('panel').guid
				}, true);
				Tabsmoz.showProperties(group, true);
				break;
		}
	}
}

function tabDoubleClick(tab)
{
	debug && console.log("[E] Double clicked");
	switch (tab.type)
	{
		case 'group':
			break;
		case 'page':
			// select root link
			tree.resetPage(tab);
			tree.setLastChild(tab);
			break;
		case 'subpage':
			var parent = tree.getObject(tab.parent);
			if (parent.children.indexOf(tab.guid) == 0)
			{
				tree.closePage(parent);
			}
			else
			{
				tree.removeNode(tab);
			}
			break;
	}
}

/**
 * Handles clicks and double clicks on page tabs
 * @function tabMouseUp
 * @static
 * @param  {Event} event
 */
events.tabMouseUp = function(event)
{
	if (event.button != 2)
	{
		var target = event.currentTarget;
		var tab = tree.getObject(target.getAttribute('data-guid'));
		eventData[tab.guid] = eventData[tab.guid] || {};
		if(!eventData[tab.guid].clicked)
			eventData[tab.guid].clicked = 0;
		eventData[tab.guid].clicked++;
		debug && console.log("[E] Tab mouse up!", eventData[tab.guid]);
		if (eventData[tab.guid].clicked > 1)
		{
			tabDoubleClick(tab);
			return;
		}
		setTimeout(function()
		{
			debug && console.log("[E] After timeout: ", eventData[tab.guid].clicked, tab.guid);
			if (eventData[tab.guid].clicked == 1)
			{
				debug && console.log("[E] Selecting tab");
				tree.setLastChild(tab);
					if(tab.type == 'group') 
					{
						console.log("Clearing listview");
						xul.showListViewNode(null);
					}

			}
			debug && console.log("[E] Clearing eventData: tabMouseUp");
			delete eventData[tab.guid];
		}, 200);

	}
}

/**
 * Handles click on close button on page tabs
 * @function closeTabClick
 * @static
 * @param  {Event} event
 */
events.closeTabClick = function(event)
{
	event.preventDefault();
	event.stopPropagation();
	debug && console.log("[E] closing page");
	var tab = event.currentTarget;
	while (!tab.hasAttribute('data-guid'))
		tab = tab.parentNode;
	var guid = tab.getAttribute('data-guid');
	eventData[guid] = {
		clicked: -1
	};
	var node = tree.getObject(guid);
	if(node.type == 'group')
		tree.closeGroup(guid);
	if(node.type == 'page')
		tree.closePage(guid);
	if(node.type == 'subpage')
		tree.removeNode(node);
}

/**
 * Handles start of tab dragging and populates necessary info into event object
 * @function tabDragStart
 * @static
 * @param  {Event} event the drag event
 */
events.tabDragStart = function(event)
{
	var target = event.currentTarget;
	var tab = tree.getObject(target.getAttribute('data-guid'));
	event.dataTransfer.setData('text/x-tabsmoz-tab', tab.guid);
	if(tab.type == 'subpage') {
		console.log("drag subpage " + tab.name + " / " + tab.url);
		event.dataTransfer.setData('text/x-moz-url', tab.url);
		event.dataTransfer.setData('text/x-moz-url-desc', tab.name);
	}
	xul.startTabDrag(tab.guid);
	Tabsmoz.selectNode(tab.guid);
	debug && console.log("[E] Started drag " + tab.name);
}

function tabDragTimeout(tab, token) {
	if (hoveredTab == tab && eventData[tab] && eventData[tab].hover && token == eventData[tab].token)
	{
		debug && console.log("[E] Drag enter, switchong");
		tree.setLastChild(tab);
		delete eventData[tab];
	}
}

function isPageOverGroup(tab, hover)
{
	hover = tree.getObject(hover);
	tab = tree.getObject(tab);
	if(hover && tab.type == 'group' && hover.type == 'page')
		return true;
	return false;
}

/**
 * Handles event when users drags one tab over another
 * @function tabDragEnter
 * @static
 * @param  {Event} event
 */
events.tabDragEnter = function(event)
{
	//return;
	var target = event.currentTarget;
	var tab = target.getAttribute('data-guid');
	var data = utils.extractURL(event.dataTransfer);
	if (!eventData[tab])
		eventData[tab] = {
			hover: 0
		};
	eventData[tab].hover = eventData[tab].hover;
	eventData[tab].hover++;
	debug && console.log("[E] Drag enter", eventData[tab].hover);
	if (!data.tab && data.web || isPageOverGroup(tab, data.tab) || data.nodelist || data.node)
	{
		if (hoveredTab !== tab)
		{
			hoveredTab = tab;
			var timeout = utils.getSetting('hoverDelay', 'int');
			var token = eventData[tab].token = Math.random() * 1e+7 | 0;
			setTimeout(function(a, b, c) {
				tabDragTimeout(a, b, c);
			}, timeout, tab, token);
		}
		event.preventDefault();
		event.stopPropagation();
	}
	else if(data.tab)
	{
		debug && console.log("[E] Hover event over " + tab.name);
		var hover = tree.getObject(data.tab);
		tab = tree.getObject(tab);
		if (tab.type == hover.type)
		{
			tree.swapNodes(hover.guid, tab.guid);
			debug && console.log("[E] Swapping");
			event.preventDefault();	
			event.stopPropagation();
		}
	}
}

/**
 * Handles events when user drags something away from tab.<br>
 * "dragleave" event fires also when you drag something over node's children, so we should hanlde that.
 * @function tabDragLeave
 * @static
 * @param  {Event} event
 */
events.tabDragLeave = function(event)
{
	var target = event.currentTarget;
	var tab = target.getAttribute('data-guid');
	debug && console.log("[E] Drag leave", eventData[tab].hover);
	if (eventData[tab] && eventData[tab].hover)
	{
		eventData[tab].hover--;
		if (eventData[tab].hover <= 0)
		{
			debug && console.log("[E] Clearing eventData: tabDragLeave");
			delete eventData[tab];
			hoveredTab = null;
		}
	}
}

/**
 * Handles dragging over a pagetab bar. Restricts anything but page tabs to be dropped
 * @function pageTabBarDragOver
 * @static
 * @param  {Event} event
 */
events.pageTabBarDragOver = function(event)
{
	var data = utils.extractURL(event.dataTransfer);
	if (data.nodelist)
		return;
	if (!data.web && data.tab)
	{
		var node 	= tree.getObject(data.tab);
		if (node.type == 'page')
			event.preventDefault();
	}
	else
	{
		event.preventDefault();
	}
}

/**
 * Handles dragging over a grouptab bar. Restricts anything but group tabs to be dropped
 * @function groupTabBarDragOver
 * @static
 * @param  {Event} event
 */
events.groupTabBarDragOver = function(event)
{
	var data = utils.extractURL(event.dataTransfer);
	if (data.nodelist)
		return;
	if (!data.web && data.tab)
	{
		var node = tree.getObject(data.tab);
		if (node.type == 'group' || node.type == 'page')
			event.preventDefault();
	}
	else
	{
		event.preventDefault();
	}
}

/**
 * Handles dragging over a subpagetab bar. Restricts anything but subpage tabs to be dropped
 * @function subpageTabBarDragOver
 * @static
 * @param  {Event} event
 */
events.subpageTabBarDragOver = function(event)
{
	var data = utils.extractURL(event.dataTransfer);
	if (data.nodelist)
		return;
	if (!data.web && data.tab)
	{
		var node = tree.getObject(data.tab);
		if (node.type == 'subpage')
			event.preventDefault();
	}
	else
	{
		event.preventDefault();
	}
}

/**
 * Handles change of tab properties caused by external events (page loading, redirects, scripts on page)
 * @function tabAttributeModified
 * @static
 * @param  {Event} event
 */
events.tabAttributeModified = function(event)
{
	var tab = event.target;
	var guid = tab.getAttribute('tabsmoz-data')
	var node = tree.getObject(guid);
	if (node)
	{
		//console.log("[E] Tab attribute modified: " + node.guid.substr(0, 5));
		var browser = gBrowser.getBrowserForTab(tab);
		var uitab = xul.getTab(guid);
		node.url = browser.currentURI.asciiSpec;
		//node.name = node.local ? node.name : tab.label;
		tree.updateNodeInfo(node, {
			name: node.name,
			url: node.url,
			label: tab.label,
			soundplaying: tab.hasAttribute('soundplaying')
		});
	}
}

/**
 * Handles opening of new native tabs and creates corresponding subpage tab
 * @function tabOpen
 * @static
 * @param  {Event} event
 */
events.tabOpen = function(event)
{
	//console.log("[E] OPEN", event);
	xul.openSubpage(
	{
		tab: event.target,
		local: false
	});
}

events.tabClose = function(event)
{
	var target = event.target;
	var guid = target.getAttribute('tabsmoz-data');
	var tab = tree.getObject(guid);
	if(tab)
	{
		tree.removeNode(tab);
	}
}

/**
 * Handles tab switching
 * @function tabChange
 * @static
 * @param  {Event} event
 */
events.tabChange = function(event)
{
	debug && console.log("[E] TabChange event");
	var target = event.target;
	var guid = target.getAttribute('tabsmoz-data');
	var tab = tree.getObject(guid);
	if (tab && xul.getSwitchHandleFlag())
	{
		debug && console.log("[E] Changed tab to node " + tab.guid);
		tree.setDeepLastChild(tab);
	}
	else
	{

	}
	debug && console.log("[E] Changed " + guid);
}

/**
 * Handles drop event on subpage panel. If dropping local link (curation or web folder) or in global management mode - not opening native tab
 * @function subpageDrop
 * @static
 * @param  {Event} event drop event
 */
events.subpageDrop = function(event)
{
	var data = utils.extractURL(event.dataTransfer);
	console.log("Dropped: " + url, event.dataTransfer);
	if(data.tab)
	{
		var tab = tree.getObject(data.tab);
		var page = tree.getSelected('page');
		if(tab.type == 'subpage' && tab.parent == page.guid) {
			return;
		}
	}
	if (data.web)
	{
		hoveredTab = null;
		event.preventDefault();
		var url = data.url;
		if (data.link)
		{
			var link = tree.getObject(data.link);
			if(link.local || xul.getManagementMode() == 'local')
			{
				console.log("[E] Local link!")
				xul.openSubpage({
					url: 'about:blank',
					name: link.name,
					node: link.guid,
					local: true
				});
				return;
			}
			url = tree.getObject(data.link).url;
		}
		window.Tabsmoz.swapBrowsers('web');
		var tab = gBrowser.addTab(url);
		gBrowser.selectedTab = tab;
	}
}

/**
 * Handles drop of url onto page tab panel
 * @function pageDrop
 * @static
 * @param  {Event} event
 */
events.pageDrop = function(event)
{
	hoveredTab = null;	
	var data = utils.extractURL(event.dataTransfer);
	var showProperties = utils.getSetting('showPropertiesOnCreate', 'bool');
	if (data.web)
	{
		var page;
		page = tree.createPage(
		{
			parent: tree.getSelected('group'),
			link: data.link,
			name: data.name,
			select: true
		}, showProperties);
		if (showProperties)
			Tabsmoz.showProperties(page, true,
			{
				createdByDragDrop: data.url,
				createdByLinkDrop: data.link
			});
		event.preventDefault();
	} else if(data.tab) {
		var tab = tree.getObject(data.tab);
		if(tab) {
			var group = tree.getSelected('group');
			if(tab.type == 'page' && tab.parent != group.guid) {
				tree.moveSubtree(tab, group);
			}
		}
	}
}

/**
 * Handles drop of url onto group tab panel
 * @function groupDrop
 * @static
 * @param  {Event} event
 */
events.groupDrop = function(event)
{
	debug && console.log("[E] Drop on group panel");
	var data = utils.extractURL(event.dataTransfer);
	if (data.web)
	{
		var group;
		group = tree.createGroup(
		{
			name: "",
			link: data.link, //
			url: data.url,
			parent: tree.getPanelRoot().getLastChild()
		}, true);
		Tabsmoz.showProperties(group, true,
		{
			pagename: data.name,
			url: data.url,
			link: data.link,
			createdByDragDrop: data.url
		});
		event.preventDefault();
	}
}


/**
 * Handles dropping links and page tabs on group tab itself
 * @param  {Event} event
 */
events.groupTabDrop = function(event)
{
	debug && console.log("[E] Drop on group tab");
	var node = tree.getObject(event.currentTarget.getAttribute('data-guid'));
	var data = utils.extractURL(event.dataTransfer);
	var showProperties = utils.getSetting('showPropertiesOnCreate', 'bool');
	if (data.web)
	{
		var page;
		if (data.link)
		{
			debug && console.log("[E] Got link! " + data.link);
			page = tree.createPage(
			{
				parent: node.guid,
				link: data.link,
				select: true
			}, showProperties);
		}
		else
		{
			page = tree.createPage(
			{
				parent: node.guid,
				url: data.url,
				name: data.name,
				select: true
			}, showProperties);
		}
		if (showProperties)
			Tabsmoz.showProperties(page, true,
			{
				createdByDragDrop: data.url
			});
		event.preventDefault();
		event.stopPropagation();
	} else {
		var tab = tree.getObject(data.tab);
		if(tab) {
			console.log("Drop the base");
			if(tab.type == 'page' && tab.parent != node.guid) {
				tree.moveSubtree(tab, node);
				event.preventDefault();
				event.stopPropagation();
			}
		}
	}
}

events.pageTabDrop = function(event)
{

}

/**
 * Handles native ff tab loading and gets url and title from it to update subpage
 * @function updateSubpage
 * @static
 * @param  {Event} event
 */
events.updateSubpage = function(event)
{
	var data = event.detail;
	var subpage = tree.getObject(data.id);
	subpage.name = data.title;
	subpage.url = data.url;
	//console.log("[E] Tab Update " + subpage.name);
	utils.emitEvent(utils.treeModifiedEvent,
	{
		target: subpage,
		type: 'update',
		properties: ['name', 'url']
	});
}

events.toggleSidebar = (function()
{	
	var lastSidebar = null;

	return function() {
		if(SidebarUI.isOpen) {
			lastSidebar = SidebarUI.currentID;
			utils.saveSetting('lastSidebar', 'string', lastSidebar);
			SidebarUI.hide();
		} else {
			lastSidebar = utils.getSetting('lastSidebar', 'string') || "tabsmozPanelSidebar";
			SidebarUI.show(lastSidebar);
		}
	};
})();

/**
 * Handles "Hide page tabs" command
 * @function hidePageTabsClick
 * @static
 * @param  {Event} event
 */
events.hidePageTabsClick = function(event)
{
	var val = utils.getSetting("hidePageTabs", "bool");
	utils.saveSetting("hidePageTabs", "bool", !val);
	document.getElementById("oaff_cmd_hidePageTabs").setAttribute("checked", !val);
	utils.emitEvent(utils.uiModifiedEvent,
	{});
}

/**
 * Handles "Hide group tabs" command
 * @function hideGroupTabsClick
 * @static
 * @param  {Event} event
 */
events.hideGroupTabsClick = function(event)
{
	var val = utils.getSetting("hideGroupTabs", "bool");
	utils.saveSetting("hideGroupTabs", "bool", !val);
	document.getElementById("oaff_cmd_hideGroupTabs").setAttribute("checked", !val);
	utils.emitEvent(utils.uiModifiedEvent,
	{});
}

events.hideAllTabsClick = function(event)
{
	var pages = utils.getSetting("hidePageTabs", "bool");
	var groups = utils.getSetting("hideGroupTabs", "bool");
	var val = true;
	if(pages && groups)
	{
		var val = false;
	}
	utils.saveSetting("hideGroupTabs", "bool", val);
	utils.saveSetting("hidePageTabs", "bool", val);
	document.getElementById("oaff_cmd_hidePageTabs").setAttribute("checked", val);
	document.getElementById("oaff_cmd_hideGroupTabs").setAttribute("checked", val);
	utils.emitEvent(utils.uiModifiedEvent,
	{});
}

events.switchTabsClick = function(event)
{
	var val = !utils.getSetting("switchTempTabs", "bool");
	console.log(val);
	document.getElementById("oaff_cmd_switchTabs").setAttribute("checked", val);
	utils.saveSetting("switchTempTabs", "bool", val);
	utils.emitEvent(utils.uiModifiedEvent,
	{});
}

module.exports = events;


var tree = require('../model/tree.js'),
	objects = require('../model/objects.js'),
	xul = require('./interface.js'),
	utils = require('../utils.js');
},{"../model/objects.js":8,"../model/tree.js":9,"../utils.js":11,"./interface.js":14}],14:[function(require,module,exports){
/**
 * Controls all interface elements and interaction with FireFox UI
 * @module interface
 */


var sidebar = document.getElementById('sidebar'),
	listView = document.getElementById('tabsmoz-browser'),
	mainTabContainer = gBrowser.tabContainer,
	sidebarSelect = document.getElementById('tabsmoz-sidebar-select'),
	strings = document.getElementById('oaff-string-bundle'),
	launch = false,
	blankTab = null,
	selectedPanel = null,
	groupTabs = null,
	pageTabs = null,
	subpageTabs = null,
	tabUpdateInterval = 200,
	tabUpdateFlag = false,
	tabUpdateCounter = 0,
	handleOpenTab = true, // flag that determines who opened new tab(extension or user)
	handleTabSwitch = true, // flag that determines who switched tab
	handleCloseTab = true, // flag that determines who closed tab
	tabUnderContext = null, // last tab on which context menu was activated
	barUnderContext = null, // tab bar which context menu was popped upon
	globalManagementMode = 'web',
	globalBrowserState = 'web'; // web or local

var debug = false;

var initialized = false;

/**
 * creates empty tab(used as default) and closes other, so we can fully manage tab creation
 * @static
 */
function closeTabs()
{
	blankTab = blankTab || gBrowser.addTab('about:blank');
	// can't use "removeAllTabsBut" because it asks permission
	var i = 0;
	debug && console.log("[I] Tabs count: " + gBrowser.tabs.length);
	while (i < gBrowser.tabs.length)
	{
		debug && console.log("[I] Tab: " + gBrowser.tabs[i].label + "; " + gBrowser.getBrowserForTab(gBrowser.tabs[i]).currentURI.spec);
		if (gBrowser.tabs[i] !== blankTab)
		{
			gBrowser.removeTab(gBrowser.tabs[i]);
		}
		else
		{
			i++;
		}
	}
}

/**
 * Called if user opens link in new window. Creates subpages for each opened native tab, not closing them.
 */
function mergeTabs()
{
	debug && console.log("[I] Tabs count: " + gBrowser.tabs.length);
	blankTab = blankTab || gBrowser.addTab('about:blank');
	for (var i = 0; i < gBrowser.tabs.length; i++)
	{
		debug && console.log("[I] Tab: " + gBrowser.tabs[i].label + "; " + gBrowser.getBrowserForTab(gBrowser.tabs[i]).currentURI.spec);
		var tab = gBrowser.tabs[i];
		var guid = tab.getAttribute('data-guid');
		if (tab !== blankTab && !guid)
		{
			handleOpenTab = true;
			openSubpage(
			{
				tab: tab,
				canClose: true
			});
		}
	}
}

/**
 * Updates tab bars visibility and position, toolbar position and state
 */
function updateUI()
{
	debug && console.log("[I] Updating UI");
	var hidePageTabs = utils.getSetting('hidePageTabs', 'bool');
	var hideGroupTabs = utils.getSetting('hideGroupTabs', 'bool');
	var groupTabPosition = utils.getSetting('groupTabPosition', 'string');
	var subpageTabPosition = utils.getSetting('subpageTabPosition', 'string');
	var showToolbar = utils.getSetting('showToolbar', 'bool');
	var toolbarPosition = utils.getSetting('toolbarPosition', 'string');
	var toolbarCollapsed = utils.getSetting('toolbarCollapsed', 'bool');
	var colorTheme = utils.getSetting('colorTheme', 'int');
	var switchTabs = utils.getSetting('switchTempTabs', 'bool');

	if(switchTabs) 
	{
		hidePageTabs = true;
		hideGroupTabs = true;
		subpageTabPosition = 'top';
	}

	var mw = document.querySelectorAll('.oaff-tab-top');
	for(var j=0; j<mw.length; j++) {
		for(var i=-1; i<8; i++)
			mw[j].classList.remove('oaff-theme-' + i);
		mw[j].classList.add('oaff-theme-' + colorTheme);
	}
	var tb = document.getElementById('navigator-toolbox');
	for(var i=-1; i<8; i++)
		tb.classList.remove('oaff-theme-' + i);
	tb.classList.add('oaff-theme-' + colorTheme);

	if (hidePageTabs)
	{
		pageTabs.hide();
	}
	else
	{
		pageTabs.show();
	}
	document.getElementById("oaff_cmd_hidePageTabs").setAttribute("checked", hidePageTabs);

	if (hideGroupTabs)
	{
		groupTabs.hide();
	}
	else
	{
		groupTabs.show(groupTabPosition);
	}
	document.getElementById("oaff_cmd_hideGroupTabs").setAttribute("checked", hideGroupTabs);

	if (!hidePageTabs || !hideGroupTabs)
	{
		subpageTabPosition = 'bottom';
		//utils.saveSetting('subpageTabPosition', 'string', 'bottom');
	}
	subpageTabs.show(subpageTabPosition);
	// document.getElementById('oaff-menu-placeholder').hidden = subpageTabPosition == 'bottom';
	//document.querySelector('#toolbar-menubar[autohide="true"]').setAttribute('data-collapse', subpageTabPosition == 'top');
	document.querySelector('#toolbar-menubar').setAttribute('data-collapse', subpageTabPosition == 'top');

	var showTooltip = utils.getSetting('showCommentTooltip', 'bool');
	var getTooltip = function(guid)
	{
		return tree.getObject(guid).comment;
	}
	groupTabs.switchTooltips(showTooltip, getTooltip);
	pageTabs.switchTooltips(showTooltip, getTooltip);

	var toolbarFlag = document.getElementById('oaff-toolbar-flag');
	toolbarFlag.hidePopup();
	var left, right;
	if(toolbarPosition == 'left')
	{
		left = false || !showToolbar || toolbarCollapsed;
		right = true || !showToolbar || toolbarCollapsed;
		if(toolbarCollapsed && showToolbar) 
		{
			toolbarFlag.openPopup(document.querySelector('.oaff-toolbar.oaff-left'), 'rightcenter topleft', 0, -8, false);
			toolbarFlag.classList.remove('oaff-right');
		}
	} else {
		left = true || !showToolbar || toolbarCollapsed;
		right = false || !showToolbar || toolbarCollapsed;
		if(toolbarCollapsed && showToolbar) 
		{
			toolbarFlag.openPopup(document.querySelector('.oaff-toolbar.oaff-right'), 'leftcenter topright', 0, -8, false);
			toolbarFlag.classList.add('oaff-right');
		}
	}

	if(left) {
		document.querySelector('.oaff-toolbar.oaff-left').classList.add('oaff-toolbar-hidden');
	} else  {
		document.querySelector('.oaff-toolbar.oaff-left').classList.remove('oaff-toolbar-hidden');
	}

	if(right) {
		document.querySelector('.oaff-toolbar.oaff-right').classList.add('oaff-toolbar-hidden');
	} else  {
		document.querySelector('.oaff-toolbar.oaff-right').classList.remove('oaff-toolbar-hidden');
	}

	TabsInTitlebar.updateAppearance(true);
}

/**
 * Handles event when favicon for some domain has been loaded. Updates favicons in tree view and in page tabs
 * @param  {Event} event custom event that fires when favicon is loaded. Contains the domain name
 */
function updateFavicons(event)
{
	var data = event.detail;
	if (sidebar.contentWindow.tabsmozInit)
	{
		sidebar.contentWindow.updateFavicon(data);
	}

	function updatePages() {
		var pages = tree.getArrayOfType('page');
		var link;
		for(var i=0; i<pages.length; i++) {
			link = tree.getObject(pages[i].link);
			if(link && link.domain == data.domain) {
				pageTabs.getTab(pages[i].guid).update(pages[i]);
			}
		}
	}

	setTimeout(function() {
		updatePages();
	}, 0);
}

/**
 * sets content of a sidebar basing on combobox value
 * @static
 */
function switchSidebar()
{
	var target = sidebarSelect.value;
	switch (target)
	{
		case 'bookmarks':
			// native FF function
			SidebarUI.show('viewBookmarksSidebar');
			utils.saveSetting('lastSidebar', 'string', 'viewBookmarksSidebar');
			break;

		case 'journal':
			// native FF function
			SidebarUI.show('viewHistorySidebar');
			utils.saveSetting('lastSidebar', 'string', 'viewHistorySidebar');
			break;

		/*case 'maintree':
			SidebarUI.show('tabsmozMainSidebar');
			break;*/

		case 'paneltree':
			SidebarUI.show('tabsmozPanelSidebar');
			utils.saveSetting('lastSidebar', 'string', 'tabsmozPanelSidebar');
			break;

		case 'linktree':
			SidebarUI.show('tabsmozLinkSidebar');
			utils.saveSetting('lastSidebar', 'string', 'tabsmozLinkSidebar');
			break;

		case 'pagetree':
			SidebarUI.show('tabsmozPageSidebar');
			utils.saveSetting('lastSidebar', 'string', 'tabsmozPageSidebar');
			break;

		case 'curationtree':
			SidebarUI.show('tabsmozCurationSidebar');
			utils.saveSetting('lastSidebar', 'string', 'tabsmozCurationSidebar');
			break;
	}
}

/**
 * sets the proper value of combobox in sidebar
 * @static
 * @param  {string} id the content to show
 */
function selectSidebar(id)
{
	switch (id)
	{
		case 'viewBookmarksSidebar':
			sidebarSelect.selectedIndex = 0;
			break;
		case 'viewHistorySidebar':
			sidebarSelect.selectedIndex = 1;
			break;
		/*case 'tabsmozMainSidebar':
			sidebarSelect.selectedIndex = 2;*/
			break;
		case 'tabsmozPanelSidebar':
			sidebarSelect.selectedIndex = 2;
			break;
		case 'tabsmozLinkSidebar':
			sidebarSelect.selectedIndex = 3;
			break;
		case 'tabsmozPageSidebar':
			sidebarSelect.selectedIndex = 4;
			break;
		case 'tabsmozCurationSidebar':
			sidebarSelect.selectedIndex = 5;
			break;
	}
}

/**
 * Initializes sidebar(e.g. sets the proper value in combobox)
 * @static
 */
function initSidebar()
{
	var broadcasters = document.getElementsByAttribute("group", "sidebar");
	for (var broadcaster of broadcasters)
	{
		// skip elements that observe sidebar broadcasters and random
		// other elements
		if (broadcaster.localName != "broadcaster")
		{
			continue;
		}

		if (broadcaster.getAttribute("checked"))
		{
			debug && console.log("Selecting sidebar " + broadcaster.id);
			selectSidebar(broadcaster.id);
		}
	}
}

/**
 * Initializes tabs on startup or data file load
 * @static
 */
function createTabs()
{
	groupTabs = new tabCollections.GroupTabCollection();
	pageTabs = new tabCollections.PageTabCollection();
	subpageTabs = new tabCollections.SubpageTabCollection();

	function traverse(node)
	{
		if (node.children && node.children.length)
		{
			for (var i = 0; i < node.children.length; i++)
			{
				var child = tree.getObject(node.children[i]);
				switch (child.type)
				{
					case 'group':
						groupTabs.addTab(child.guid,
						{
							title: child.name
						});
						break;
					case 'page':
						pageTabs.addTab(child.guid,
						{
							title: child.name
						});
						break;
					case 'subpage':
						// nothing to do
						break;
				}
				traverse(child);
			}
		}
	}
	traverse(tree.getPanelRoot());
}

/**
 * Updates tree view
 * @static
 * @param  {string} view 'panel' or 'link'
 * @param  {guid} [node] optional - node to use as the tree root
 */
function refreshTree(view, node, selected)
{
	if (!view)
	{
		var hash = sidebar.contentWindow.location.hash;
		switch (hash)
		{
			case '#links':
				view = 'link';
				break;
			case '#panels':
				view = 'panel';
				break;
			case '#main':
				view = 'main';
				break;
			default:
				return;
				break;
		}
	}
	var root;
	//debug && console.log("[I] Refreshing " + view);
	switch (view)
	{
		case 'panel':
			if (node)
				root = tree.getObject(node);
			else
				root = tree.getPanelRoot();
			break;
		case 'link':
			root = tree.getLinkRoot();
			break;
		case 'main':
			root = tree.getRoot();
			break;
	}
	root = tree.getSubtree(root);
	if (!selected)
		selected = pageTabs.selected;
	showTree(root, view, selected);
}

/**
 * Shows part of tree in sidebar
 * @static
 * @param  {object} treeData nested object with info, suitable for jsTree
 */
function showTree(treeData, view, selected)
{
	if (sidebar.contentWindow.tabsmozTreeInit)
	{
		sidebar.contentWindow.showTree(treeData, view, selected);
	}
}

/**
 * Selects panel, and last selected child group
 * @static
 * @param  {GUID|BaseObject} id
 * @param  {boolean} silent
 */
function selectPanel(id, silent)
{
	var panel = tree.getObject(id),
		last = panel.getLastChild();
	if (!panel)
		return;
	
	debug && console.log("[I] Selecting panel " + panel.name);

	if (!selectedPanel)
		selectedPanel = panel;

	var clearPreviousPanel = panel.guid !== selectedPanel.guid,
		previousPanel = selectedPanel;

	selectedPanel = panel;
	groupTabs.showList(panel.children)
	selectGroup(last);

	debug && console.log("[I] Panel selected, closing tabs in previous");

	if (clearPreviousPanel)
	{
		// close all tabs in previous panel
		for (var i = 0; i < previousPanel.children.length; i++)
		{
			var group = tree.getObject(previousPanel.children[i]);
			for (var j = 0; j < group.children.length; j++)
			{
				var page = tree.getObject(group.children[j]);
				while (page.children.length > 0)
					tree.removeNode(page.children[0]);
			}
		}
	}
}

/**
 * Selects group, and last selected child page
 * @static
 * @param  {GUID|BaseObject} id
 * @param  {boolean} silent
 */
function selectGroup(id, silent)
{
	var group = tree.getObject(id),
		last = group.getLastChild();
	if (!group || selectedPanel.guid !== group.parent)
		return;

	debug && console.log("[I] Selecting group " + group.name);

	var page = tree.getObject(last);
	pageTabs.showList(group.children);
	groupTabs.select(id);
	if (page && (!page.children || page.children.length == 0))
	{
		// if group has no open subpages, then wait for a while
		gBrowser.selectedTab = blankTab;
		// a hack, but we really need this
		swapBrowsers('web');
		var interval = utils.getSetting('groupDelay', "int");
		if(!launch) {
			launch = true;
			interval = 0;	
		}
		subpageTabs.showList([]);
		setTimeout(function()
		{
			if (tree.getSelected('group').guid == id)
				selectPage(group.getLastChild());
		}, interval);
	}
	else
	{
		selectPage(last);
	}
}

/**
 * Selects page, and last selected child subpage. If has no subpages, then creates one with url of associated link
 * @static
 * @param  {GUID|BaseObject} id
 * @param  {boolean} silent
 */
function selectPage(id, silent)
{
	var page = tree.getObject(id);
	if (!page || tree.getSelected('group').guid !== page.parent)
		return;

	debug && console.log("[I] Selecting page " + page.name);

	swapBrowsers('web');

	// if page has no subpage tabs (e.g. freshly created)
	if (!page.children.length)
	{
		debug && console.log("[I] Page has no children");
		// create subpage tab from page link
		if (!page.link)
			page.link = tree.getLinkRoot().guid;
		var link = tree.getObject(page.link);
		//console.log("[I] Link local? ", link.name, link.local);
		if(link.local || globalManagementMode == 'local')
		{
			//console.log("[I] Selecting page, local", link.local);
			openSubpage(
			{
				parent: page.guid,
				node: link.guid,
				url: 'about:blank',
				local: link.local,
				name: page.name
			});
		} else {
			//console.log("[I] Selecting page, web", page.guid);
			handleTabSwitch = false;
			openSubpage(
			{
				parent: page.guid,
				url: link.url,
				node: link.guid,
				name: page.name
			});
		}
	}
	if (sidebar.contentWindow.tabsmozInit)
		sidebar.contentWindow.refreshSelection();
	var last = page.getLastChild();
	subpageTabs.showList(page.children);
	pageTabs.select(id);
	refreshTree('panel', null, id);
	selectSubpage(last);
}

/**
 * Selects subpage
 * @static
 * @param  {GUID|BaseObject} id
 */
function selectSubpage(id)
{
	var subpage = tree.getObject(id);
	if (!subpage || tree.getSelected('page').guid !== subpage.parent)
		return;
	swapBrowsers('web');
	debug && console.log("[I] Selecting subpage " + subpage.name);
	//console.log("[I] selecting subpage", subpage.local);
	if (!subpage.local && globalManagementMode == 'web')
	{
		//swapBrowsers('web');
		if (!subpageTabs.getTab(id).nativeTab)
		{
			//console.log("[I] selecting subpage, opening tab");
			handleOpenTab = false;
			subpageTabs.getTab(id).openTab();
		}
	}
	else
	{
		//console.log("[I] selecting subpage, switching to local ", subpage.guid);
		//swapBrowsers('local');
		if(!subpageTabs.getTab(id).nativeTab)
		{
			handleOpenTab = false;
			subpageTabs.getTab(id).openTab();
		}
	}
	handleTabSwitch = false;
	subpageTabs.select(id);
}

/**
 * Selects any node from tree, based on it's type. Used mostly from tree view
 * @static
 * @param  {GUID|BaseObject} id
 */
function selectNode(id)
{
	var node = tree.getObject(id);
	handleTabSwitch = false;
	//var subpage = tree.getSelected('subpage');
	switch (node.type)
	{
		case 'link':
			tree.openLinkInPage(tree.getSelected('page'), id);
			break;

		case 'linkroot':
			/*var url = utils.getSetting("homepage", "string", "browser.startup.");
			debug && console.log("[I] Selected link root, url: " + url);*/
			var currentNode = tree.getSelected('page');
			if (currentNode)
				tree.openLinkInPage(currentNode, id);
			break;

		case 'page':
			tree.setDeepLastChild(id);
			break;

		case 'group':
			tree.setDeepLastChild(id);
			break;

		case 'panel':
			tree.setDeepLastChild(id);
			break;

		case 'curationroot':
			tree.openLinkInPage(tree.getSelected('page'), node);
			break;

		case 'curationfile':
			tree.openLinkInPage(tree.getSelected('page'), node);
			break;

		case 'curationgroup':
			tree.openLinkInPage(tree.getSelected('page'), node);
			break;

		case 'curationpage':
			tree.openLinkInPage(tree.getSelected('page'), node.link);
			break;
	}
}

/**
 * Closes oldest subpages if they are over the limit.
 */
function closeExtraSubpages() {
	var maxTabs = utils.getSetting("maxSubpageTabs", "int") || 15;
	if (subpageTabs.guids.length > maxTabs)
	{
		//console.log("[I] Subpages over the limit!");
		var tabs = subpageTabs.guids.slice();
		tabs.sort(function(a, b) {
			return subpageTabs.data[a].countdown > subpageTabs.data[b].countdown;
		});
		// do not close first tab, if it is a current tab
		if(tabs.indexOf(subpageTabs.selected) > -1) {
			tabs.splice(tabs.indexOf(subpageTabs.selected), 1);
			maxTabs --;
		}
		while(tabs.length > maxTabs) {
			tree.removeNode(tabs[0]);
			tabs.shift();
		}
	}
}

/**
 * Creates new subpage and subpage tab.<br>
 * Also it is a handler for tabs opened by user (e.g. Ctrl+click on a link).
 * @static
 * @param  {object} options key-value pairs of properties
 * @param {Tab} [options.tab] - native firefox tab, if user opened it
 * @param {GUID} [options.parent] - guid of parent object for subpage
 * @param {string} [options.url] - url for a new tab
 * @param {boolean} [options.managementMode] - tab mode
 */
function openSubpage(options)
{
	if (!handleOpenTab)
	{
		debug && console.log("[I] Not handling open tab");
		handleOpenTab = true;
		return null;
	}
	var result = null;
	debug && console.log("[I] Opening subpage, swapping to web");
	//swapBrowsers('web');
	debug && console.log("[I] Opening subpage tab", options);
	if (options.tab)
	{
		options.url = gBrowser.getBrowserForTab(options.tab).currentURI.spec;
		debug && console.log("[I] TAB EXISTS");
	}
	else
	{
		handleOpenTab = false;
	}
	var parent = options.parent || tree.getSelected("page").guid,
		id = options.guid || null;
	{
		debug && console.log("[I] and a new parent for subpage is", options.parent, tree.getObject(parent));
	}
	url = options.url || utils.getHomePage(),
	name = options.name || '...',
	canClose = options.canClose;
	if (!id)
	{
		debug && console.log("[I] Loading new subpage", options);
		if(options.local)
			url = 'about:blank';	
		var sp = objects.load(null,
		{
			parent: parent,
			type: 'subpage',
			url: url,
			name: name,
			local: options.local || false,
			node: options.node
		});
		id = sp.guid;
		debug && console.log("[I] Creating subpage " + sp.parent);
		tree.addNode(sp);
	}
	var spt = subpageTabs.addTab(id,
	{
		title: name,
		local: options.local || false,
		url: url,
		nativeTab: options.tab || null
	});

	if (!options.tab)
	{
		tree.setLastChild(sp);
	}

	closeExtraSubpages();
	updateTabs();

	return tree.getObject(id);
}

/**
 * Updates all tabs to ensure that only one of each is selected, and correct tabs are showed
 * @static
 */
function updateTabs()
{
	function realUpdate() {
		try
		{
			//console.log("[I] UPDATING TABS");
			var panel = tree.getPanelRoot().getLastChild(),
				group = tree.getObject(panel).getLastChild(),
				page = tree.getObject(group).getLastChild(),
				subpage = tree.getObject(page).getLastChild();
		}
		catch (e)
		{
			tabUpdateFlag = false;
			tabUpdateCounter++;
			if(tabUpdateCounter < 5)
				setTimeout(function() {
					updateTabs();
				}, 100);
			console.log("[I] Something wrong with tab updating", e);
			return;
		};

		if (group && page && subpage)
		{
			groupTabs.showList(tree.getObject(panel).children, group);

			//sidebar.contentWindow.refreshSelection();

			var pages = [];
			var curGroup = tree.getObject(group);
			for (var i = 0; i < curGroup.children.length; i++)
				pages.push(curGroup.children[i]);
			pageTabs.showList(pages, page);

			subpageTabs.showList(tree.getObject(page).children, subpage);
		}
		tabUpdateFlag = false;
		tabUpdateCounter = 0;
	}

	if(!tabUpdateFlag) {
		tabUpdateFlag = true;
		setTimeout(function() {
			realUpdate();
		}, tabUpdateInterval);
	}
}

/**
 * Updates sound indicator on tabs when sound starts/stops playing in subpage or when subpage is closed
 * @param  {Subpage} subpage tab which is changed sound state or closed
 */
function updateSoundIcon(subpage)
{
	var page = tree.getObject(subpage.parent);
	var group = tree.getObject(page.parent);
	var pagePlaying = false;
	for(var i=0; i<page.children.length; i++)
	{
		if(tree.getObject(page.children[i]).soundplaying)
			pagePlaying = true;
	}
	pageTabs.getTab(page.guid).setSoundIndicator(pagePlaying);

	var groupPlaying = false;
	for(var i=0; i<group.children.length; i++)
	{
		if(pageTabs.getTab(group.children[i]).soundplaying)
			groupPlaying = true;
	}
	groupTabs.getTab(group.guid).setSoundIndicator(groupPlaying);
}

/**
 * Creates new tab, according to it's type and node info
 * @static
 * @param  {BaseObject} node
 * @param {object} data additional data
 * @param {int} data.position index where to insert
 */
function openTab(node, data)
{
	debug && console.log('[I] Opening tab ' + node.name + '/' + node.type);
	switch (node.type)
	{
		case 'panel':
			// not opening a tab, but switching to freshly created panel
			//selectNode(node);
			refreshTree('panelroot');
			break;
		case 'group':
			groupTabs.addTab(node.guid,
			{
				title: node.name
			});
			if(!data.doNotSwitch)
				tree.setLastChild(node);
			refreshTree('panel');
			break;
		case 'page':
			pageTabs.addTab(node.guid,
			{
				title: node.name
			});
			if(!data.doNotSwitch)
				tree.setLastChild(node);
			refreshTree('panel');
			break;
		case 'subpage':
			// subpage tabs are opened via "openSubpage" function
			// because of complex interaction between ff tabs and our extension
			return;
			break;
		case 'link':
			// not actually opening a tab, just update tree
			refreshTree('link');
			break;
	}
	updateTabs();
}

/**
 * Finds and closes tab
 * @static
 * @param  {BaseObject} node
 */
function closeTab(node)
{
	debug && console.log("[I] Closing tab " + node.name);
	switch (node.type)
	{
		case 'panel':
			break;
		case 'group':
			groupTabs.removeTab(node.guid).close();
			break;
		case 'page':
			pageTabs.removeTab(node.guid).close();
			break;
		case 'subpage':
			var tab = subpageTabs.removeTab(node.guid);
			if (tab)
			{
				/* 
					Here is important kostyl:
					We've got selected page tab. If we close it, we also close native tab -> firefox will automatically switch to previous native tab and mess all our stuff.
					So there is a rule: never close the selected temp page, switch to another first. Or bugs will be coming.
				*/
				function closeSubpage()
				{
					if (tab.guid == subpageTabs.selected)
						setTimeout(function() {
							closeSubpage();
						}, 100);
					else {
						tab.close();
					}
					updateSoundIcon(node);
				}
				closeSubpage();
			}
			else
				debug && console.log("[I] No subpage!");
			break;
	}
	updateTabs();
}

/**
 * Updates tab and tab collection(if needed)
 * @static
 * @param  {BaseObject} node
 * @param  {string[]} properties - array of properties that need to be updated
 * @param  {object} data       - additional data that need for update
 */
function updateTab(node, properties, data)
{
	var tab,
		select = properties.indexOf('lastChild') > -1,
		swap = properties.indexOf('swap') > -1,
		link = properties.indexOf('link') > -1;
	switch (node.type)
	{
		case 'panelroot':
			if (select)
				selectPanel(node.getLastChild(), true);
			break;
		case 'panel':
			if (select)
				selectGroup(node.getLastChild(), true);
			if (swap)
				groupTabs.swapTabs(data.c1, data.c2);
			break;
		case 'group':
			tab = groupTabs.getTab(node.guid);
			if (select && groupTabs.selected == node.guid)
				selectPage(node.getLastChild(), true);
			if (swap)
				pageTabs.swapTabs(data.c1, data.c2);
			break;
		case 'page':
			tab = pageTabs.getTab(node.guid);
			if (select)
				selectSubpage(node.getLastChild(), true);
			if (swap)
				subpageTabs.swapTabs(data.c1, data.c2);
			/*if (link)
				tab.update(node);*/
			break;
		case 'subpage':
			tab = subpageTabs.getTab(node.guid);
			if(properties.indexOf('soundplaying') > -1)
			{
				tab.setSoundIndicator(node.soundplaying);
				updateSoundIcon(node);
			}
			break;
	}
	if (tab)
		tab.update(node, properties);
	if (swap)
		debug && console.log("[I] ", data);
	if (select)
		updateTabs();
}

/**
 * Handler for dragStart event
 * @static
 * @param  {GUID} guid - guid of tab that user drags
 */
function startTabDrag(guid)
{
	var tab = tree.getObject(guid);
	switch (tab.type)
	{
		case 'group':
			groupTabs.dragging = tab;
			break;
		case 'page':
			pageTabs.dragging = tab;
			break;
		case 'subpage':
			subpageTabs.dragging = tab;
			break;
	}
}

/**
 * Handler for event when user drags tab over another
 * @static
 * @param  {GUID} guid1 - dragged tab
 * @param  {GUID} guid2 - tab that is under dragged
 */
function swapTabs(guid1, guid2)
{
	var tab = tree.getObject(guid1);
	var parent = tree.getObject(tab.parent);
	tree.swapNodes(guid1, guid2);
}

/**
 * Function that adjusts "Delete tab" popup according to active tab (enables/disables button)
 * @static
 * @param  {Event} event
 */
function showDeletePopup(event)
{
	var tab = event.target.triggerNode;
	while (!tab.hasAttribute('data-guid'))
		tab = tab.parentNode;
	var type, node;
	if (tab.hasAttribute('data-type'))
	{
		type = tab.getAttribute('data-type');
		node = null;
	}
	else
	{
		node = tree.getObject(tab.getAttribute('data-guid'));
		type = node.type;
	}
	var menu = document.getElementById('oaff-tab-menu');

	for (var i = 0; i < menu.children.length; i++)
	{
		var show = menu.children[i].getAttribute('data-show');
		show = show ? JSON.parse(show) :
		{};
		if (show.type && show.type !== type || show.tab === false && node || show.tab === true && !node || show.hide && show.hide == type)
			menu.children[i].hidden = true;
		else
			menu.children[i].hidden = false;
	}

	//document.getElementById('oaff-tab-menu-hidePageTabs').setAttribute("checked", utils.getSetting("hidePageTabs", "bool"));
	//document.getElementById('oaff-tab-menu-hideGroupTabs').setAttribute("checked", utils.getSetting("hideGroupTabs", "bool"));

	document.getElementById('oaff-tab-menu-close').hidden = !node || (node.type != 'page');
	//document.getElementById('oaff-tab-menu-delete').hidden = !node;
	document.getElementById('oaff-tab-menu-delete').disabled = !node;
	if( (type == 'group' || type == 'page') && tree.getCountOfType(type) == 1)
	{
		document.getElementById('oaff-tab-menu-delete').disabled = true;
	}

	debug && console.log("[I] Type: " + type);
	document.getElementById('oaff-tab-menu-new').setAttribute('label', strings.getString('oaff.new.' + type));
	document.getElementById('oaff-tab-menu-new').setAttribute('data-type', type);
	document.getElementById('oaff-tab-menu-delete').setAttribute('label', strings.getString('oaff.delete.' + type));

	if (node && type == 'subpage')
	{
		var parent = tree.getObject(node.parent);
		document.getElementById('oaff-tab-menu-delete').disabled = parent.children.indexOf(node.guid) == 0;
	}

	tabUnderContext = node;
	barUnderContext = type;
}

/**
 * Handler for pressing "Delete tab" button in popup
 * @static
 * @param  {Event} event
 */
function deleteTabFromContext(event)
{
	if (tabUnderContext)
	{
		if (tabUnderContext)
			handleTabSwitch = false;
		tree.removeNode(tabUnderContext);
	}
}


/**
 * Handles clickon context menu item for closing a page. Also handles "Close all subpages" command in subpage context menu 
 * @param  {Event} event click event
 */
function closePageFromContext(event)
{
	if (tabUnderContext)
	{
		var node = tree.getObject(tabUnderContext);
		if (node.type == 'page')
			tree.closePage(tabUnderContext);
		if (node.type == 'subpage')
			tree.closePage(node.parent);
	}
	else
	{
		var page = tree.getSelected('page');
		tree.closePage(page);
	}
}

/**
 * Closes all subpages in page except selected one
 * @param  {Event} event
 */
function closeSubpagesFromContext(event)
{
	var tab = tree.getObject(tree.getSelected('subpage'));
	var page = tree.getObject(tab.parent);
	var limit = 2;
	if (page.children[0] == tab.guid)
		limit = 1;
	
	while (page.children.length > limit)
	{
		if (page.children[1] == tab.guid)
			tree.removeNode(page.children[2]);
		else
			tree.removeNode(page.children[1]);
	}
}

/**
 * All subpages
 * @param {Event} event 
 */
function closeAllSubpagesFromContext(event)
{
	var page = tree.getSelected('page');
	while(page.children.length > 1)
	{
		tree.removeNode(page.children[1]);
	}
}

/**
 * Handles click on "Properties" command in context menu. Shows properties of a tab
 * @param  {Event} event 
 */
function showPropertiesFromContext(event)
{
	Tabsmoz.showProperties(tabUnderContext);
}

/**
 * Function that passes model modifications to tree view
 * @static
 * @param  {object} data - information with changes in tree. Just data from "tabsmozTreeModified" event
 */
function updateTreeview(data)
{
	if (sidebar.contentWindow.tabsmozInit)
		sidebar.contentWindow.updateTree(data);
}

/**
 * Handler for "tabsmozTreeModified" event. Makes changes in UI in accordance with tree modifications
 * @static
 * @param  {Event} event
 */
function onTreeModified(event)
{
	var node = tree.getObject(event.detail.target.guid) || event.detail.target,
		action = event.detail.type;
	//debug && console.log('[I] Tree modified ', action);
	switch (action)
	{
		case 'add':
			openTab(node, event.detail.data);
			break;

		case 'delete':
			closeTab(node);
			break;

		case 'update':
			updateTab(node, event.detail.properties || [], event.detail.data);
			break;
	}
	updateTreeview(event.detail);
	if(globalBrowserState == 'local')
	{
		listView.contentWindow.updateListView(event.detail);
	}
}

/**
 * Hides one of browsers (list view or web view)
 * @param  {Browser} browser XUL browser element
 */
function hideBrowser (browser) {
	browser.removeAttribute('flex');
	browser.style.height = "0px";
	//browser.style.maxHeight = "0px";
}

/**
 *	Shows one of browsers (list view or web view)
 * @param  {Browser} browser XUL browser element
 */
function showBrowser (browser) {
	browser.setAttribute('flex', 1);
	browser.style.height = "auto";
	//browser.style.maxHeight = "auto";
}

/**
 * Switches between normal web browser and list view
 * @static
 * @param  {string} state 'local' or 'web'
 */
function swapBrowsers(state)
{
	if (!state)
		state = globalBrowserState == 'web' ? 'local' : 'web';
	var global = document.getElementById('content');
	if (globalBrowserState == 'local' && state != 'local')
	{
		debug && console.log('[I] Global Swapping to web');
		hideBrowser(listView);
		showBrowser(global);
		listView.contentWindow.reset();
	}
	if (globalBrowserState == 'web' && state != 'web')
	{
		debug && console.log('[I] Global Swapping to local');
		hideBrowser(global);
		showBrowser(listView);
	}
	globalBrowserState = state;
}

/**
 * Shows node info in list view. Switches to listview if necessary
 * @param  {GUID|BaseObject} node node to show
 * @param  {boolean} [swap] if true, forces listview to appear
 */
function showListViewNode(node, swap)
{
	node = tree.getObject(node);
	//console.log("[I] Showing listview node " + node.name);
	listView.contentWindow.showNode(node);
	if(swap)
	{
		swapBrowsers('local');
	}
}

/**
 * Handles event when rss feed has been loaded, and updates listview
 * @param  {Event} event 
 */
function rssLoaded(event)
{
	var data = event.detail;
	listView.contentWindow.unblockRefreshButton(data.target.guid);
}

/**
 * Toggles the toolbar opened/collapsed
 */
function toggleToolbar()
{
	var collapse = utils.getSetting('toolbarCollapsed', 'bool');
	collapse = !collapse;
	utils.saveSetting('toolbarCollapsed', 'bool', collapse);
	updateUI();
}

/**
 * Toggles management mode on/off
 */
function toggleManagementMode()
{
	globalManagementMode = globalManagementMode == 'web' ? 'local' : 'web';
	document.getElementById('oaff_cmd_switchManagementMode').setAttribute('state', globalManagementMode);
	document.getElementById('oaff-managementMode').setAttribute('checked', globalManagementMode == 'local');
	var page = tree.getSelected('page');
	var subpage = tree.getObject(page.getLastChild());
	//console.log("Switching MM to " + globalManagementMode);
	if(globalManagementMode == 'web')
	{
		//swapBrowsers('web');
		subpageTabs.select(subpage.guid);
	} else {
		if(subpage && subpage.node)
		{
			//console.log("[I] Toggle MM: setting subpage to link");
			//tree.setSubpageToLink(subpage, subpage.node);
			subpageTabs.select(subpage.guid);
		} else {
			//console.log("[I] Toggle MM: opening link in page");
			tree.openLinkInPage(page, page.link);
		}
	}
	//tree.setLastChild(page);	
}

/**
 * Adds event listeners for some global elements, like menu entries and custom events
 */
function addGlobalListeners()
{
	document.getElementById('oaff-tab-menu-new').addEventListener('mouseup', events.plusTabMouseUp);

	document.getElementById('oaff-tab-menu-properties').addEventListener('click', showPropertiesFromContext);

	document.getElementById('oaff_cmd_hidePageTabs').addEventListener('command', events.hidePageTabsClick);
	document.getElementById('oaff_cmd_hideGroupTabs').addEventListener('command', events.hideGroupTabsClick);
	document.getElementById('oaff_cmd_hidePageTabs').setAttribute('checked', utils.getSetting("hidePageTabs", "bool"));
	document.getElementById('oaff_cmd_hideGroupTabs').setAttribute('checked', utils.getSetting("hideGroupTabs", "bool"));
	document.getElementById('oaff_cmd_switchTabs').setAttribute('checked', utils.getSetting("switchTempTabs", "bool"));
	document.getElementById('oaff_cmd_hideAllTabs').addEventListener('command', events.hideAllTabsClick);
	document.getElementById('oaff_cmd_switchTabs').addEventListener('command', events.switchTabsClick);

	document.getElementById('oaff_cmd_toggleSidebar').addEventListener('command', events.toggleSidebar);
	document.getElementById('oaff_cmd_toggleToolbar').addEventListener('command', toggleToolbar);
	document.getElementById('oaff-toolbar-flag').addEventListener('click', toggleToolbar);
	document.getElementById('oaff_cmd_switchManagementMode').addEventListener('command', toggleManagementMode);

	//document.getElementById('oaff_cmd_newCurationFile').addEventListener('command', Tabsmoz.showCurationWizard);
	//document.getElementById('oaff_cmd_exportPanelTree').addEventListener('command', Tabsmoz.exportPanelTree);

	document.getElementById('oaff_cmd_createPanel').addEventListener('command', function()
	{
		var panel = tree.createPanel(
		{
			name: " ",
		}, true);
		window.parent.Tabsmoz.showProperties(panel, true);
	});

	var container = gBrowser.tabContainer;
	container.addEventListener("TabOpen", events.tabOpen, false);
	container.addEventListener("TabSelect", events.tabChange, false);
	container.addEventListener("TabClose", events.tabClose, false);
	container.addEventListener("TabAttrModified", events.tabAttributeModified, false);

	//utils.addTabsmozListener('tabsmozSubpageLoaded', events.updateSubpage, false);
	utils.addTabsmozListener(utils.treeModifiedEvent, onTreeModified, false);
	utils.addTabsmozListener(utils.uiModifiedEvent, updateUI, false);
	utils.addTabsmozListener(utils.faviconLoadEvent, updateFavicons, false);
	utils.addTabsmozListener(utils.rssLoadedEvent, rssLoaded, false);
}

/**
 * Reinitializes UI
 * @static
 */
function reset()
{
	//closeTabs();
	groupTabs.closeAll();
	pageTabs.closeAll();
	subpageTabs.closeAll();
	search.cancelSearch();
	launch = false;
	history.clear();
	setTimeout(function()
	{
		selectPanel(tree.getPanelRoot().getLastChild());
		if (sidebar.contentWindow.tabsmozInit)
		{
			console.log("[I] Reset - Refreshing tree");
			sidebar.contentWindow.refreshTree();
		}
	}, 0);
	createTabs();
}

/**
 * Inits interface part on startup
 * @static
 */
function init()
{
	if(initialized)
		return;
	initialized = true;
	sidebar = document.getElementById('sidebar');
	listView = document.getElementById('tabsmoz-browser');
	mainTabContainer = gBrowser.tabContainer;
	sidebarSelect = document.getElementById('tabsmoz-sidebar-select');
	strings = document.getElementById('oaff_string_bundle');
	debug && console.log("[I] Strings", strings);

	document.getElementById('oaff-context-panelroot').setAttribute('data-guid', tree.getPanelRoot().guid);

	// exporting functions to global scope, so event listeners in layout can use them
	window.Tabsmoz = window.Tabsmoz ||
	{};
	window.Tabsmoz.switchSidebar = switchSidebar;
	window.Tabsmoz.selectSidebar = selectSidebar;
	window.Tabsmoz.refreshTree = refreshTree;
	window.Tabsmoz.showDeletePopup = showDeletePopup;
	window.Tabsmoz.deleteTab = deleteTabFromContext;
	window.Tabsmoz.closePage = closePageFromContext;
	window.Tabsmoz.closeSubpages = closeSubpagesFromContext;
	window.Tabsmoz.closeAllSubpages = closeAllSubpagesFromContext;
	window.Tabsmoz.selectNode = selectNode;
	window.Tabsmoz.swapBrowsers = swapBrowsers;
	window.Tabsmoz.openSubpage = openSubpage;
	//window.Tabsmoz.
	window.Tabsmoz.closeTabClick = function(event)
	{
		events.closeTabClick(event);
	};
	window.Tabsmoz.createLink = function(data)
	{
		tree.createLink(data)
	};
	window.Tabsmoz.selectLink = function(guid)
	{
		tree.setSubpageToLink(subpageTabs.selected, guid);
	};
	window.Tabsmoz.getObject = function(guid)
	{
		return tree.getObject(guid);
	};
	window.Tabsmoz.getTree = function()
	{
		return tree;
	};
	window.Tabsmoz.getObject = function(guid)
	{
		return tree.getObject(guid);
	};
	window.Tabsmoz.getManagementMode = function()
	{
		return globalManagementMode;
	};

	// make sure we show only one browser at a time
	globalBrowserState = 'local';
	swapBrowsers('web');

	var ch = document.getElementById('main-window').getAttribute('chromehidden');
	if (ch.indexOf('menubar') > -1 && ch.indexOf('toolbar') > -1 && ch.indexOf('extrachrome') > -1)
	{
		// this is temporary modal window! Hide everything and leave
		document.getElementById('main-window').classList.add('oaff-disabled');
		return;
	}

	function initinit()
	{
		initSidebar();

		addGlobalListeners();

		history.init();
		search.init();

		menu.init(strings);

		updateUI();

		setTimeout(function()
		{
			selectPanel(tree.getPanelRoot().getLastChild());
		}, 0);
	}

	var closedMerged = false;
	function closeOrMerge()
	{
		gBrowser.removeProgressListener(myListener);
		if(closedMerged)
			return;
		closedMerged = true;

		var close = true;
		if (gBrowser.getBrowserForTab(gBrowser.tabs[0]).currentURI.scheme != 'about')
			close = false;

		if (close)
		{
			closeTabs();
			createTabs();
		}
		else
		{
			createTabs();
			mergeTabs();
		}
		initinit();
	}

	var {classes: Cc, interfaces: Ci, utils: Cu} = Components;
	var myListener = {
	    QueryInterface: XPCOMUtils.generateQI(["nsIWebProgressListener", "nsISupportsWeakReference"]),

	    onStateChange: function(aWebProgress, aRequest, aFlag, aStatus) {
	        if (aFlag && (aFlag & Ci.nsIWebProgressListener.STATE_STOP) ) {
            	closeOrMerge();
	        }
	    }
	}
	gBrowser.addProgressListener(myListener);

	setTimeout(function() {
		closeOrMerge();
	}, 5000);

	if(utils.getOSName() == "Darwin")
	{
		document.getElementById("browser-panel").classList.add("oaff-mac");
		document.getElementById("titlebar").classList.add("oaff-mac");
	}
}

module.exports = {
	init: init,
	reset: reset,
	closeTabs: closeTabs,
	showTree: showTree,
	createTabs: createTabs,
	selectPanel: selectPanel,
	selectGroup: selectGroup,
	selectPage: selectPage,
	selectSubpage: selectSubpage,
	swapBrowsers: swapBrowsers,
	openSubpage: openSubpage,
	startTabDrag: startTabDrag,
	swapTabs: swapTabs,
	showListViewNode: showListViewNode,
	getSelectedPanel: function()
	{
		return tree.getPanelRoot().getLastChild();
	},
	getSelectedGroup: function()
	{
		return groupTabs.selected;
	},
	getSelectedPage: function()
	{
		return pageTabs.selected;
	},
	getSelectedSubpage: function()
	{
		return subpageTabs.selected;
	},
	setSwitchHandleFlag: function(value)
	{
		handleTabSwitch = value === undefined ? true : value;
	},
	getSwitchHandleFlag: function()
	{
		return handleTabSwitch;
	},
	setCloseHandleFlag: function(value)
	{
		handleCloseTab = value ? true : false;
	},
	getCloseHandleFlag: function()
	{
		return handleCloseTab;
	},
	getManagementMode: function()
	{
		return globalManagementMode;
	},
	getTab: function(guid)
	{
		var tab = null;
		return subpageTabs.getTab(guid) || pageTabs.getTab(guid) || groupTabs.getTab(guid) || null;
	},
	getString: function(id)
	{
		strings = strings || document.getElementById('oaff_string_bundle');
		try {
			return strings.getString(id);
		} catch(e) {
			console.log("No string:", id);	
			return "[no string]";
		}
	}
};

var tree = require('../model/tree.js'),
	objects = require('../model/objects.js'),
	tabs = require('./tabs.js'),
	events = require('./events.js'),
	utils = require('../utils.js'),
	menu = require('./mainmenu.js'),
	search = require('./search.js'),
	history = require('../model/history.js'),
	tabCollections = require('./tab-collection.js');
},{"../model/history.js":7,"../model/objects.js":8,"../model/tree.js":9,"../utils.js":11,"./events.js":13,"./mainmenu.js":15,"./search.js":16,"./tab-collection.js":17,"./tabs.js":18}],15:[function(require,module,exports){
/**
 * Operates with main menu entry
 * @module mainmenu
 */

const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";

var newLabels = {
	"panelroot": "panel",
	"panel": "group",
	"group": "page",
	"linkroot": "link",
	"link": "link"
};

var debug = false;

var strings = null;

/**
 * Removes all children of node
 * @param  {Element} node
 */
function clearChildren(node)
{
	while (node.hasChildNodes())
	{
		node.removeChild(node.firstChild);
	}
}

/**
 * Creates menuitem element with specified label and data-id
 * @param  {string} label
 * @param  {string} guid
 * @return {Element}	menuitem element
 */
function createMenuitem(label, guid)
{
	if (label === null)
	{
		var item = document.createElementNS(XUL_NS, "menuseparator"); // create a new XUL menuitem
	}
	else
	{
		var item = document.createElementNS(XUL_NS, "menuitem"); // create a new XUL menuitem
		item.setAttribute("label", label);
	}
	return item;
}

/**
 * Handles click on "New" entry in popup menu
 * @param  {Event} event
 */
function newClick(event)
{
	var target = event.target;
	var id = target.getAttribute('data-parent');
	if (!id)
		return;
	var node = tree.getObject(id);
	switch (node.type)
	{
		case 'panelroot':
			var panel = tree.createPanel(
			{
				name: "",
			}, true);
			window.parent.Tabsmoz.showProperties(panel, true);
			break;
		case 'panel':
			var group = tree.createGroup(
			{
				name: "",
				parent: node.guid
			}, true);
			window.parent.Tabsmoz.showProperties(group, true);
			break;
		case 'group':
			var page = tree.createPage(
			{
				name: "",
				parent: node.guid
			}, true);
			window.parent.Tabsmoz.showProperties(page, true);
			break;
		case 'linkroot':
		case 'link':
			var link = tree.createLink(
			{
				name: "",
				url: "http://",
				parent: node.guid
			}, true);
			window.parent.Tabsmoz.showProperties(link, true);
			break;
	}
}

function nodeClick(event)
{
	console.log("[MM] Click");
	var target = event.target;
	var id = target.getAttribute('data-guid');
	if (!id)
		return;
	var node = tree.getObject(id);
	Tabsmoz.selectNode(node);
	var popups = document.querySelectorAll('menupopup[data-type="panelroot"]');
	for(var i=0; i<popups.length; i++)
		popups[i].hidePopup();
}

/**
 * Fills popup menu for node with it's children and "New" button
 * @param  {Element} menu "menupopup" element to fill
 * @param  {BaseObject} data node to get information from
 */
function fillMenupopup(menu, data)
{
	var strings = document.getElementById('oaff_string_bundle');
	var newLabel = newLabels[data.type];
	var createNew = createMenuitem(strings.getString('oaff.new.' + newLabel));
	createNew.setAttribute('data-parent', data.guid);
	// set oncommand etc
	createNew.addEventListener('click', newClick);
	menu.appendChild(createNew);
	menu.appendChild(createMenuitem(null, null));
	if (data.children.length && data.type != 'page' && data.type != 'group')
	{
		for (var i = 0; i < data.children.length; i++)
		{
			var childmenu = document.createElementNS(XUL_NS, "menu");
			var child = tree.getObject(data.children[i]);
			childmenu.classList.add('menu-iconic');
			if(child.guid == data.lastChild)
				childmenu.setAttribute('image', 'chrome://store.tabsmoz/content/common/check.png');
			childmenu.setAttribute("label", child.name);
			childmenu.setAttribute("data-guid", child.guid);
			console.log("[MM] Adding click listener " + child.guid);
			childmenu.addEventListener("click", nodeClick);
			var menupopup = document.createElementNS(XUL_NS, "menupopup");
			menupopup.setAttribute("data-guid", child.guid);
			menupopup.setAttribute("data-type", child.type);
			//menupopup.onpopupshowing = function(event) { Tabsmoz.showPanelManager(event); };
			menupopup.addEventListener("popupshowing", Tabsmoz.showPanelManager);
			childmenu.appendChild(menupopup);
			menu.appendChild(childmenu);
		}
	}
	if (data.type == 'group' && data.children.length)
	{
		for (var i = 0; i < data.children.length; i++)
		{
			var child = tree.getObject(data.children[i]);
			var page = createMenuitem(child.name, child.guid);
			page.classList.add('menuitem-iconic');
			if(child.guid == data.lastChild)
				page.setAttribute('image', 'chrome://store.tabsmoz/content/common/check.png');
			page.setAttribute("data-guid", child.guid);
			page.addEventListener("click", nodeClick);
			menu.appendChild(page);
		}
	}
}

/**
 * Handler of event when user hovers over menu item that corresponds to a tree node
 * @param  {Event} event
 */
function showPanelManager(event)
{
	var target = event.target;
	var type = target.getAttribute('data-type');
	var guid = target.getAttribute('data-guid');
	if(type == 'panelroot')
		guid = tree.getPanelRoot().guid;
	debug && console.log("[MM] Guid: " + guid);
	var node = tree.getObject(guid);
	clearChildren(target);
	fillMenupopup(target, node);
}

/**
 * Handles clicks in "recent files" menu
 * @param  {Event} event
 */
function recentFileClick(event)
{
	var target = event.target;
	var file = target.getAttribute('data-file');
	Tabsmoz.loadFile(file);
}

/**
 * Checks list of recent files if all of them are existing
 * @param  {Event} event [description]
 */
function checkRecentFiles(event)
{
	var files = utils.getSetting('recentFiles', 'string');
	var FileUtils = Cu.import("resource://gre/modules/FileUtils.jsm").FileUtils;
	if (files)
	{
		files = JSON.parse(files);
		for (var i = 0; i < files.length; i++)
		{
			var f = new FileUtils.File(files[i]);
			if (!f.exists())
			{
				files.splice(i, 1);
				i--;
			}
		}
	}
	if (files && files.length)
	{
		utils.saveSetting('recentFiles', 'string', JSON.stringify(files));
		document.getElementById('tabsmoz-recentFiles-entry').disabled = false;
	}
	else
	{
		document.getElementById('tabsmoz-recentFiles-entry').disabled = true;
	}
}

/**
 * Checks list of recent files and builds a menu for it
 * @param  {Event} event
 */
function showRecentFiles(event)
{
	var files = utils.getSetting('recentFiles', 'string');
	var FileUtils = Cu.import("resource://gre/modules/FileUtils.jsm").FileUtils;
	var popup = document.getElementById('tabsmoz-recentFiles-popup');
	clearChildren(popup);
	if (files)
	{
		files = JSON.parse(files);
		for (var i = 0; i < files.length; i++)
		{
			var f = new FileUtils.File(files[i]);
			var item = createMenuitem(f.leafName);
			if(i == 0)
			{
				item.classList.add('menuitem-iconic');
				item.setAttribute('image', 'chrome://store.tabsmoz/content/common/check.png');
			}
			item.setAttribute('data-file', files[i]);
			item.addEventListener('command', recentFileClick);
			popup.appendChild(item);
		}
	}
}


/**
 * Initializes main menu on startup
 * @static
 */
function init(strings)
{
	var panelrootGuid = tree.getPanelRoot().guid;
	document.getElementById('tabsmoz-menu-panelroot').setAttribute('data-guid', panelrootGuid);

	strings = document.getElementById('oaff_string_bundle');
	debug && console.log("[MM]", strings);

	window.Tabsmoz = window.Tabsmoz ||
	{};
	Tabsmoz.showPanelManager = showPanelManager;
	Tabsmoz.showRecentFiles = showRecentFiles;
	Tabsmoz.checkRecentFiles = checkRecentFiles;
}

module.exports = {
	init: init
};

var tree = require('../model/tree.js'),
	objects = require('../model/objects.js'),
	events = require('./events.js'),
	utils = require('../utils.js');
},{"../model/objects.js":8,"../model/tree.js":9,"../utils.js":11,"./events.js":13}],16:[function(require,module,exports){

var searchNode = null,
	searchBox = null,
	currentSearch = null,
	currentSubpage = null;

var debug = false;

var wasSidebarOpen = false;
var isOpen = false;

function showSearchBox()
{
	if(isOpen)
		return;
	wasSidebarOpen = SidebarUI.isOpen;
	document.getElementById('sidebar-header').classList.add('oaff-hidden');
	document.getElementById('sidebar').classList.add('oaff-hidden');
	document.getElementById('oaff-search-panel').classList.remove('oaff-hidden');
	var lastSidebar = utils.getSetting('lastSidebar', 'string') || "tabsmozPanelSidebar";
	SidebarUI.show(lastSidebar);
	searchBox.focus();
	isOpen = true;
}

function hideSearchBox()
{
	if(!isOpen)
		return;
	var sidebarStatus = SidebarUI.isOpen;
	var reload = false;
	if(!document.getElementById('oaff-search-panel').classList.contains('oaff-hidden'))
		reload = true;
	document.getElementById('sidebar-header').classList.remove('oaff-hidden');
	document.getElementById('sidebar').classList.remove('oaff-hidden');
	document.getElementById('oaff-search-panel').classList.add('oaff-hidden');
	currentSubpage = null;
	currentSearch = null;
	isOpen = false;
	if(reload)
		setTimeout(function() {
			console.log("[S] reload");
			document.getElementById('sidebar').reload();
		}, 100);
	if(sidebarStatus && !wasSidebarOpen)
	{
		SidebarUI.hide();
	}
}

function initSearch(subpage)
{
	var sp = subpage ? tree.getObject(subpage) : tree.getSelected('subpage');
	var container = tree.getObject(sp.node);
	if(sp.node && container && container.type == 'search')
	{
		console.log("[S] Reusing search");
		showSearchBox();
		currentSearch = container;
		currentSubpage = sp;
		searchBox.value = currentSearch.term;
		if(currentSearch)
		{
			document.getElementById('oaff-search-tabs').checked = currentSearch.searchTabs;
			document.getElementById('oaff-search-rss').checked = currentSearch.searchRSS;
			document.getElementById('oaff-search-curation').checked = currentSearch.searchCuration;
		}
	} else {
		console.log("[S] Creating search");
		container = new objects.search(null, null, {});
		tree.addNode(container);
		currentSubpage = xul.openSubpage({
			node: container.guid,
			name: 'Search',
			url: 'about:blank',
			local: true
		});
	}
}

function cancelSearch()
{
	if(currentSubpage)
	{
		tree.removeNode(currentSubpage);
		currentSubpage = null;
		currentSearch = null;
	}
	hideSearchBox();
}

function onTreeModified(event)
{
	var data = event.detail;
	var node = tree.getObject(data.target.node);
	if(data.type == 'delete' && data.target.type == 'subpage' && node && node.type == 'search')
	{
		tree.removeNode(data.target.node);
		if(currentSubpage && currentSubpage.guid == data.target.guid)
		{
			currentSubpage = null;
			currentSearch = null;
			cancelSearch();
		}
	}
}

function doSearch () 
{
	if(!currentSearch)
	{
		return;
	}

	currentSearch.searchTabs = document.getElementById('oaff-search-tabs').checked;
	currentSearch.searchRSS = document.getElementById('oaff-search-rss').checked;
	currentSearch.searchCuration = document.getElementById('oaff-search-curation').checked;
	currentSearch.searchAuthor = document.getElementById('oaff-search-author').checked;
	currentSearch.searchDescription = document.getElementById('oaff-search-description').checked;
	currentSearch.searchTwitter = document.getElementById('oaff-search-twitter').checked;
	currentSearch.searchPublisher = document.getElementById('oaff-search-publisher').checked;
	currentSearch.searchHeadline = document.getElementById('oaff-search-headline').checked;
	currentSearch.searchTags = document.getElementById('oaff-search-tags').checked;

	function quote (str) 
	{
    	return (str+'').replace(/[.?*+^$[\]\\(){}|-]/g, "\\$&");
	}
	var term = searchBox.value.trim().toLowerCase();
	var search = currentSearch;
	search.term = term;
	search.children = [];
	var regex = new RegExp(quote(term), 'i');
	function traverse (node) {
		if(node.type !== 'panelroot' && (regex.test(node.name) || regex.test(node.comment)) )
		{
			search.children.push(node.guid);
		}
		if(node.type == 'page')
		{
			var link = tree.getObject(node.link);
			if(link && (regex.test(link.name) || regex.test(link.comment)))
				search.children.push(node.link);
			return;
		}
		for(var i=0; i<node.children.length; i++)
		{
			traverse(tree.getObject(node.children[i]));
		}
		/*if(node.links)
		{
			for(var i=0; i<node.links.length; i++)
			{
				var link = tree.getObject(node.links[i]);
				if(regex.test(link.headline) || regex.test(link.description) || regex.test(link.title) || regex.test(link.content))
					search.children.push(link.guid);
			}
		}*/
	}

	if(currentSearch.searchTabs)
		traverse(tree.getPanelRoot());
	var links = null;
	if(currentSearch.searchRSS || currentSearch.searchCuration)
	{
		links = tree.getArrayOfType('link');
		for(var i=0; i<links.length; i++)
		{
			var link = links[i];
			if(link.linkType == 'rss' && currentSearch.searchRSS)
			{
				for(var j=0; j<link.links.length; j++)
				{
					var item = tree.getObject(link.links[j]);
					if(regex.test(item.title) || regex.test(item.content))
						search.children.push(item.guid);
				}
			}
			if(link.linkType == 'curation' && currentSearch.searchCuration)
			{
				for(var j=0; j<link.links.length; j++)
				{
					var item = tree.getObject(link.links[j]);
					if((currentSearch.searchHeadline && regex.test(item.headline)) ||
					   (currentSearch.searchDescription && regex.test(item.description)) ||
					   (currentSearch.searchAuthor && regex.test(item.author)) ||
					   (currentSearch.searchPublisher && regex.test(item.publisher)) ||
					   (currentSearch.searchTags && regex.test(item.tags)) ||
					   (currentSearch.searchTwitter && regex.test(item.twitter)))
							search.children.push(item.guid);
				}
			}
		}
	}
	//traverse(tree.getLinkRoot());
	//
	if(search.children.length == 0)
	{
		Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                              .getService(Components.interfaces.nsIPromptService).alert(window, "Optimal Access", xul.getString('oaff.nothingFound'));
	}

	if(currentSubpage)
	{
		currentSubpage.name = 'Search "' + term + '"';
		utils.emitEvent(utils.treeModifiedEvent,
		{
			target: currentSubpage,
			type: 'update',
			properties: ['name']
		});
	}

	utils.emitEvent(utils.treeModifiedEvent,
	{
		target: search,
		type: 'update',
		properties: []
	});
}

function saveSearch()
{
	console.log("boop");
	if(currentSearch)
	{
		currentSearch.term = searchBox.value;
		currentSearch.searchTabs = document.getElementById('oaff-search-tabs').checked;
		currentSearch.searchRSS = document.getElementById('oaff-search-rss').checked;
		currentSearch.searchCuration = document.getElementById('oaff-search-curation').checked;
		currentSearch.searchAuthor = document.getElementById('oaff-search-author').checked;
		currentSearch.searchDescription = document.getElementById('oaff-search-description').checked;
		currentSearch.searchTwitter = document.getElementById('oaff-search-twitter').checked;
		currentSearch.searchPublisher = document.getElementById('oaff-search-publisher').checked;
		currentSearch.searchHeadline = document.getElementById('oaff-search-headline').checked;
	}
}

function toggleCurationSearch()
{
	console.log("beep");
	document.getElementById("oaff-search-columns").hidden = !document.getElementById('oaff-search-curation').checked;
}

function init () 
{
	searchBox = document.getElementById('oaff-search-term');

	document.getElementById('oaff_cmd_initSearch').addEventListener('command', initSearch);
	document.getElementById('oaff_cmd_cancelSearch').addEventListener('command', cancelSearch);
	document.getElementById('oaff-search-button').addEventListener('command', doSearch);

	var options = document.querySelectorAll('.oaff-search-option');
	for(var i=0; i<options.length; i++)
	{
		options[i].addEventListener('click', saveSearch);
	}
	document.getElementById('oaff-search-curation').addEventListener('click', toggleCurationSearch);

	searchBox.addEventListener('keypress', function (event) 
	{
		saveSearch();
		if (event.which == 13 || event.keyCode == 13) {
	        doSearch();
	    }
	});

	utils.addTabsmozListener(utils.treeModifiedEvent, onTreeModified, false);

	debug && console.log("[S] Init!");
}

module.exports = {
	init: init,
	cancelSearch: cancelSearch,
	initSearch: initSearch,
	hideSearchBox: hideSearchBox,
	showSearchBox: showSearchBox
};

var tree = require('../model/tree.js'),
	objects = require('../model/objects.js'),
	tabs = require('./tabs.js'),
	events = require('./events.js'),
	utils = require('../utils.js'),
	menu = require('./mainmenu.js'),
	xul = require('./interface.js'),
	history = require('../model/history.js'),
	tabCollections = require('./tab-collection.js');
},{"../model/history.js":7,"../model/objects.js":8,"../model/tree.js":9,"../utils.js":11,"./events.js":13,"./interface.js":14,"./mainmenu.js":15,"./tab-collection.js":17,"./tabs.js":18}],17:[function(require,module,exports){
/**
 * @module tab-collection
 */

var utils = require('../utils.js');

var debug = false;


var TabCollection = function() {

}

TabCollection.prototype.init = function(containers, templates)
{
	// tabs guids stored in order
	this.guids = [];
	// tab objects themselves
	this.data = {};

	this.containers = [];
	for (var i = 0; i < containers.length; i++)
	{
		this.containers.push(document.getElementById(containers[i]));
		containers[i]._selectNewTab = function () {};
	}

	this.templates = [];
	for (var i = 0; i < templates.length; i++)
	{
		this.templates.push(document.getElementById(templates[i]));
	}

	this.selected = null;
	this.dragging = null;
};

/**
 * Hides the tab collection. Used by "hide group/page tab bar" option.
 */
TabCollection.prototype.hide = function()
{
	this.containers.forEach(function(val, idx)
	{
		//val.hidden = true;
		val.setAttribute('hidden', true);
	});
}

/**
 * Hides the tab collection. Used by "hide group/page tab bar" option.
 */
TabCollection.prototype.show = function(side)
{
	if (!side)
	{
		this.containers.forEach(function(val, idx)
		{
			//val.hidden = false;
			val.removeAttribute('hidden');
		});
	}
	else
	{
		this.containers.forEach(function(val, idx)
		{
			if (val.id.indexOf('-' + side) > -1)
				//val.hidden = false;
				val.removeAttribute('hidden');
			else
				//val.hidden = true;
				val.setAttribute('hidden', true);
		});
	}
}

/**
 * Adds already created tab to collection
 * @param  {BaseTab} tab
 */
TabCollection.prototype.pushTab = function(tab)
{
	if (!this.data[tab.guid])
	{
		this.data[tab.guid] = tab;
		this.guids.push(tab.guid);
	}
	else
	{
		debug && console.log("[TC] Tab already exists " + tab.guid);
	}
}

/**
 * Creates a new tab and adds it to collection
 * @param {GUID} id       - id of object associated with tab
 * @param {object} options  key-value pairs of tab properties
 * @param {boolean} [selected] flag if new tab should be selected
 * @return {BaseTab} created tab
 */
TabCollection.prototype.addTab = function(id, options, selected)
{
	var tab;
	debug && console.log('[TC] Adding tab ' + id);
	switch (this.type)
	{
		case 'group':
			tab = new tabs.GroupTab(id, options);
			break;
		case 'page':
			tab = new tabs.PageTab(id, options);
			break;
		case 'subpage':
			options.canClose = this.guids.length > 0;
			tab = new tabs.SubpageTab(id, options);
			break;
	}
	this.pushTab(tab);
	if (selected)
		this.select(id);
	return tab;
}

/**
 * Removes tab from collection and returns it (not visually hiding it. To destroy tab completely, call close() method of returned tab)
 * @param  {GUID} guid
 * @return {BaseTab}      removed tab
 */
TabCollection.prototype.removeTab = function(guid)
{
	if (this.data[guid])
	{
		this.guids.splice(this.guids.indexOf(guid), 1);
		var tab = this.data[guid];
		delete this.data[guid];
		return tab;
	}
	debug && console.log("[TC] No tab found", guid);
	return null;
}


/**
 * Hides particular tab in collection. Basically a shortcut for <i>collection.getTab(id).hide()</i>
 * @param  {GUID} guid GUID of tab
 */
TabCollection.prototype.hideTab = function(guid)
{
	if (this.data[guid])
	{
		this.data[guid].hide();
	}
}

/**
 * Toggles showing tooltips (when hover over tabs)
 * @param  {boolean} on         enables tooltips if true, disables if false
 * @param  {function} getTooltip callback for getting tooltip. Accepts GUID as parameter and sholud return string.
 */
TabCollection.prototype.switchTooltips = function(on, getTooltip)
{
	if (on)
	{
		this.guids.forEach(function(val, idx)
		{
			this.data[val].setTooltip(getTooltip(val));
		}, this);
	}
	else
	{
		this.guids.forEach(function(val, idx)
		{
			this.data[val].setTooltip("");
		}, this);
	}
}

/**
 * Closes all tab in collection
 */
TabCollection.prototype.closeAll = function()
{
	while (this.guids.length)
	{
		this.removeTab(this.guids[0]).close();
	}
	debug && console.log("[TC] Tabs closed: " + this.guids);
}

/**
 * Utility function, similar to "insertBefore" from DOM API
 * @param  {Element} newNode
 * @param  {Element} referenceNode
 */
function insertAfter(newNode, referenceNode)
{
	referenceNode.parentNode.insertBefore(newNode, referenceNode.nextSibling);
}

/**
 * Utility function that returns position of a children in array of siblings
 * @param  {Element} node - child node
 * @return {Number}      index of node
 */
function getChildNumber(node)
{
	return Array.prototype.indexOf.call(node.parentNode.childNodes, node);
}

/**
 * Swaps two tabs. Removing first tab and inserts it at position of second tab. Used mostly for drag&drop
 * @param  {GUID} guid1 guid of first tab
 * @param  {GUID} guid2 guid of second tab
 */
TabCollection.prototype.swapTabs = function(guid1, guid2)
{
	var i1 = this.guids.indexOf(guid1),
		i2 = this.guids.indexOf(guid2);
	/*debug &&*/
	console.log("[TC] swap " + i1 + " " + i2);
	if (i1 == i2)
		return;
	var tabs1 = this.getElements(guid1),
		tabs2 = this.getElements(guid2);
	tabs1.forEach(function(val, idx)
	{
		val.parentNode.removeChild(val);
	});
	if (i1 > i2)
	{
		this.containers.forEach(function(val, idx)
		{
			tabs2[idx].parentNode.insertBefore(tabs1[idx], tabs2[idx]);
		});
	}
	else
	{
		this.containers.forEach(function(val, idx)
		{
			insertAfter(tabs1[idx], tabs2[idx]);
		});
	}
	this.guids.splice(i1, 1);
	this.guids.splice(i2, 0, guid1);
}

/**
 * Returns Tab object for given GUID
 * @param  {GUID} id 
 * @return {Tab|undefined}
 */
TabCollection.prototype.getTab = function(id)
{
	return this.data[id];
};

TabCollection.prototype.getElements = function(id)
{
	return this.data[id].elements;
}

/**
 * Hides all tabs and shows only the specified
 * @param  {GUID[]} list
 * @param  {GUID} [selected] - optional
 */
TabCollection.prototype.showList = function(list, selected)
{
	this.guids.forEach(function(val, index)
	{
		this.data[val].hide();
		this.data[val].unselect();
	}, this);

	list.forEach(function(val, index)
	{
		if (this.data[val])
		{
			this.data[val].show();
		}
	}, this);

	if (selected && this.data[selected])
	{
		this.data[selected].select();
	}
}

/**
 * Highlights one tab, dims another
 * @param  {GUID} guid - guid of tab to select
 */
TabCollection.prototype.select = function(guid)
{
	if (this.data[guid])
	{
		this.guids.forEach(function(val, index)
		{
			this.data[val].unselect();
		}, this);
		this.data[guid].select();
		this.data[guid].show();
		this.selected = guid;
	}
}

/**
 * Group tab collection constructor
 * @class GroupTabCollection
 * @extends {TabCollection}
 */
function GroupTabCollection()
{
	this.init(['oaff-groups-top', 'oaff-tabs-left', 'oaff-tabs-right'], ['oaff-group-top-template', 'oaff-group-left-template', 'oaff-group-right-template']);

	this.containers.forEach(function(val, idx)
	{
		val.addEventListener('dragover', events.groupTabBarDragOver);
		val.addEventListener('drop', events.groupDrop);
		val.querySelector('.oaff-addtab').addEventListener('mouseup', events.plusTabMouseUp);
	});
}
utils.extend(GroupTabCollection.prototype, TabCollection.prototype);

GroupTabCollection.prototype.addTab = function(id, options, selected)
{
	var tab;
	debug && console.log('[TC] Adding group tab ' + id);
	tab = new tabs.GroupTab(id, options, this.templates);
	this.pushTab(tab);
	if (selected)
		this.select(id);
	return tab;
}

/**
 * Page tab collection constructor
 * @class PageTabCollection
 * @extends {TabCollection}
 */
function PageTabCollection()
{
	this.init(['oaff-pages-top'], ['oaff-page-top-template']);

	this.containers.forEach(function(val, idx)
	{
		val.addEventListener('dragover', events.pageTabBarDragOver);
		val.addEventListener('drop', events.pageDrop);
		val.querySelector('.oaff-addtab').addEventListener('mouseup', events.plusTabMouseUp);
	});
}
utils.extend(PageTabCollection.prototype, TabCollection.prototype);

PageTabCollection.prototype.addTab = function(id, options, selected)
{
	var tab;
	debug && console.log('[TC] Adding page tab ' + id);
	tab = new tabs.PageTab(id, options, this.templates);
	this.pushTab(tab);
	if (selected)
		this.select(id);
	return tab;
}

/**
 * Subpage tab collection constructor
 * @class  SubpageTabCollection
 * @extends {TabCollection}
 */
function SubpageTabCollection()
{
	this.init(['oaff-subpages-top', 'oaff-tabs-bottom'], ['oaff-subpage-top-template', 'oaff-subpage-bottom-template']);

	this.containers.forEach(function(val, idx)
	{
		val.addEventListener('dragover', events.subpageTabBarDragOver);
		val.addEventListener('drop', events.subpageDrop);
		val.querySelector('.oaff-addtab').addEventListener('mouseup', events.plusTabMouseUp);
	});
}
utils.extend(SubpageTabCollection.prototype, TabCollection.prototype);

SubpageTabCollection.prototype.addTab = function(id, options, selected)
{
	var tab;
	debug && console.log('[TC] Adding subpage tab ' + id);
	tab = new tabs.SubpageTab(id, options, this.templates);
	this.pushTab(tab);
	if (selected)
		this.select(id);
	return tab;
}

module.exports = {
	GroupTabCollection: GroupTabCollection,
	PageTabCollection: PageTabCollection,
	SubpageTabCollection: SubpageTabCollection
};

var tabs = require('./tabs.js'),
	events = require('./events.js');
},{"../utils.js":11,"./events.js":13,"./tabs.js":18}],18:[function(require,module,exports){
/**
 * @module tabs
 */

var utils = require('../utils.js');

var PREFIX = 'oaff';

var debug = false;

function stub () {

};

/**
 * Constructor of BaseTab class. Just creates an instance, to initialize use "init" method
 * @class  BaseTab
 */
function BaseTab()
{

}

/**
 * Initializes tab object
 * @param  {string} templateId id of template xul element. Follows pattern "tabsmoz-[type]tab-template"
 * @param  {GUID} id         guid of associated object. Will be stored in "data-guid" attribute, and used for element id
 * @param  {object} options    key-value pairs of properties
 */
BaseTab.prototype.init = function(templates, id, options)
{
	this.elements = [];

	templates.forEach(function(val, idx)
	{
		var el = val.cloneNode(true);
		el.id = PREFIX + '-' + idx + '-' + id;
		el.setAttribute('data-guid', id);

		el.addEventListener('mouseup', events.tabMouseUp);
		el.addEventListener('dragstart', events.tabDragStart);
		el.addEventListener('dragenter', events.tabDragEnter);
		el.addEventListener('dragleave', events.tabDragLeave);

		val.parentNode.insertBefore(el, val.parentNode.lastChild);

		// hack to prevent errors with native tab bindings (tabbox.xml)
		val.parentNode._selectNewTab = val.parentNode._selectNewTab || stub;

		this.elements.push(el);
	}, this);

	debug && console.log("[TABS] Elements: ", this.elements.length);

	this.selected = false;

	this.guid = id;
	this.soundplaying = false;
	this.lastTab = null;
	this.setText(options.title);
}

/**
 * Simply hides the tab
 */
BaseTab.prototype.hide = function()
{
	this.elements.forEach(function(val, idx)
	{
		val.hidden = true;
	});
}

/**
 * Makes tab visible
 */
BaseTab.prototype.show = function()
{
	this.elements.forEach(function(val, idx)
	{
		debug && console.log("[TABS] Showing");
		val.hidden = false;
	});
	this.update(Tabsmoz.getObject(this.guid));
}

/**
 * Visually highlights tab
 */
BaseTab.prototype.select = function()
{
	this.selected = true;
	this.elements.forEach(function(val, idx)
	{
		val.classList.add('oaff-tab-active');
		val._visuallySelected = true; //.setAttribute('visuallyselected', 'true');
		if (val.parentNode.ensureElementIsVisible)
			val.parentNode.ensureElementIsVisible(val);
	});
}

/**
 * Removes highlight from tab
 */
BaseTab.prototype.unselect = function()
{
	this.selected = false;
	this.elements.forEach(function(val, idx)
	{
		val.classList.remove('oaff-tab-active');
		val._visuallySelected = false; //.removeAttribute('visuallyselected');
	});
}

BaseTab.prototype.setSoundIndicator = function(on)
{
	if(on)
	{
		this.elements.forEach(function(val, idx)
		{
			val.classList.add('soundplaying');
		});
	} else {
		this.elements.forEach(function(val, idx)
		{
			val.classList.remove('soundplaying');
		});
	}
	this.soundplaying = on;
}

/**
 * Sets tab title (trims if necessary)
 * @param {string} text
 */
BaseTab.prototype.setText = function(text)
{
	this.elements.forEach(function(val, idx)
	{
		var desc = val.getElementsByTagName('description');
		if (desc.length)
			desc[0].textContent = text;
		val.setAttribute('label', text);
	});
}

/**
 * Sets tooltip text for tab
 * @param {string} text 
 */
BaseTab.prototype.setTooltip = function(text)
{
	this.elements.forEach(function(val, idx)
	{
		val.setAttribute('tooltiptext', text);
	});
}

/**
 * Removes all tab elements from XUL document
 */
BaseTab.prototype.close = function()
{
	this.elements.forEach(function(val, idx)
	{
		val.parentNode.removeChild(val);
	});
}

/**
 * Updates tab appearance (sets text)
 * @param  {object} data key-value pairs of information
 * @param {string} data.name new title for tab
 */
BaseTab.prototype.update = function(data)
{
	this.setText(data.name);
	this.setTooltip(data.comment);
}

var baseTab = new BaseTab();

/**
 * Group tab constructor
 * @class GroupTab
 * @extends {BaseTab}
 * @param {GUID} id      guid of related group
 * @param {object} options key-value pairs of additional information
 */
var GroupTab = function(id, options, templates)
{
	this.init(templates, id, options);
	this.type = 'group';
	this.elements.forEach(function(val, idx)
	{
		val.addEventListener('drop', events.groupTabDrop);
	});
}
utils.extend(GroupTab.prototype, BaseTab.prototype);

GroupTab.prototype.update = function(data)
{
	this.setText(data.name);
	this.setTooltip(data.comment);
	if(data.isOpen())
	{
		this.elements.forEach(function(val, idx) {
			val.classList.add('oaff-open-tab');
		});
	}
	else
	{
		this.elements.forEach(function(val, idx) {
			val.classList.remove('oaff-open-tab');
		});
	}
}

/**
 * Page tab constructor
 * @class PageTab
 * @extends {BaseTab}
 * @param {GUID} id      guid of related page object
 * @param {object} options key-value pairs of additional data
 */
var PageTab = function(id, options, templates)
{
	this.init(templates, id, options);
	this.type = 'page';
	this.elements.forEach(function(val, idx)
	{
		/*var closeButton = val.querySelector('.close-icon');
		console.log("PT ", val);
		if(closeButton)
			closeButton.addEventListener('click', events.closeTabClick);*/
		val.addEventListener('drop', events.pageTabDrop);
	});
}
utils.extend(PageTab.prototype, BaseTab.prototype);

/**
 * Updates page tab (including door icon)
 * @override
 * @param  {BaseObject} data page object to get data from
 */
PageTab.prototype.update = function(data)
{
	this.setText(data.name);
	this.setTooltip(data.comment);
	if(data.isOpen())
	{
		this.elements.forEach(function(val, idx) {
			val.classList.add('oaff-open-tab');
		});
	}
	else
	{
		this.elements.forEach(function(val, idx) {
			val.classList.remove('oaff-open-tab');
		});
	}
	var link = Tabsmoz.getObject(data.link);
	if (link)
	{
		var icon = favicons.getFavicon(link.domain);
		this.elements.forEach(function(val, idx)
		{
			val.setAttribute('image', icon);
		}, this);
	}
}

var subpageCountdown = 0;

/**
 * Subpage tab constructor
 * @class SubpageTab
 * @extends {BaseTab}
 * @param {GUID} id      guid of related subpage object
 * @param {object} options key-value pairs of additional information
 */
var SubpageTab = function(id, options, templates)
{
	this.init(templates, id, options);
	this.type = 'subpage';
	this.local = options.local || false;
	this.node = options.node || null;
	if (options.canClose !== undefined)
		this.canClose = options.canClose;
	else
		this.canClose = true;
	this.setTab(options.nativeTab || null);
	this.url = options.url || null;
	this.raise();
}

utils.extend(SubpageTab.prototype, BaseTab.prototype);

/**
 * Assigns a native firefox tab to subpage
 * @param {Tab} tab native firefox browser tab
 */
SubpageTab.prototype.setTab = function(tab)
{
	if (tab)
	{
		this.nativeTab = tab;
		tab.setAttribute('tabsmoz-data', this.guid);
	}
}

SubpageTab.prototype.raise = function()
{
	this.countdown = subpageCountdown;
	subpageCountdown++;
}

/**
 * Opens native tab with url of subpage
 */
SubpageTab.prototype.openTab = function()
{
	if (!this.nativeTab)
	{
		Tabsmoz.swapBrowsers('web');
		debug && console.log("[TABS] subpage openTab", this.guid, this.url);
		debug && console.log("[T] Opening subpage: " + this.url);
		var url = this.url;
		if(xul.getManagementMode() == 'local')
			url = 'about:blank';
		var tab = gBrowser.addTab(url);
		this.setTab(tab);
		tab.setAttribute('tabsmoz-data', this.guid);
	}
}

/**
 * Highlights the tab, and opens native tab if necessary
 * @override
 */
SubpageTab.prototype.select = function()
{
	//var debug = true;
	this.selected = true;
	//console.log("[TABS] Selecting tab " + this.name, this.guid.substr(0, 5));
	this.elements.forEach(function(val, idx)
	{
		val.classList.add('oaff-tab-active');
		val._visuallySelected = true;
		if (val.parentNode.ensureElementIsVisible)
			val.parentNode.ensureElementIsVisible(val);
	})
	if (this.nativeTab && !xul.getSwitchHandleFlag())
	{
		var self = this;
		gBrowser.selectedTab = self.nativeTab;
		xul.setSwitchHandleFlag(true);
		this.raise();
	}
	search.hideSearchBox();
	if(this.local || xul.getManagementMode() == 'local')
	{
		//console.log("[TABS] Swapping to local, ", this.guid);
		if(this.node)
		{
			var node = Tabsmoz.getTree().getObject(this.node);
			// it's deleted!
			if(!node)
			{
				this.local = false;
				this.node = null;
				this.url = utils.getOAPage();
				this.nativeTab && gBrowser.getBrowserForTab(this.nativeTab).loadURI(this.url);
				Tabsmoz.swapBrowsers('web');
			} else {
				document.getElementById('urlbar').value = node.getFullPath().join('/');
				xul.showListViewNode(this.node, true);
				//Tabsmoz.swapBrowsers('local');
				if(node.type == 'search')
				{
					search.initSearch(this.guid);
				} 
			}
		}
		else
		{
			Tabsmoz.swapBrowsers('local');
		}
	} else {
		//console.log("[TABS] Swapping to web, ", this.guid);
		document.getElementById('urlbar').value = gBrowser.getBrowserForTab(this.nativeTab).currentURI.spec;
		Tabsmoz.swapBrowsers('web');
		if(this.url == 'about:blank' && this.node && this.nativeTab)
		{
			var node = Tabsmoz.getTree().getObject(this.node);
			if(node.url !== this.url)
			{
				gBrowser.getBrowserForTab(this.nativeTab).loadURI(node.url);
			}
		}
	}
}

/**
 * Removes tab itself and also closes native tab
 * @override
 */
SubpageTab.prototype.close = function()
{
	// it may already be removed
	this.elements.forEach(function(val, idx)
	{
		if (val.parentNode)
			val.parentNode.removeChild(val);
	});
	if (this.nativeTab)
	{
		debug && console.log("[TABS] Closing subpage");
		gBrowser.removeTab(this.nativeTab);
	}
}

/**
 * Injects script in native RSS pages and adds button
 * @param  {HTMLDocument} doc document element of rss page
 */
function modifyRss(doc)
{
	var text = "Create RSS link for this feed";
	var button = doc.createElement('button');
	button.innerHTML = 'Create';
	button.style.marginLeft = '2em';
	var p = doc.createElement('p');
	p.style.padding = '1em 2em 1em 2em';
	p.id = 'oaff-rss';
	p.innerHTML = text;
	p.appendChild(button);
	doc.getElementById('feedHeader').style.display = 'none';
	doc.getElementById('feedHeaderContainer').style.marginTop = '0';
	doc.getElementById('feedHeaderContainer').appendChild(p);
	var tree = Tabsmoz.getTree();
	button.addEventListener('click', function() {
		var url = doc.URL;
		//console.log("[RSS]", url);
		var link = tree.createLink({
			url: url,
			linkType: 'rss',
			name: doc.title
		}, true);
		Tabsmoz.showProperties(link, true);
	});
}

/**
 * Hides "When Firefox starts" entry in options
 * @param  {Tab} tab XUL tab object
 */
function checkAndHidePreferences(tab)
{
	if(!tab)
		return;
	var browser = gBrowser.getBrowserForTab(tab);
	if(browser && browser.currentURI.spec == 'about:preferences')
	{
		debug && console.log("[TABS] ORORO, PREFERENCES");
		var doc = browser.contentDocument;
		doc.getElementById("startupTable").children[0].style.display = 'none';
		//doc.getElementById("startupTable").children[1].style.display = 'none';
	}
	if(browser && browser.contentDocument && browser.contentDocument.documentElement && browser.contentDocument.documentElement.id == 'feedHandler')
	{
		if(!browser.contentWindow.oaffInjected) 
		{
			browser.contentWindow.oaffInjected = true;
			setTimeout(function() {
				debug && console.log("[TABS] RSS");
				modifyRss(browser.contentDocument);
			}, 400);
		}
	}
}

/**
 * Updates info for tab, maybe with url
 * @param  {object} data key-value pairs of properties to update
 */
SubpageTab.prototype.update = function(data, properties)
{
	var debug = false;
	debug && console.log("[TABS] Updating subpage " + data.label || this.name, this.guid.substr(0, 5));
	
	if((data.local | 0) != (this.local | 0))
	{
		debug && console.log("[TABS] Changing local to " + data.local, this.guid);
		this.local = data.local;
	}
	if(data.node)
		this.node = data.node;
	var browser;
	if (this.nativeTab)
	{
		setTimeout(function() { checkAndHidePreferences(this.nativeTab); }, 0);

		browser = gBrowser.getBrowserForTab(this.nativeTab);

		// catch the moment when user manually enters url when in management mode
		if(this.local && data.url && data.url.indexOf('about:blank') < 0)
		{
			debug && console.log("[TABS] Swapping to web due to url " + data.url, this.guid);
			search.hideSearchBox();
			this.local = false;
			Tabsmoz.swapBrowsers('web');
		}
	}
	if (this.nativeTab && data.urlUpdate && (xul.getManagementMode() == 'web'))
	{
		data.urlUpdate = false;
		// force reload tab (url is changed by our extension)
		if (browser.currentURI.spec !== data.url)
		{
			debug && console.log("[TABS] Changing url, yes-yes-yes " + browser.currentURI.spec + " => " + data.url, this.guid);
			this.url = data.url;
			browser.loadURI(this.url);
		}
	}
	else
		this.url = data.url;

	if(debug) this.elements.forEach(function(val, idx)
	{
		val.setAttribute('tooltiptext', this.guid);
	}, this);

	var image = this.nativeTab ? this.nativeTab.image : null;
	if( (this.local || xul.getManagementMode() == 'local') && this.node)
	{
		debug && console.log("[TABS] Showing list view " + this.guid.substr(0, 5));
		var node = Tabsmoz.getTree().getObject(this.node);
		if(this.selected)
		{
			xul.showListViewNode(this.node, true);
			document.getElementById('urlbar').value = node.getFullPath().join('/');
		}
		image = favicons.getFavicon('folder');
		if(node.type == 'search')
			image = favicons.getFavicon('search');
		if(node.linkType == 'rss')
			image = favicons.getFavicon('rss');
		if(node.linkType == 'curation')
			image = favicons.getFavicon('curation');
	}
	var local = this.local || xul.getManagementMode() == 'local';
	var text = local ? data.name : data.label;
	//console.log("[TABS] update " + local + " ; " + data.name + " ; " + data.label);
	text = debug ? '[' + this.countdown + ']' + text + ' ' + this.local : text;
	this.setText(text);
	if(this.nativeTab)
	{
		this.elements.forEach(function(val, idx)
		{
			val.setAttribute('image', image);
			val.setAttribute('tooltiptext', text);
		}, this);
	}
}

module.exports = {
	GroupTab: GroupTab,
	PageTab: PageTab,
	SubpageTab: SubpageTab
};

var events = require('./events.js'),
	favicons = require('../faviconmanager.js'),
	search = require('./search.js'),
	xul = require('./interface.js');
},{"../faviconmanager.js":3,"../utils.js":11,"./events.js":13,"./interface.js":14,"./search.js":16}]},{},[1]);
